# This file is automatically generated. Do not edit!
# To re-generated, execute res/wrap.jl

using CEnum

# CUBLAS uses CUDA runtime objects, which are compatible with our driver usage
const cudaStream_t = CUstream

# outlined functionality to avoid GC frame allocation
@noinline function throw_api_error(res)
    if res == CUBLAS_STATUS_ALLOC_FAILED
        throw(OutOfGPUMemoryError())
    else
        throw(CUBLASError(res))
    end
end

@inline function check(f)
    function retry_if(res)
        return res in (CUBLAS_STATUS_NOT_INITIALIZED,
                       CUBLAS_STATUS_ALLOC_FAILED,
                       CUBLAS_STATUS_INTERNAL_ERROR)
    end
    res = retry_reclaim(f, retry_if)

    if res != CUBLAS_STATUS_SUCCESS
        throw_api_error(res)
    end
end

mutable struct cublasContext end

const cublasHandle_t = Ptr{cublasContext}

@cenum cublasStatus_t::UInt32 begin
    CUBLAS_STATUS_SUCCESS = 0
    CUBLAS_STATUS_NOT_INITIALIZED = 1
    CUBLAS_STATUS_ALLOC_FAILED = 3
    CUBLAS_STATUS_INVALID_VALUE = 7
    CUBLAS_STATUS_ARCH_MISMATCH = 8
    CUBLAS_STATUS_MAPPING_ERROR = 11
    CUBLAS_STATUS_EXECUTION_FAILED = 13
    CUBLAS_STATUS_INTERNAL_ERROR = 14
    CUBLAS_STATUS_NOT_SUPPORTED = 15
    CUBLAS_STATUS_LICENSE_ERROR = 16
end

@checked function cublasCreate_v2(handle)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCreate_v2(handle::Ref{cublasHandle_t})::cublasStatus_t
end

@checked function cublasDestroy_v2(handle)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDestroy_v2(handle::cublasHandle_t)::cublasStatus_t
end

@checked function cublasGetVersion_v2(handle, version)
    @gcsafe_ccall libcublas.cublasGetVersion_v2(handle::cublasHandle_t,
                                                version::Ref{Cint})::cublasStatus_t
end

@checked function cublasSetWorkspace_v2(handle, workspace, workspaceSizeInBytes)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetWorkspace_v2(handle::cublasHandle_t,
                                                  workspace::CuPtr{Cvoid},
                                                  workspaceSizeInBytes::Csize_t)::cublasStatus_t
end

@checked function cublasSetStream_v2(handle, streamId)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetStream_v2(handle::cublasHandle_t,
                                               streamId::cudaStream_t)::cublasStatus_t
end

@checked function cublasGetStream_v2(handle, streamId)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetStream_v2(handle::cublasHandle_t,
                                               streamId::Ref{CUstream})::cublasStatus_t
end

@cenum cublasPointerMode_t::UInt32 begin
    CUBLAS_POINTER_MODE_HOST = 0
    CUBLAS_POINTER_MODE_DEVICE = 1
end

@checked function cublasGetPointerMode_v2(handle, mode)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetPointerMode_v2(handle::cublasHandle_t,
                                                    mode::Ref{cublasPointerMode_t})::cublasStatus_t
end

@checked function cublasSetPointerMode_v2(handle, mode)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetPointerMode_v2(handle::cublasHandle_t,
                                                    mode::cublasPointerMode_t)::cublasStatus_t
end

@checked function cublasSnrm2_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSnrm2_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cfloat}, incx::Cint,
                                           result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDnrm2_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDnrm2_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cdouble}, incx::Cint,
                                           result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasScnrm2_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasScnrm2_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{cuComplex}, incx::Cint,
                                            result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDznrm2_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDznrm2_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{cuDoubleComplex}, incx::Cint,
                                            result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasSdot_v2(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSdot_v2(handle::cublasHandle_t, n::Cint, x::CuPtr{Cfloat},
                                          incx::Cint, y::CuPtr{Cfloat}, incy::Cint,
                                          result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDdot_v2(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDdot_v2(handle::cublasHandle_t, n::Cint,
                                          x::CuPtr{Cdouble}, incx::Cint, y::CuPtr{Cdouble},
                                          incy::Cint,
                                          result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasCdotu_v2(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCdotu_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint,
                                           result::RefOrCuRef{cuComplex})::cublasStatus_t
end

@checked function cublasCdotc_v2(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCdotc_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint,
                                           result::RefOrCuRef{cuComplex})::cublasStatus_t
end

@checked function cublasZdotu_v2(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdotu_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex}, incy::Cint,
                                           result::RefOrCuRef{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasZdotc_v2(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdotc_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex}, incy::Cint,
                                           result::RefOrCuRef{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasSscal_v2(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSscal_v2(handle::cublasHandle_t, n::Cint,
                                           alpha::RefOrCuRef{Cfloat}, x::CuPtr{Cfloat},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasDscal_v2(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDscal_v2(handle::cublasHandle_t, n::Cint,
                                           alpha::RefOrCuRef{Cdouble}, x::CuPtr{Cdouble},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasCscal_v2(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCscal_v2(handle::cublasHandle_t, n::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           x::CuPtr{cuComplex}, incx::Cint)::cublasStatus_t
end

@checked function cublasCsscal_v2(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsscal_v2(handle::cublasHandle_t, n::Cint,
                                            alpha::RefOrCuRef{Cfloat}, x::CuPtr{cuComplex},
                                            incx::Cint)::cublasStatus_t
end

@checked function cublasZscal_v2(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZscal_v2(handle::cublasHandle_t, n::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasZdscal_v2(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdscal_v2(handle::cublasHandle_t, n::Cint,
                                            alpha::RefOrCuRef{Cdouble},
                                            x::CuPtr{cuDoubleComplex},
                                            incx::Cint)::cublasStatus_t
end

@checked function cublasSaxpy_v2(handle, n, alpha, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSaxpy_v2(handle::cublasHandle_t, n::Cint,
                                           alpha::RefOrCuRef{Cfloat}, x::CuPtr{Cfloat},
                                           incx::Cint, y::CuPtr{Cfloat},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasDaxpy_v2(handle, n, alpha, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDaxpy_v2(handle::cublasHandle_t, n::Cint,
                                           alpha::RefOrCuRef{Cdouble}, x::CuPtr{Cdouble},
                                           incx::Cint, y::CuPtr{Cdouble},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasCaxpy_v2(handle, n, alpha, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCaxpy_v2(handle::cublasHandle_t, n::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint)::cublasStatus_t
end

@checked function cublasZaxpy_v2(handle, n, alpha, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZaxpy_v2(handle::cublasHandle_t, n::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasScopy_v2(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasScopy_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cfloat}, incx::Cint, y::CuPtr{Cfloat},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasDcopy_v2(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDcopy_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cdouble}, incx::Cint, y::CuPtr{Cdouble},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasCcopy_v2(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCcopy_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint)::cublasStatus_t
end

@checked function cublasZcopy_v2(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZcopy_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasSswap_v2(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSswap_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cfloat}, incx::Cint, y::CuPtr{Cfloat},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasDswap_v2(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDswap_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cdouble}, incx::Cint, y::CuPtr{Cdouble},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasCswap_v2(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCswap_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint)::cublasStatus_t
end

@checked function cublasZswap_v2(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZswap_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasIsamax_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIsamax_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{Cfloat}, incx::Cint,
                                            result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasIdamax_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIdamax_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{Cdouble}, incx::Cint,
                                            result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasIcamax_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIcamax_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{cuComplex}, incx::Cint,
                                            result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasIzamax_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIzamax_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{cuDoubleComplex}, incx::Cint,
                                            result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasIsamin_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIsamin_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{Cfloat}, incx::Cint,
                                            result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasIdamin_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIdamin_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{Cdouble}, incx::Cint,
                                            result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasIcamin_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIcamin_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{cuComplex}, incx::Cint,
                                            result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasIzamin_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIzamin_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{cuDoubleComplex}, incx::Cint,
                                            result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasSasum_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSasum_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cfloat}, incx::Cint,
                                           result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDasum_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDasum_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cdouble}, incx::Cint,
                                           result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasScasum_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasScasum_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{cuComplex}, incx::Cint,
                                            result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDzasum_v2(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDzasum_v2(handle::cublasHandle_t, n::Cint,
                                            x::CuPtr{cuDoubleComplex}, incx::Cint,
                                            result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasSrot_v2(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSrot_v2(handle::cublasHandle_t, n::Cint, x::CuPtr{Cfloat},
                                          incx::Cint, y::CuPtr{Cfloat}, incy::Cint,
                                          c::RefOrCuRef{Cfloat},
                                          s::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDrot_v2(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDrot_v2(handle::cublasHandle_t, n::Cint,
                                          x::CuPtr{Cdouble}, incx::Cint, y::CuPtr{Cdouble},
                                          incy::Cint, c::RefOrCuRef{Cdouble},
                                          s::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasCrot_v2(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCrot_v2(handle::cublasHandle_t, n::Cint,
                                          x::CuPtr{cuComplex}, incx::Cint,
                                          y::CuPtr{cuComplex}, incy::Cint,
                                          c::RefOrCuRef{Cfloat},
                                          s::RefOrCuRef{cuComplex})::cublasStatus_t
end

@checked function cublasCsrot_v2(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsrot_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint,
                                           c::RefOrCuRef{Cfloat},
                                           s::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasZrot_v2(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZrot_v2(handle::cublasHandle_t, n::Cint,
                                          x::CuPtr{cuDoubleComplex}, incx::Cint,
                                          y::CuPtr{cuDoubleComplex}, incy::Cint,
                                          c::RefOrCuRef{Cdouble},
                                          s::RefOrCuRef{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasZdrot_v2(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdrot_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex}, incy::Cint,
                                           c::RefOrCuRef{Cdouble},
                                           s::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasSrotg_v2(handle, a, b, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSrotg_v2(handle::cublasHandle_t, a::RefOrCuRef{Cfloat},
                                           b::RefOrCuRef{Cfloat}, c::PtrOrCuPtr{Cfloat},
                                           s::PtrOrCuPtr{Cfloat})::cublasStatus_t
end

@checked function cublasDrotg_v2(handle, a, b, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDrotg_v2(handle::cublasHandle_t, a::RefOrCuRef{Cdouble},
                                           b::RefOrCuRef{Cdouble}, c::PtrOrCuPtr{Cdouble},
                                           s::PtrOrCuPtr{Cdouble})::cublasStatus_t
end

@checked function cublasCrotg_v2(handle, a, b, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCrotg_v2(handle::cublasHandle_t, a::RefOrCuRef{cuComplex},
                                           b::RefOrCuRef{cuComplex}, c::PtrOrCuPtr{Cfloat},
                                           s::PtrOrCuPtr{cuComplex})::cublasStatus_t
end

@checked function cublasZrotg_v2(handle, a, b, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZrotg_v2(handle::cublasHandle_t,
                                           a::RefOrCuRef{cuDoubleComplex},
                                           b::RefOrCuRef{cuDoubleComplex},
                                           c::PtrOrCuPtr{Cdouble},
                                           s::PtrOrCuPtr{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasSrotm_v2(handle, n, x, incx, y, incy, param)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSrotm_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cfloat}, incx::Cint, y::CuPtr{Cfloat},
                                           incy::Cint,
                                           param::PtrOrCuPtr{Cfloat})::cublasStatus_t
end

@checked function cublasDrotm_v2(handle, n, x, incx, y, incy, param)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDrotm_v2(handle::cublasHandle_t, n::Cint,
                                           x::CuPtr{Cdouble}, incx::Cint, y::CuPtr{Cdouble},
                                           incy::Cint,
                                           param::PtrOrCuPtr{Cdouble})::cublasStatus_t
end

@checked function cublasSrotmg_v2(handle, d1, d2, x1, y1, param)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSrotmg_v2(handle::cublasHandle_t, d1::RefOrCuRef{Cfloat},
                                            d2::RefOrCuRef{Cfloat}, x1::RefOrCuRef{Cfloat},
                                            y1::RefOrCuRef{Cfloat},
                                            param::PtrOrCuPtr{Cfloat})::cublasStatus_t
end

@checked function cublasDrotmg_v2(handle, d1, d2, x1, y1, param)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDrotmg_v2(handle::cublasHandle_t, d1::RefOrCuRef{Cdouble},
                                            d2::RefOrCuRef{Cdouble},
                                            x1::RefOrCuRef{Cdouble},
                                            y1::RefOrCuRef{Cdouble},
                                            param::PtrOrCuPtr{Cdouble})::cublasStatus_t
end

@cenum cublasOperation_t::UInt32 begin
    CUBLAS_OP_N = 0
    CUBLAS_OP_T = 1
    CUBLAS_OP_C = 2
    CUBLAS_OP_HERMITAN = 2
    CUBLAS_OP_CONJG = 3
end

@checked function cublasSgemv_v2(handle, trans, m, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemv_v2(handle::cublasHandle_t, trans::cublasOperation_t,
                                           m::Cint, n::Cint, alpha::RefOrCuRef{Cfloat},
                                           A::CuPtr{Cfloat}, lda::Cint, x::CuPtr{Cfloat},
                                           incx::Cint, beta::RefOrCuRef{Cfloat},
                                           y::CuPtr{Cfloat}, incy::Cint)::cublasStatus_t
end

@checked function cublasDgemv_v2(handle, trans, m, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemv_v2(handle::cublasHandle_t, trans::cublasOperation_t,
                                           m::Cint, n::Cint, alpha::RefOrCuRef{Cdouble},
                                           A::CuPtr{Cdouble}, lda::Cint, x::CuPtr{Cdouble},
                                           incx::Cint, beta::RefOrCuRef{Cdouble},
                                           y::CuPtr{Cdouble}, incy::Cint)::cublasStatus_t
end

@checked function cublasCgemv_v2(handle, trans, m, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemv_v2(handle::cublasHandle_t, trans::cublasOperation_t,
                                           m::Cint, n::Cint, alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuComplex}, y::CuPtr{cuComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasZgemv_v2(handle, trans, m, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemv_v2(handle::cublasHandle_t, trans::cublasOperation_t,
                                           m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           y::CuPtr{cuDoubleComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasSgbmv_v2(handle, trans, m, n, kl, ku, alpha, A, lda, x, incx, beta,
                                 y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgbmv_v2(handle::cublasHandle_t, trans::cublasOperation_t,
                                           m::Cint, n::Cint, kl::Cint, ku::Cint,
                                           alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                           lda::Cint, x::CuPtr{Cfloat}, incx::Cint,
                                           beta::RefOrCuRef{Cfloat}, y::CuPtr{Cfloat},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasDgbmv_v2(handle, trans, m, n, kl, ku, alpha, A, lda, x, incx, beta,
                                 y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgbmv_v2(handle::cublasHandle_t, trans::cublasOperation_t,
                                           m::Cint, n::Cint, kl::Cint, ku::Cint,
                                           alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                           lda::Cint, x::CuPtr{Cdouble}, incx::Cint,
                                           beta::RefOrCuRef{Cdouble}, y::CuPtr{Cdouble},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasCgbmv_v2(handle, trans, m, n, kl, ku, alpha, A, lda, x, incx, beta,
                                 y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgbmv_v2(handle::cublasHandle_t, trans::cublasOperation_t,
                                           m::Cint, n::Cint, kl::Cint, ku::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuComplex}, y::CuPtr{cuComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasZgbmv_v2(handle, trans, m, n, kl, ku, alpha, A, lda, x, incx, beta,
                                 y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgbmv_v2(handle::cublasHandle_t, trans::cublasOperation_t,
                                           m::Cint, n::Cint, kl::Cint, ku::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           y::CuPtr{cuDoubleComplex},
                                           incy::Cint)::cublasStatus_t
end

@cenum cublasFillMode_t::UInt32 begin
    CUBLAS_FILL_MODE_LOWER = 0
    CUBLAS_FILL_MODE_UPPER = 1
    CUBLAS_FILL_MODE_FULL = 2
end

@cenum cublasDiagType_t::UInt32 begin
    CUBLAS_DIAG_NON_UNIT = 0
    CUBLAS_DIAG_UNIT = 1
end

@checked function cublasStrmv_v2(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, A::CuPtr{Cfloat}, lda::Cint,
                                           x::CuPtr{Cfloat}, incx::Cint)::cublasStatus_t
end

@checked function cublasDtrmv_v2(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, A::CuPtr{Cdouble}, lda::Cint,
                                           x::CuPtr{Cdouble}, incx::Cint)::cublasStatus_t
end

@checked function cublasCtrmv_v2(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, A::CuPtr{cuComplex}, lda::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint)::cublasStatus_t
end

@checked function cublasZtrmv_v2(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           x::CuPtr{cuDoubleComplex},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasStbmv_v2(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStbmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, k::Cint, A::CuPtr{Cfloat}, lda::Cint,
                                           x::CuPtr{Cfloat}, incx::Cint)::cublasStatus_t
end

@checked function cublasDtbmv_v2(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtbmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, k::Cint, A::CuPtr{Cdouble}, lda::Cint,
                                           x::CuPtr{Cdouble}, incx::Cint)::cublasStatus_t
end

@checked function cublasCtbmv_v2(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtbmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, k::Cint, A::CuPtr{cuComplex}, lda::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint)::cublasStatus_t
end

@checked function cublasZtbmv_v2(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtbmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, k::Cint, A::CuPtr{cuDoubleComplex},
                                           lda::Cint, x::CuPtr{cuDoubleComplex},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasStpmv_v2(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStpmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, AP::CuPtr{Cfloat}, x::CuPtr{Cfloat},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasDtpmv_v2(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtpmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, AP::CuPtr{Cdouble}, x::CuPtr{Cdouble},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasCtpmv_v2(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtpmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, AP::CuPtr{cuComplex},
                                           x::CuPtr{cuComplex}, incx::Cint)::cublasStatus_t
end

@checked function cublasZtpmv_v2(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtpmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, AP::CuPtr{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasStrsv_v2(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, A::CuPtr{Cfloat}, lda::Cint,
                                           x::CuPtr{Cfloat}, incx::Cint)::cublasStatus_t
end

@checked function cublasDtrsv_v2(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, A::CuPtr{Cdouble}, lda::Cint,
                                           x::CuPtr{Cdouble}, incx::Cint)::cublasStatus_t
end

@checked function cublasCtrsv_v2(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, A::CuPtr{cuComplex}, lda::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint)::cublasStatus_t
end

@checked function cublasZtrsv_v2(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           x::CuPtr{cuDoubleComplex},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasStpsv_v2(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStpsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, AP::CuPtr{Cfloat}, x::CuPtr{Cfloat},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasDtpsv_v2(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtpsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, AP::CuPtr{Cdouble}, x::CuPtr{Cdouble},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasCtpsv_v2(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtpsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, AP::CuPtr{cuComplex},
                                           x::CuPtr{cuComplex}, incx::Cint)::cublasStatus_t
end

@checked function cublasZtpsv_v2(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtpsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, AP::CuPtr{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasStbsv_v2(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStbsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, k::Cint, A::CuPtr{Cfloat}, lda::Cint,
                                           x::CuPtr{Cfloat}, incx::Cint)::cublasStatus_t
end

@checked function cublasDtbsv_v2(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtbsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, k::Cint, A::CuPtr{Cdouble}, lda::Cint,
                                           x::CuPtr{Cdouble}, incx::Cint)::cublasStatus_t
end

@checked function cublasCtbsv_v2(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtbsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, k::Cint, A::CuPtr{cuComplex}, lda::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint)::cublasStatus_t
end

@checked function cublasZtbsv_v2(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtbsv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, diag::cublasDiagType_t,
                                           n::Cint, k::Cint, A::CuPtr{cuDoubleComplex},
                                           lda::Cint, x::CuPtr{cuDoubleComplex},
                                           incx::Cint)::cublasStatus_t
end

@checked function cublasSsymv_v2(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsymv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{Cfloat},
                                           A::CuPtr{Cfloat}, lda::Cint, x::CuPtr{Cfloat},
                                           incx::Cint, beta::RefOrCuRef{Cfloat},
                                           y::CuPtr{Cfloat}, incy::Cint)::cublasStatus_t
end

@checked function cublasDsymv_v2(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsymv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{Cdouble},
                                           A::CuPtr{Cdouble}, lda::Cint, x::CuPtr{Cdouble},
                                           incx::Cint, beta::RefOrCuRef{Cdouble},
                                           y::CuPtr{Cdouble}, incy::Cint)::cublasStatus_t
end

@checked function cublasCsymv_v2(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsymv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuComplex}, y::CuPtr{cuComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasZsymv_v2(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsymv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           y::CuPtr{cuDoubleComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasChemv_v2(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChemv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuComplex}, y::CuPtr{cuComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasZhemv_v2(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhemv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           y::CuPtr{cuDoubleComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasSsbmv_v2(handle, uplo, n, k, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsbmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, k::Cint, alpha::RefOrCuRef{Cfloat},
                                           A::CuPtr{Cfloat}, lda::Cint, x::CuPtr{Cfloat},
                                           incx::Cint, beta::RefOrCuRef{Cfloat},
                                           y::CuPtr{Cfloat}, incy::Cint)::cublasStatus_t
end

@checked function cublasDsbmv_v2(handle, uplo, n, k, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsbmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, k::Cint, alpha::RefOrCuRef{Cdouble},
                                           A::CuPtr{Cdouble}, lda::Cint, x::CuPtr{Cdouble},
                                           incx::Cint, beta::RefOrCuRef{Cdouble},
                                           y::CuPtr{Cdouble}, incy::Cint)::cublasStatus_t
end

@checked function cublasChbmv_v2(handle, uplo, n, k, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChbmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, k::Cint, alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuComplex}, y::CuPtr{cuComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasZhbmv_v2(handle, uplo, n, k, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhbmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, k::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           y::CuPtr{cuDoubleComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasSspmv_v2(handle, uplo, n, alpha, AP, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSspmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{Cfloat},
                                           AP::CuPtr{Cfloat}, x::CuPtr{Cfloat}, incx::Cint,
                                           beta::RefOrCuRef{Cfloat}, y::CuPtr{Cfloat},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasDspmv_v2(handle, uplo, n, alpha, AP, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDspmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{Cdouble},
                                           AP::CuPtr{Cdouble}, x::CuPtr{Cdouble},
                                           incx::Cint, beta::RefOrCuRef{Cdouble},
                                           y::CuPtr{Cdouble}, incy::Cint)::cublasStatus_t
end

@checked function cublasChpmv_v2(handle, uplo, n, alpha, AP, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChpmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuComplex},
                                           AP::CuPtr{cuComplex}, x::CuPtr{cuComplex},
                                           incx::Cint, beta::RefOrCuRef{cuComplex},
                                           y::CuPtr{cuComplex}, incy::Cint)::cublasStatus_t
end

@checked function cublasZhpmv_v2(handle, uplo, n, alpha, AP, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhpmv_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                           AP::CuPtr{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           y::CuPtr{cuDoubleComplex},
                                           incy::Cint)::cublasStatus_t
end

@checked function cublasSger_v2(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSger_v2(handle::cublasHandle_t, m::Cint, n::Cint,
                                          alpha::RefOrCuRef{Cfloat}, x::CuPtr{Cfloat},
                                          incx::Cint, y::CuPtr{Cfloat}, incy::Cint,
                                          A::CuPtr{Cfloat}, lda::Cint)::cublasStatus_t
end

@checked function cublasDger_v2(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDger_v2(handle::cublasHandle_t, m::Cint, n::Cint,
                                          alpha::RefOrCuRef{Cdouble}, x::CuPtr{Cdouble},
                                          incx::Cint, y::CuPtr{Cdouble}, incy::Cint,
                                          A::CuPtr{Cdouble}, lda::Cint)::cublasStatus_t
end

@checked function cublasCgeru_v2(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgeru_v2(handle::cublasHandle_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint,
                                           A::CuPtr{cuComplex}, lda::Cint)::cublasStatus_t
end

@checked function cublasCgerc_v2(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgerc_v2(handle::cublasHandle_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint,
                                           A::CuPtr{cuComplex}, lda::Cint)::cublasStatus_t
end

@checked function cublasZgeru_v2(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgeru_v2(handle::cublasHandle_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex}, incy::Cint,
                                           A::CuPtr{cuDoubleComplex},
                                           lda::Cint)::cublasStatus_t
end

@checked function cublasZgerc_v2(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgerc_v2(handle::cublasHandle_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex}, incy::Cint,
                                           A::CuPtr{cuDoubleComplex},
                                           lda::Cint)::cublasStatus_t
end

@checked function cublasSsyr_v2(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyr_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{Cfloat},
                                          x::CuPtr{Cfloat}, incx::Cint, A::CuPtr{Cfloat},
                                          lda::Cint)::cublasStatus_t
end

@checked function cublasDsyr_v2(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyr_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{Cdouble},
                                          x::CuPtr{Cdouble}, incx::Cint, A::CuPtr{Cdouble},
                                          lda::Cint)::cublasStatus_t
end

@checked function cublasCsyr_v2(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyr_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{cuComplex},
                                          x::CuPtr{cuComplex}, incx::Cint,
                                          A::CuPtr{cuComplex}, lda::Cint)::cublasStatus_t
end

@checked function cublasZsyr_v2(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyr_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                          x::CuPtr{cuDoubleComplex}, incx::Cint,
                                          A::CuPtr{cuDoubleComplex},
                                          lda::Cint)::cublasStatus_t
end

@checked function cublasCher_v2(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCher_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{Cfloat},
                                          x::CuPtr{cuComplex}, incx::Cint,
                                          A::CuPtr{cuComplex}, lda::Cint)::cublasStatus_t
end

@checked function cublasZher_v2(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZher_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{Cdouble},
                                          x::CuPtr{cuDoubleComplex}, incx::Cint,
                                          A::CuPtr{cuDoubleComplex},
                                          lda::Cint)::cublasStatus_t
end

@checked function cublasSspr_v2(handle, uplo, n, alpha, x, incx, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSspr_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{Cfloat},
                                          x::CuPtr{Cfloat}, incx::Cint,
                                          AP::CuPtr{Cfloat})::cublasStatus_t
end

@checked function cublasDspr_v2(handle, uplo, n, alpha, x, incx, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDspr_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{Cdouble},
                                          x::CuPtr{Cdouble}, incx::Cint,
                                          AP::CuPtr{Cdouble})::cublasStatus_t
end

@checked function cublasChpr_v2(handle, uplo, n, alpha, x, incx, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChpr_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{Cfloat},
                                          x::CuPtr{cuComplex}, incx::Cint,
                                          AP::CuPtr{cuComplex})::cublasStatus_t
end

@checked function cublasZhpr_v2(handle, uplo, n, alpha, x, incx, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhpr_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          n::Cint, alpha::RefOrCuRef{Cdouble},
                                          x::CuPtr{cuDoubleComplex}, incx::Cint,
                                          AP::CuPtr{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasSsyr2_v2(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyr2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{Cfloat},
                                           x::CuPtr{Cfloat}, incx::Cint, y::CuPtr{Cfloat},
                                           incy::Cint, A::CuPtr{Cfloat},
                                           lda::Cint)::cublasStatus_t
end

@checked function cublasDsyr2_v2(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyr2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{Cdouble},
                                           x::CuPtr{Cdouble}, incx::Cint, y::CuPtr{Cdouble},
                                           incy::Cint, A::CuPtr{Cdouble},
                                           lda::Cint)::cublasStatus_t
end

@checked function cublasCsyr2_v2(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyr2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuComplex},
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint,
                                           A::CuPtr{cuComplex}, lda::Cint)::cublasStatus_t
end

@checked function cublasZsyr2_v2(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyr2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex}, incy::Cint,
                                           A::CuPtr{cuDoubleComplex},
                                           lda::Cint)::cublasStatus_t
end

@checked function cublasCher2_v2(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCher2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuComplex},
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint,
                                           A::CuPtr{cuComplex}, lda::Cint)::cublasStatus_t
end

@checked function cublasZher2_v2(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZher2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex}, incy::Cint,
                                           A::CuPtr{cuDoubleComplex},
                                           lda::Cint)::cublasStatus_t
end

@checked function cublasSspr2_v2(handle, uplo, n, alpha, x, incx, y, incy, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSspr2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{Cfloat},
                                           x::CuPtr{Cfloat}, incx::Cint, y::CuPtr{Cfloat},
                                           incy::Cint, AP::CuPtr{Cfloat})::cublasStatus_t
end

@checked function cublasDspr2_v2(handle, uplo, n, alpha, x, incx, y, incy, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDspr2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{Cdouble},
                                           x::CuPtr{Cdouble}, incx::Cint, y::CuPtr{Cdouble},
                                           incy::Cint, AP::CuPtr{Cdouble})::cublasStatus_t
end

@checked function cublasChpr2_v2(handle, uplo, n, alpha, x, incx, y, incy, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChpr2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuComplex},
                                           x::CuPtr{cuComplex}, incx::Cint,
                                           y::CuPtr{cuComplex}, incy::Cint,
                                           AP::CuPtr{cuComplex})::cublasStatus_t
end

@checked function cublasZhpr2_v2(handle, uplo, n, alpha, x, incx, y, incy, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhpr2_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           n::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                           x::CuPtr{cuDoubleComplex}, incx::Cint,
                                           y::CuPtr{cuDoubleComplex}, incy::Cint,
                                           AP::CuPtr{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasSgemm_v2(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                 beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemm_v2(handle::cublasHandle_t,
                                           transa::cublasOperation_t,
                                           transb::cublasOperation_t, m::Cint, n::Cint,
                                           k::Cint, alpha::RefOrCuRef{Cfloat},
                                           A::CuPtr{Cfloat}, lda::Cint, B::CuPtr{Cfloat},
                                           ldb::Cint, beta::RefOrCuRef{Cfloat},
                                           C::CuPtr{Cfloat}, ldc::Cint)::cublasStatus_t
end

@checked function cublasDgemm_v2(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                 beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemm_v2(handle::cublasHandle_t,
                                           transa::cublasOperation_t,
                                           transb::cublasOperation_t, m::Cint, n::Cint,
                                           k::Cint, alpha::RefOrCuRef{Cdouble},
                                           A::CuPtr{Cdouble}, lda::Cint, B::CuPtr{Cdouble},
                                           ldb::Cint, beta::RefOrCuRef{Cdouble},
                                           C::CuPtr{Cdouble}, ldc::Cint)::cublasStatus_t
end

@checked function cublasCgemm_v2(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                 beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm_v2(handle::cublasHandle_t,
                                           transa::cublasOperation_t,
                                           transb::cublasOperation_t, m::Cint, n::Cint,
                                           k::Cint, alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           B::CuPtr{cuComplex}, ldb::Cint,
                                           beta::RefOrCuRef{cuComplex}, C::CuPtr{cuComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasZgemm_v2(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                 beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemm_v2(handle::cublasHandle_t,
                                           transa::cublasOperation_t,
                                           transb::cublasOperation_t, m::Cint, n::Cint,
                                           k::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           C::CuPtr{cuDoubleComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasSsyrk_v2(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyrk_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Cint, k::Cint,
                                           alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                           lda::Cint, beta::RefOrCuRef{Cfloat},
                                           C::CuPtr{Cfloat}, ldc::Cint)::cublasStatus_t
end

@checked function cublasDsyrk_v2(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyrk_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Cint, k::Cint,
                                           alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                           lda::Cint, beta::RefOrCuRef{Cdouble},
                                           C::CuPtr{Cdouble}, ldc::Cint)::cublasStatus_t
end

@checked function cublasCsyrk_v2(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyrk_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Cint, k::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           beta::RefOrCuRef{cuComplex}, C::CuPtr{cuComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasZsyrk_v2(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyrk_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Cint, k::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           C::CuPtr{cuDoubleComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasCherk_v2(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCherk_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Cint, k::Cint,
                                           alpha::RefOrCuRef{Cfloat}, A::CuPtr{cuComplex},
                                           lda::Cint, beta::RefOrCuRef{Cfloat},
                                           C::CuPtr{cuComplex}, ldc::Cint)::cublasStatus_t
end

@checked function cublasZherk_v2(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZherk_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Cint, k::Cint,
                                           alpha::RefOrCuRef{Cdouble},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           beta::RefOrCuRef{Cdouble},
                                           C::CuPtr{cuDoubleComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasSsyr2k_v2(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyr2k_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Cint, k::Cint,
                                            alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                            lda::Cint, B::CuPtr{Cfloat}, ldb::Cint,
                                            beta::RefOrCuRef{Cfloat}, C::CuPtr{Cfloat},
                                            ldc::Cint)::cublasStatus_t
end

@checked function cublasDsyr2k_v2(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyr2k_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Cint, k::Cint,
                                            alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                            lda::Cint, B::CuPtr{Cdouble}, ldb::Cint,
                                            beta::RefOrCuRef{Cdouble}, C::CuPtr{Cdouble},
                                            ldc::Cint)::cublasStatus_t
end

@checked function cublasCsyr2k_v2(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyr2k_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Cint, k::Cint,
                                            alpha::RefOrCuRef{cuComplex},
                                            A::CuPtr{cuComplex}, lda::Cint,
                                            B::CuPtr{cuComplex}, ldb::Cint,
                                            beta::RefOrCuRef{cuComplex},
                                            C::CuPtr{cuComplex}, ldc::Cint)::cublasStatus_t
end

@checked function cublasZsyr2k_v2(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyr2k_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Cint, k::Cint,
                                            alpha::RefOrCuRef{cuDoubleComplex},
                                            A::CuPtr{cuDoubleComplex}, lda::Cint,
                                            B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                            beta::RefOrCuRef{cuDoubleComplex},
                                            C::CuPtr{cuDoubleComplex},
                                            ldc::Cint)::cublasStatus_t
end

@checked function cublasCher2k_v2(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCher2k_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Cint, k::Cint,
                                            alpha::RefOrCuRef{cuComplex},
                                            A::CuPtr{cuComplex}, lda::Cint,
                                            B::CuPtr{cuComplex}, ldb::Cint,
                                            beta::RefOrCuRef{Cfloat}, C::CuPtr{cuComplex},
                                            ldc::Cint)::cublasStatus_t
end

@checked function cublasZher2k_v2(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZher2k_v2(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Cint, k::Cint,
                                            alpha::RefOrCuRef{cuDoubleComplex},
                                            A::CuPtr{cuDoubleComplex}, lda::Cint,
                                            B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                            beta::RefOrCuRef{Cdouble},
                                            C::CuPtr{cuDoubleComplex},
                                            ldc::Cint)::cublasStatus_t
end

@cenum cublasSideMode_t::UInt32 begin
    CUBLAS_SIDE_LEFT = 0
    CUBLAS_SIDE_RIGHT = 1
end

@checked function cublasSsymm_v2(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsymm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                           lda::Cint, B::CuPtr{Cfloat}, ldb::Cint,
                                           beta::RefOrCuRef{Cfloat}, C::CuPtr{Cfloat},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasDsymm_v2(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsymm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                           lda::Cint, B::CuPtr{Cdouble}, ldb::Cint,
                                           beta::RefOrCuRef{Cdouble}, C::CuPtr{Cdouble},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasCsymm_v2(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsymm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           B::CuPtr{cuComplex}, ldb::Cint,
                                           beta::RefOrCuRef{cuComplex}, C::CuPtr{cuComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasZsymm_v2(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsymm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           C::CuPtr{cuDoubleComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasChemm_v2(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChemm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           B::CuPtr{cuComplex}, ldb::Cint,
                                           beta::RefOrCuRef{cuComplex}, C::CuPtr{cuComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasZhemm_v2(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhemm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           C::CuPtr{cuDoubleComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasStrsm_v2(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                 ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrsm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, trans::cublasOperation_t,
                                           diag::cublasDiagType_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                           lda::Cint, B::CuPtr{Cfloat},
                                           ldb::Cint)::cublasStatus_t
end

@checked function cublasDtrsm_v2(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                 ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrsm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, trans::cublasOperation_t,
                                           diag::cublasDiagType_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                           lda::Cint, B::CuPtr{Cdouble},
                                           ldb::Cint)::cublasStatus_t
end

@checked function cublasCtrsm_v2(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                 ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrsm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, trans::cublasOperation_t,
                                           diag::cublasDiagType_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           B::CuPtr{cuComplex}, ldb::Cint)::cublasStatus_t
end

@checked function cublasZtrsm_v2(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                 ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrsm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, trans::cublasOperation_t,
                                           diag::cublasDiagType_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           B::CuPtr{cuDoubleComplex},
                                           ldb::Cint)::cublasStatus_t
end

@checked function cublasStrmm_v2(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                 ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrmm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, trans::cublasOperation_t,
                                           diag::cublasDiagType_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                           lda::Cint, B::CuPtr{Cfloat}, ldb::Cint,
                                           C::CuPtr{Cfloat}, ldc::Cint)::cublasStatus_t
end

@checked function cublasDtrmm_v2(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                 ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrmm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, trans::cublasOperation_t,
                                           diag::cublasDiagType_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                           lda::Cint, B::CuPtr{Cdouble}, ldb::Cint,
                                           C::CuPtr{Cdouble}, ldc::Cint)::cublasStatus_t
end

@checked function cublasCtrmm_v2(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                 ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrmm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, trans::cublasOperation_t,
                                           diag::cublasDiagType_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Cint,
                                           B::CuPtr{cuComplex}, ldb::Cint,
                                           C::CuPtr{cuComplex}, ldc::Cint)::cublasStatus_t
end

@checked function cublasZtrmm_v2(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                 ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrmm_v2(handle::cublasHandle_t, side::cublasSideMode_t,
                                           uplo::cublasFillMode_t, trans::cublasOperation_t,
                                           diag::cublasDiagType_t, m::Cint, n::Cint,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Cint,
                                           B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                           C::CuPtr{cuDoubleComplex},
                                           ldc::Cint)::cublasStatus_t
end

@checked function cublasSnrm2_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSnrm2_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cfloat}, incx::Int64,
                                              result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDnrm2_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDnrm2_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cdouble}, incx::Int64,
                                              result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasScnrm2_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasScnrm2_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{cuComplex}, incx::Int64,
                                               result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDznrm2_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDznrm2_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{cuDoubleComplex}, incx::Int64,
                                               result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasSdot_v2_64(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSdot_v2_64(handle::cublasHandle_t, n::Int64,
                                             x::CuPtr{Cfloat}, incx::Int64,
                                             y::CuPtr{Cfloat}, incy::Int64,
                                             result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDdot_v2_64(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDdot_v2_64(handle::cublasHandle_t, n::Int64,
                                             x::CuPtr{Cdouble}, incx::Int64,
                                             y::CuPtr{Cdouble}, incy::Int64,
                                             result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasCdotu_v2_64(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCdotu_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex}, incy::Int64,
                                              result::RefOrCuRef{cuComplex})::cublasStatus_t
end

@checked function cublasCdotc_v2_64(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCdotc_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex}, incy::Int64,
                                              result::RefOrCuRef{cuComplex})::cublasStatus_t
end

@checked function cublasZdotu_v2_64(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdotu_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex}, incy::Int64,
                                              result::RefOrCuRef{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasZdotc_v2_64(handle, n, x, incx, y, incy, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdotc_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex}, incy::Int64,
                                              result::RefOrCuRef{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasSscal_v2_64(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSscal_v2_64(handle::cublasHandle_t, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, x::CuPtr{Cfloat},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasDscal_v2_64(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDscal_v2_64(handle::cublasHandle_t, n::Int64,
                                              alpha::RefOrCuRef{Cdouble}, x::CuPtr{Cdouble},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasCscal_v2_64(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCscal_v2_64(handle::cublasHandle_t, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              x::CuPtr{cuComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasCsscal_v2_64(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsscal_v2_64(handle::cublasHandle_t, n::Int64,
                                               alpha::RefOrCuRef{Cfloat},
                                               x::CuPtr{cuComplex},
                                               incx::Int64)::cublasStatus_t
end

@checked function cublasZscal_v2_64(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZscal_v2_64(handle::cublasHandle_t, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasZdscal_v2_64(handle, n, alpha, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdscal_v2_64(handle::cublasHandle_t, n::Int64,
                                               alpha::RefOrCuRef{Cdouble},
                                               x::CuPtr{cuDoubleComplex},
                                               incx::Int64)::cublasStatus_t
end

@checked function cublasSaxpy_v2_64(handle, n, alpha, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSaxpy_v2_64(handle::cublasHandle_t, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, x::CuPtr{Cfloat},
                                              incx::Int64, y::CuPtr{Cfloat},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasDaxpy_v2_64(handle, n, alpha, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDaxpy_v2_64(handle::cublasHandle_t, n::Int64,
                                              alpha::RefOrCuRef{Cdouble}, x::CuPtr{Cdouble},
                                              incx::Int64, y::CuPtr{Cdouble},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasCaxpy_v2_64(handle, n, alpha, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCaxpy_v2_64(handle::cublasHandle_t, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasZaxpy_v2_64(handle, n, alpha, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZaxpy_v2_64(handle::cublasHandle_t, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasScopy_v2_64(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasScopy_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cfloat}, incx::Int64,
                                              y::CuPtr{Cfloat}, incy::Int64)::cublasStatus_t
end

@checked function cublasDcopy_v2_64(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDcopy_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cdouble}, incx::Int64,
                                              y::CuPtr{Cdouble},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasCcopy_v2_64(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCcopy_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasZcopy_v2_64(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZcopy_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasSswap_v2_64(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSswap_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cfloat}, incx::Int64,
                                              y::CuPtr{Cfloat}, incy::Int64)::cublasStatus_t
end

@checked function cublasDswap_v2_64(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDswap_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cdouble}, incx::Int64,
                                              y::CuPtr{Cdouble},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasCswap_v2_64(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCswap_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasZswap_v2_64(handle, n, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZswap_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasIsamax_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIsamax_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{Cfloat}, incx::Int64,
                                               result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasIdamax_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIdamax_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{Cdouble}, incx::Int64,
                                               result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasIcamax_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIcamax_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{cuComplex}, incx::Int64,
                                               result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasIzamax_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIzamax_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{cuDoubleComplex}, incx::Int64,
                                               result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasIsamin_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIsamin_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{Cfloat}, incx::Int64,
                                               result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasIdamin_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIdamin_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{Cdouble}, incx::Int64,
                                               result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasIcamin_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIcamin_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{cuComplex}, incx::Int64,
                                               result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasIzamin_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIzamin_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{cuDoubleComplex}, incx::Int64,
                                               result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasSasum_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSasum_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cfloat}, incx::Int64,
                                              result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDasum_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDasum_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cdouble}, incx::Int64,
                                              result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasScasum_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasScasum_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{cuComplex}, incx::Int64,
                                               result::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDzasum_v2_64(handle, n, x, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDzasum_v2_64(handle::cublasHandle_t, n::Int64,
                                               x::CuPtr{cuDoubleComplex}, incx::Int64,
                                               result::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasSrot_v2_64(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSrot_v2_64(handle::cublasHandle_t, n::Int64,
                                             x::CuPtr{Cfloat}, incx::Int64,
                                             y::CuPtr{Cfloat}, incy::Int64,
                                             c::RefOrCuRef{Cfloat},
                                             s::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasDrot_v2_64(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDrot_v2_64(handle::cublasHandle_t, n::Int64,
                                             x::CuPtr{Cdouble}, incx::Int64,
                                             y::CuPtr{Cdouble}, incy::Int64,
                                             c::RefOrCuRef{Cdouble},
                                             s::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasCrot_v2_64(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCrot_v2_64(handle::cublasHandle_t, n::Int64,
                                             x::CuPtr{cuComplex}, incx::Int64,
                                             y::CuPtr{cuComplex}, incy::Int64,
                                             c::RefOrCuRef{Cfloat},
                                             s::RefOrCuRef{cuComplex})::cublasStatus_t
end

@checked function cublasCsrot_v2_64(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsrot_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex}, incy::Int64,
                                              c::RefOrCuRef{Cfloat},
                                              s::RefOrCuRef{Cfloat})::cublasStatus_t
end

@checked function cublasZrot_v2_64(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZrot_v2_64(handle::cublasHandle_t, n::Int64,
                                             x::CuPtr{cuDoubleComplex}, incx::Int64,
                                             y::CuPtr{cuDoubleComplex}, incy::Int64,
                                             c::RefOrCuRef{Cdouble},
                                             s::RefOrCuRef{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasZdrot_v2_64(handle, n, x, incx, y, incy, c, s)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdrot_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex}, incy::Int64,
                                              c::RefOrCuRef{Cdouble},
                                              s::RefOrCuRef{Cdouble})::cublasStatus_t
end

@checked function cublasSrotm_v2_64(handle, n, x, incx, y, incy, param)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSrotm_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cfloat}, incx::Int64,
                                              y::CuPtr{Cfloat}, incy::Int64,
                                              param::PtrOrCuPtr{Cfloat})::cublasStatus_t
end

@checked function cublasDrotm_v2_64(handle, n, x, incx, y, incy, param)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDrotm_v2_64(handle::cublasHandle_t, n::Int64,
                                              x::CuPtr{Cdouble}, incx::Int64,
                                              y::CuPtr{Cdouble}, incy::Int64,
                                              param::PtrOrCuPtr{Cdouble})::cublasStatus_t
end

@checked function cublasSgemv_v2_64(handle, trans, m, n, alpha, A, lda, x, incx, beta, y,
                                    incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemv_v2_64(handle::cublasHandle_t,
                                              trans::cublasOperation_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                              lda::Int64, x::CuPtr{Cfloat}, incx::Int64,
                                              beta::RefOrCuRef{Cfloat}, y::CuPtr{Cfloat},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasDgemv_v2_64(handle, trans, m, n, alpha, A, lda, x, incx, beta, y,
                                    incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemv_v2_64(handle::cublasHandle_t,
                                              trans::cublasOperation_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                              lda::Int64, x::CuPtr{Cdouble}, incx::Int64,
                                              beta::RefOrCuRef{Cdouble}, y::CuPtr{Cdouble},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasCgemv_v2_64(handle, trans, m, n, alpha, A, lda, x, incx, beta, y,
                                    incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemv_v2_64(handle::cublasHandle_t,
                                              trans::cublasOperation_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuComplex},
                                              y::CuPtr{cuComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasZgemv_v2_64(handle, trans, m, n, alpha, A, lda, x, incx, beta, y,
                                    incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemv_v2_64(handle::cublasHandle_t,
                                              trans::cublasOperation_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              y::CuPtr{cuDoubleComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasSgbmv_v2_64(handle, trans, m, n, kl, ku, alpha, A, lda, x, incx,
                                    beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgbmv_v2_64(handle::cublasHandle_t,
                                              trans::cublasOperation_t, m::Int64, n::Int64,
                                              kl::Int64, ku::Int64,
                                              alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                              lda::Int64, x::CuPtr{Cfloat}, incx::Int64,
                                              beta::RefOrCuRef{Cfloat}, y::CuPtr{Cfloat},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasDgbmv_v2_64(handle, trans, m, n, kl, ku, alpha, A, lda, x, incx,
                                    beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgbmv_v2_64(handle::cublasHandle_t,
                                              trans::cublasOperation_t, m::Int64, n::Int64,
                                              kl::Int64, ku::Int64,
                                              alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                              lda::Int64, x::CuPtr{Cdouble}, incx::Int64,
                                              beta::RefOrCuRef{Cdouble}, y::CuPtr{Cdouble},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasCgbmv_v2_64(handle, trans, m, n, kl, ku, alpha, A, lda, x, incx,
                                    beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgbmv_v2_64(handle::cublasHandle_t,
                                              trans::cublasOperation_t, m::Int64, n::Int64,
                                              kl::Int64, ku::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuComplex},
                                              y::CuPtr{cuComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasZgbmv_v2_64(handle, trans, m, n, kl, ku, alpha, A, lda, x, incx,
                                    beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgbmv_v2_64(handle::cublasHandle_t,
                                              trans::cublasOperation_t, m::Int64, n::Int64,
                                              kl::Int64, ku::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              y::CuPtr{cuDoubleComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasStrmv_v2_64(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              A::CuPtr{Cfloat}, lda::Int64,
                                              x::CuPtr{Cfloat}, incx::Int64)::cublasStatus_t
end

@checked function cublasDtrmv_v2_64(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              A::CuPtr{Cdouble}, lda::Int64,
                                              x::CuPtr{Cdouble},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasCtrmv_v2_64(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              x::CuPtr{cuComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasZtrmv_v2_64(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              x::CuPtr{cuDoubleComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasStbmv_v2_64(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStbmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64, k::Int64,
                                              A::CuPtr{Cfloat}, lda::Int64,
                                              x::CuPtr{Cfloat}, incx::Int64)::cublasStatus_t
end

@checked function cublasDtbmv_v2_64(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtbmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64, k::Int64,
                                              A::CuPtr{Cdouble}, lda::Int64,
                                              x::CuPtr{Cdouble},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasCtbmv_v2_64(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtbmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64, k::Int64,
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              x::CuPtr{cuComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasZtbmv_v2_64(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtbmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64, k::Int64,
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              x::CuPtr{cuDoubleComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasStpmv_v2_64(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStpmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              AP::CuPtr{Cfloat}, x::CuPtr{Cfloat},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasDtpmv_v2_64(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtpmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              AP::CuPtr{Cdouble}, x::CuPtr{Cdouble},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasCtpmv_v2_64(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtpmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              AP::CuPtr{cuComplex}, x::CuPtr{cuComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasZtpmv_v2_64(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtpmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              AP::CuPtr{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasStrsv_v2_64(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              A::CuPtr{Cfloat}, lda::Int64,
                                              x::CuPtr{Cfloat}, incx::Int64)::cublasStatus_t
end

@checked function cublasDtrsv_v2_64(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              A::CuPtr{Cdouble}, lda::Int64,
                                              x::CuPtr{Cdouble},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasCtrsv_v2_64(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              x::CuPtr{cuComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasZtrsv_v2_64(handle, uplo, trans, diag, n, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              x::CuPtr{cuDoubleComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasStpsv_v2_64(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStpsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              AP::CuPtr{Cfloat}, x::CuPtr{Cfloat},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasDtpsv_v2_64(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtpsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              AP::CuPtr{Cdouble}, x::CuPtr{Cdouble},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasCtpsv_v2_64(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtpsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              AP::CuPtr{cuComplex}, x::CuPtr{cuComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasZtpsv_v2_64(handle, uplo, trans, diag, n, AP, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtpsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64,
                                              AP::CuPtr{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasStbsv_v2_64(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStbsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64, k::Int64,
                                              A::CuPtr{Cfloat}, lda::Int64,
                                              x::CuPtr{Cfloat}, incx::Int64)::cublasStatus_t
end

@checked function cublasDtbsv_v2_64(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtbsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64, k::Int64,
                                              A::CuPtr{Cdouble}, lda::Int64,
                                              x::CuPtr{Cdouble},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasCtbsv_v2_64(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtbsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64, k::Int64,
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              x::CuPtr{cuComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasZtbsv_v2_64(handle, uplo, trans, diag, n, k, A, lda, x, incx)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtbsv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, n::Int64, k::Int64,
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              x::CuPtr{cuDoubleComplex},
                                              incx::Int64)::cublasStatus_t
end

@checked function cublasSsymv_v2_64(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsymv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                              lda::Int64, x::CuPtr{Cfloat}, incx::Int64,
                                              beta::RefOrCuRef{Cfloat}, y::CuPtr{Cfloat},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasDsymv_v2_64(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsymv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                              lda::Int64, x::CuPtr{Cdouble}, incx::Int64,
                                              beta::RefOrCuRef{Cdouble}, y::CuPtr{Cdouble},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasCsymv_v2_64(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsymv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuComplex},
                                              y::CuPtr{cuComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasZsymv_v2_64(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsymv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              y::CuPtr{cuDoubleComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasChemv_v2_64(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChemv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuComplex},
                                              y::CuPtr{cuComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasZhemv_v2_64(handle, uplo, n, alpha, A, lda, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhemv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              y::CuPtr{cuDoubleComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasSsbmv_v2_64(handle, uplo, n, k, alpha, A, lda, x, incx, beta, y,
                                    incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsbmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                              lda::Int64, x::CuPtr{Cfloat}, incx::Int64,
                                              beta::RefOrCuRef{Cfloat}, y::CuPtr{Cfloat},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasDsbmv_v2_64(handle, uplo, n, k, alpha, A, lda, x, incx, beta, y,
                                    incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsbmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                              lda::Int64, x::CuPtr{Cdouble}, incx::Int64,
                                              beta::RefOrCuRef{Cdouble}, y::CuPtr{Cdouble},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasChbmv_v2_64(handle, uplo, n, k, alpha, A, lda, x, incx, beta, y,
                                    incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChbmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuComplex},
                                              y::CuPtr{cuComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasZhbmv_v2_64(handle, uplo, n, k, alpha, A, lda, x, incx, beta, y,
                                    incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhbmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              y::CuPtr{cuDoubleComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasSspmv_v2_64(handle, uplo, n, alpha, AP, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSspmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, AP::CuPtr{Cfloat},
                                              x::CuPtr{Cfloat}, incx::Int64,
                                              beta::RefOrCuRef{Cfloat}, y::CuPtr{Cfloat},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasDspmv_v2_64(handle, uplo, n, alpha, AP, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDspmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{Cdouble},
                                              AP::CuPtr{Cdouble}, x::CuPtr{Cdouble},
                                              incx::Int64, beta::RefOrCuRef{Cdouble},
                                              y::CuPtr{Cdouble},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasChpmv_v2_64(handle, uplo, n, alpha, AP, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChpmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              AP::CuPtr{cuComplex}, x::CuPtr{cuComplex},
                                              incx::Int64, beta::RefOrCuRef{cuComplex},
                                              y::CuPtr{cuComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasZhpmv_v2_64(handle, uplo, n, alpha, AP, x, incx, beta, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhpmv_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              AP::CuPtr{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              y::CuPtr{cuDoubleComplex},
                                              incy::Int64)::cublasStatus_t
end

@checked function cublasSger_v2_64(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSger_v2_64(handle::cublasHandle_t, m::Int64, n::Int64,
                                             alpha::RefOrCuRef{Cfloat}, x::CuPtr{Cfloat},
                                             incx::Int64, y::CuPtr{Cfloat}, incy::Int64,
                                             A::CuPtr{Cfloat}, lda::Int64)::cublasStatus_t
end

@checked function cublasDger_v2_64(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDger_v2_64(handle::cublasHandle_t, m::Int64, n::Int64,
                                             alpha::RefOrCuRef{Cdouble}, x::CuPtr{Cdouble},
                                             incx::Int64, y::CuPtr{Cdouble}, incy::Int64,
                                             A::CuPtr{Cdouble}, lda::Int64)::cublasStatus_t
end

@checked function cublasCgeru_v2_64(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgeru_v2_64(handle::cublasHandle_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex}, incy::Int64,
                                              A::CuPtr{cuComplex},
                                              lda::Int64)::cublasStatus_t
end

@checked function cublasCgerc_v2_64(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgerc_v2_64(handle::cublasHandle_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex}, incy::Int64,
                                              A::CuPtr{cuComplex},
                                              lda::Int64)::cublasStatus_t
end

@checked function cublasZgeru_v2_64(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgeru_v2_64(handle::cublasHandle_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex}, incy::Int64,
                                              A::CuPtr{cuDoubleComplex},
                                              lda::Int64)::cublasStatus_t
end

@checked function cublasZgerc_v2_64(handle, m, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgerc_v2_64(handle::cublasHandle_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex}, incy::Int64,
                                              A::CuPtr{cuDoubleComplex},
                                              lda::Int64)::cublasStatus_t
end

@checked function cublasSsyr_v2_64(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyr_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{Cfloat},
                                             x::CuPtr{Cfloat}, incx::Int64,
                                             A::CuPtr{Cfloat}, lda::Int64)::cublasStatus_t
end

@checked function cublasDsyr_v2_64(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyr_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{Cdouble},
                                             x::CuPtr{Cdouble}, incx::Int64,
                                             A::CuPtr{Cdouble}, lda::Int64)::cublasStatus_t
end

@checked function cublasCsyr_v2_64(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyr_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{cuComplex},
                                             x::CuPtr{cuComplex}, incx::Int64,
                                             A::CuPtr{cuComplex},
                                             lda::Int64)::cublasStatus_t
end

@checked function cublasZsyr_v2_64(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyr_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{cuDoubleComplex},
                                             x::CuPtr{cuDoubleComplex}, incx::Int64,
                                             A::CuPtr{cuDoubleComplex},
                                             lda::Int64)::cublasStatus_t
end

@checked function cublasCher_v2_64(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCher_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{Cfloat},
                                             x::CuPtr{cuComplex}, incx::Int64,
                                             A::CuPtr{cuComplex},
                                             lda::Int64)::cublasStatus_t
end

@checked function cublasZher_v2_64(handle, uplo, n, alpha, x, incx, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZher_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{Cdouble},
                                             x::CuPtr{cuDoubleComplex}, incx::Int64,
                                             A::CuPtr{cuDoubleComplex},
                                             lda::Int64)::cublasStatus_t
end

@checked function cublasSspr_v2_64(handle, uplo, n, alpha, x, incx, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSspr_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{Cfloat},
                                             x::CuPtr{Cfloat}, incx::Int64,
                                             AP::CuPtr{Cfloat})::cublasStatus_t
end

@checked function cublasDspr_v2_64(handle, uplo, n, alpha, x, incx, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDspr_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{Cdouble},
                                             x::CuPtr{Cdouble}, incx::Int64,
                                             AP::CuPtr{Cdouble})::cublasStatus_t
end

@checked function cublasChpr_v2_64(handle, uplo, n, alpha, x, incx, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChpr_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{Cfloat},
                                             x::CuPtr{cuComplex}, incx::Int64,
                                             AP::CuPtr{cuComplex})::cublasStatus_t
end

@checked function cublasZhpr_v2_64(handle, uplo, n, alpha, x, incx, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhpr_v2_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             n::Int64, alpha::RefOrCuRef{Cdouble},
                                             x::CuPtr{cuDoubleComplex}, incx::Int64,
                                             AP::CuPtr{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasSsyr2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyr2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, x::CuPtr{Cfloat},
                                              incx::Int64, y::CuPtr{Cfloat}, incy::Int64,
                                              A::CuPtr{Cfloat}, lda::Int64)::cublasStatus_t
end

@checked function cublasDsyr2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyr2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{Cdouble}, x::CuPtr{Cdouble},
                                              incx::Int64, y::CuPtr{Cdouble}, incy::Int64,
                                              A::CuPtr{Cdouble}, lda::Int64)::cublasStatus_t
end

@checked function cublasCsyr2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyr2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex}, incy::Int64,
                                              A::CuPtr{cuComplex},
                                              lda::Int64)::cublasStatus_t
end

@checked function cublasZsyr2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyr2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex}, incy::Int64,
                                              A::CuPtr{cuDoubleComplex},
                                              lda::Int64)::cublasStatus_t
end

@checked function cublasCher2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCher2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex}, incy::Int64,
                                              A::CuPtr{cuComplex},
                                              lda::Int64)::cublasStatus_t
end

@checked function cublasZher2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZher2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex}, incy::Int64,
                                              A::CuPtr{cuDoubleComplex},
                                              lda::Int64)::cublasStatus_t
end

@checked function cublasSspr2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSspr2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, x::CuPtr{Cfloat},
                                              incx::Int64, y::CuPtr{Cfloat}, incy::Int64,
                                              AP::CuPtr{Cfloat})::cublasStatus_t
end

@checked function cublasDspr2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDspr2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{Cdouble}, x::CuPtr{Cdouble},
                                              incx::Int64, y::CuPtr{Cdouble}, incy::Int64,
                                              AP::CuPtr{Cdouble})::cublasStatus_t
end

@checked function cublasChpr2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChpr2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              x::CuPtr{cuComplex}, incx::Int64,
                                              y::CuPtr{cuComplex}, incy::Int64,
                                              AP::CuPtr{cuComplex})::cublasStatus_t
end

@checked function cublasZhpr2_v2_64(handle, uplo, n, alpha, x, incx, y, incy, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhpr2_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              x::CuPtr{cuDoubleComplex}, incx::Int64,
                                              y::CuPtr{cuDoubleComplex}, incy::Int64,
                                              AP::CuPtr{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasSgemm_v2_64(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                    beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemm_v2_64(handle::cublasHandle_t,
                                              transa::cublasOperation_t,
                                              transb::cublasOperation_t, m::Int64, n::Int64,
                                              k::Int64, alpha::RefOrCuRef{Cfloat},
                                              A::CuPtr{Cfloat}, lda::Int64,
                                              B::CuPtr{Cfloat}, ldb::Int64,
                                              beta::RefOrCuRef{Cfloat}, C::CuPtr{Cfloat},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasDgemm_v2_64(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                    beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemm_v2_64(handle::cublasHandle_t,
                                              transa::cublasOperation_t,
                                              transb::cublasOperation_t, m::Int64, n::Int64,
                                              k::Int64, alpha::RefOrCuRef{Cdouble},
                                              A::CuPtr{Cdouble}, lda::Int64,
                                              B::CuPtr{Cdouble}, ldb::Int64,
                                              beta::RefOrCuRef{Cdouble}, C::CuPtr{Cdouble},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasCgemm_v2_64(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                    beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm_v2_64(handle::cublasHandle_t,
                                              transa::cublasOperation_t,
                                              transb::cublasOperation_t, m::Int64, n::Int64,
                                              k::Int64, alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              B::CuPtr{cuComplex}, ldb::Int64,
                                              beta::RefOrCuRef{cuComplex},
                                              C::CuPtr{cuComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasZgemm_v2_64(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                    beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemm_v2_64(handle::cublasHandle_t,
                                              transa::cublasOperation_t,
                                              transb::cublasOperation_t, m::Int64, n::Int64,
                                              k::Int64, alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              C::CuPtr{cuDoubleComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasSsyrk_v2_64(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyrk_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                              lda::Int64, beta::RefOrCuRef{Cfloat},
                                              C::CuPtr{Cfloat}, ldc::Int64)::cublasStatus_t
end

@checked function cublasDsyrk_v2_64(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyrk_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                              lda::Int64, beta::RefOrCuRef{Cdouble},
                                              C::CuPtr{Cdouble}, ldc::Int64)::cublasStatus_t
end

@checked function cublasCsyrk_v2_64(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyrk_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              beta::RefOrCuRef{cuComplex},
                                              C::CuPtr{cuComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasZsyrk_v2_64(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyrk_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              C::CuPtr{cuDoubleComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasCherk_v2_64(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCherk_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{Cfloat},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              beta::RefOrCuRef{Cfloat}, C::CuPtr{cuComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasZherk_v2_64(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZherk_v2_64(handle::cublasHandle_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t, n::Int64, k::Int64,
                                              alpha::RefOrCuRef{Cdouble},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              beta::RefOrCuRef{Cdouble},
                                              C::CuPtr{cuDoubleComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasSsyr2k_v2_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta,
                                     C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyr2k_v2_64(handle::cublasHandle_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t, n::Int64, k::Int64,
                                               alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                               lda::Int64, B::CuPtr{Cfloat}, ldb::Int64,
                                               beta::RefOrCuRef{Cfloat}, C::CuPtr{Cfloat},
                                               ldc::Int64)::cublasStatus_t
end

@checked function cublasDsyr2k_v2_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta,
                                     C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyr2k_v2_64(handle::cublasHandle_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t, n::Int64, k::Int64,
                                               alpha::RefOrCuRef{Cdouble},
                                               A::CuPtr{Cdouble}, lda::Int64,
                                               B::CuPtr{Cdouble}, ldb::Int64,
                                               beta::RefOrCuRef{Cdouble}, C::CuPtr{Cdouble},
                                               ldc::Int64)::cublasStatus_t
end

@checked function cublasCsyr2k_v2_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta,
                                     C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyr2k_v2_64(handle::cublasHandle_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t, n::Int64, k::Int64,
                                               alpha::RefOrCuRef{cuComplex},
                                               A::CuPtr{cuComplex}, lda::Int64,
                                               B::CuPtr{cuComplex}, ldb::Int64,
                                               beta::RefOrCuRef{cuComplex},
                                               C::CuPtr{cuComplex},
                                               ldc::Int64)::cublasStatus_t
end

@checked function cublasZsyr2k_v2_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta,
                                     C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyr2k_v2_64(handle::cublasHandle_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t, n::Int64, k::Int64,
                                               alpha::RefOrCuRef{cuDoubleComplex},
                                               A::CuPtr{cuDoubleComplex}, lda::Int64,
                                               B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                               beta::RefOrCuRef{cuDoubleComplex},
                                               C::CuPtr{cuDoubleComplex},
                                               ldc::Int64)::cublasStatus_t
end

@checked function cublasCher2k_v2_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta,
                                     C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCher2k_v2_64(handle::cublasHandle_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t, n::Int64, k::Int64,
                                               alpha::RefOrCuRef{cuComplex},
                                               A::CuPtr{cuComplex}, lda::Int64,
                                               B::CuPtr{cuComplex}, ldb::Int64,
                                               beta::RefOrCuRef{Cfloat},
                                               C::CuPtr{cuComplex},
                                               ldc::Int64)::cublasStatus_t
end

@checked function cublasZher2k_v2_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta,
                                     C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZher2k_v2_64(handle::cublasHandle_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t, n::Int64, k::Int64,
                                               alpha::RefOrCuRef{cuDoubleComplex},
                                               A::CuPtr{cuDoubleComplex}, lda::Int64,
                                               B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                               beta::RefOrCuRef{Cdouble},
                                               C::CuPtr{cuDoubleComplex},
                                               ldc::Int64)::cublasStatus_t
end

@checked function cublasSsymm_v2_64(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta,
                                    C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsymm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                              lda::Int64, B::CuPtr{Cfloat}, ldb::Int64,
                                              beta::RefOrCuRef{Cfloat}, C::CuPtr{Cfloat},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasDsymm_v2_64(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta,
                                    C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsymm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                              lda::Int64, B::CuPtr{Cdouble}, ldb::Int64,
                                              beta::RefOrCuRef{Cdouble}, C::CuPtr{Cdouble},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasCsymm_v2_64(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta,
                                    C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsymm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              B::CuPtr{cuComplex}, ldb::Int64,
                                              beta::RefOrCuRef{cuComplex},
                                              C::CuPtr{cuComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasZsymm_v2_64(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta,
                                    C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsymm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              C::CuPtr{cuDoubleComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasChemm_v2_64(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta,
                                    C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasChemm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              B::CuPtr{cuComplex}, ldb::Int64,
                                              beta::RefOrCuRef{cuComplex},
                                              C::CuPtr{cuComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasZhemm_v2_64(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta,
                                    C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZhemm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                              beta::RefOrCuRef{cuDoubleComplex},
                                              C::CuPtr{cuDoubleComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasStrsm_v2_64(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                    ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrsm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                              lda::Int64, B::CuPtr{Cfloat},
                                              ldb::Int64)::cublasStatus_t
end

@checked function cublasDtrsm_v2_64(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                    ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrsm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                              lda::Int64, B::CuPtr{Cdouble},
                                              ldb::Int64)::cublasStatus_t
end

@checked function cublasCtrsm_v2_64(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                    ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrsm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              B::CuPtr{cuComplex},
                                              ldb::Int64)::cublasStatus_t
end

@checked function cublasZtrsm_v2_64(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                    ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrsm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              B::CuPtr{cuDoubleComplex},
                                              ldb::Int64)::cublasStatus_t
end

@checked function cublasStrmm_v2_64(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                    ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrmm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                              lda::Int64, B::CuPtr{Cfloat}, ldb::Int64,
                                              C::CuPtr{Cfloat}, ldc::Int64)::cublasStatus_t
end

@checked function cublasDtrmm_v2_64(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                    ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrmm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                              lda::Int64, B::CuPtr{Cdouble}, ldb::Int64,
                                              C::CuPtr{Cdouble}, ldc::Int64)::cublasStatus_t
end

@checked function cublasCtrmm_v2_64(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                    ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrmm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuComplex},
                                              A::CuPtr{cuComplex}, lda::Int64,
                                              B::CuPtr{cuComplex}, ldb::Int64,
                                              C::CuPtr{cuComplex},
                                              ldc::Int64)::cublasStatus_t
end

@checked function cublasZtrmm_v2_64(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                    ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrmm_v2_64(handle::cublasHandle_t,
                                              side::cublasSideMode_t,
                                              uplo::cublasFillMode_t,
                                              trans::cublasOperation_t,
                                              diag::cublasDiagType_t, m::Int64, n::Int64,
                                              alpha::RefOrCuRef{cuDoubleComplex},
                                              A::CuPtr{cuDoubleComplex}, lda::Int64,
                                              B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                              C::CuPtr{cuDoubleComplex},
                                              ldc::Int64)::cublasStatus_t
end

@cenum cublasAtomicsMode_t::UInt32 begin
    CUBLAS_ATOMICS_NOT_ALLOWED = 0
    CUBLAS_ATOMICS_ALLOWED = 1
end

@cenum cublasGemmAlgo_t::Int32 begin
    CUBLAS_GEMM_DFALT = -1
    CUBLAS_GEMM_DEFAULT = -1
    CUBLAS_GEMM_ALGO0 = 0
    CUBLAS_GEMM_ALGO1 = 1
    CUBLAS_GEMM_ALGO2 = 2
    CUBLAS_GEMM_ALGO3 = 3
    CUBLAS_GEMM_ALGO4 = 4
    CUBLAS_GEMM_ALGO5 = 5
    CUBLAS_GEMM_ALGO6 = 6
    CUBLAS_GEMM_ALGO7 = 7
    CUBLAS_GEMM_ALGO8 = 8
    CUBLAS_GEMM_ALGO9 = 9
    CUBLAS_GEMM_ALGO10 = 10
    CUBLAS_GEMM_ALGO11 = 11
    CUBLAS_GEMM_ALGO12 = 12
    CUBLAS_GEMM_ALGO13 = 13
    CUBLAS_GEMM_ALGO14 = 14
    CUBLAS_GEMM_ALGO15 = 15
    CUBLAS_GEMM_ALGO16 = 16
    CUBLAS_GEMM_ALGO17 = 17
    CUBLAS_GEMM_ALGO18 = 18
    CUBLAS_GEMM_ALGO19 = 19
    CUBLAS_GEMM_ALGO20 = 20
    CUBLAS_GEMM_ALGO21 = 21
    CUBLAS_GEMM_ALGO22 = 22
    CUBLAS_GEMM_ALGO23 = 23
    CUBLAS_GEMM_DEFAULT_TENSOR_OP = 99
    CUBLAS_GEMM_DFALT_TENSOR_OP = 99
    CUBLAS_GEMM_ALGO0_TENSOR_OP = 100
    CUBLAS_GEMM_ALGO1_TENSOR_OP = 101
    CUBLAS_GEMM_ALGO2_TENSOR_OP = 102
    CUBLAS_GEMM_ALGO3_TENSOR_OP = 103
    CUBLAS_GEMM_ALGO4_TENSOR_OP = 104
    CUBLAS_GEMM_ALGO5_TENSOR_OP = 105
    CUBLAS_GEMM_ALGO6_TENSOR_OP = 106
    CUBLAS_GEMM_ALGO7_TENSOR_OP = 107
    CUBLAS_GEMM_ALGO8_TENSOR_OP = 108
    CUBLAS_GEMM_ALGO9_TENSOR_OP = 109
    CUBLAS_GEMM_ALGO10_TENSOR_OP = 110
    CUBLAS_GEMM_ALGO11_TENSOR_OP = 111
    CUBLAS_GEMM_ALGO12_TENSOR_OP = 112
    CUBLAS_GEMM_ALGO13_TENSOR_OP = 113
    CUBLAS_GEMM_ALGO14_TENSOR_OP = 114
    CUBLAS_GEMM_ALGO15_TENSOR_OP = 115
end

@cenum cublasMath_t::UInt32 begin
    CUBLAS_DEFAULT_MATH = 0
    CUBLAS_TENSOR_OP_MATH = 1
    CUBLAS_PEDANTIC_MATH = 2
    CUBLAS_TF32_TENSOR_OP_MATH = 3
    CUBLAS_MATH_DISALLOW_REDUCED_PRECISION_REDUCTION = 16
end

const cublasDataType_t = cudaDataType

@cenum cublasComputeType_t::UInt32 begin
    CUBLAS_COMPUTE_16F = 64
    CUBLAS_COMPUTE_16F_PEDANTIC = 65
    CUBLAS_COMPUTE_32F = 68
    CUBLAS_COMPUTE_32F_PEDANTIC = 69
    CUBLAS_COMPUTE_32F_FAST_16F = 74
    CUBLAS_COMPUTE_32F_FAST_16BF = 75
    CUBLAS_COMPUTE_32F_FAST_TF32 = 77
    CUBLAS_COMPUTE_64F = 70
    CUBLAS_COMPUTE_64F_PEDANTIC = 71
    CUBLAS_COMPUTE_32I = 72
    CUBLAS_COMPUTE_32I_PEDANTIC = 73
end

# typedef void ( * cublasLogCallback ) ( const char * msg )
const cublasLogCallback = Ptr{Cvoid}

@checked function cublasGetProperty(type, value)
    @gcsafe_ccall libcublas.cublasGetProperty(type::libraryPropertyType,
                                              value::Ref{Cint})::cublasStatus_t
end

function cublasGetCudartVersion()
    @gcsafe_ccall libcublas.cublasGetCudartVersion()::Csize_t
end

@checked function cublasGetAtomicsMode(handle, mode)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetAtomicsMode(handle::cublasHandle_t,
                                                 mode::Ref{cublasAtomicsMode_t})::cublasStatus_t
end

@checked function cublasSetAtomicsMode(handle, mode)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetAtomicsMode(handle::cublasHandle_t,
                                                 mode::cublasAtomicsMode_t)::cublasStatus_t
end

@checked function cublasGetMathMode(handle, mode)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetMathMode(handle::cublasHandle_t,
                                              mode::Ref{UInt32})::cublasStatus_t
end

@checked function cublasSetMathMode(handle, mode)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetMathMode(handle::cublasHandle_t,
                                              mode::cublasMath_t)::cublasStatus_t
end

@checked function cublasGetSmCountTarget(handle, smCountTarget)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetSmCountTarget(handle::cublasHandle_t,
                                                   smCountTarget::Ptr{Cint})::cublasStatus_t
end

@checked function cublasSetSmCountTarget(handle, smCountTarget)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetSmCountTarget(handle::cublasHandle_t,
                                                   smCountTarget::Cint)::cublasStatus_t
end

function cublasGetStatusName(status)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetStatusName(status::cublasStatus_t)::Cstring
end

function cublasGetStatusString(status)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetStatusString(status::cublasStatus_t)::Cstring
end

@checked function cublasLoggerConfigure(logIsOn, logToStdOut, logToStdErr, logFileName)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLoggerConfigure(logIsOn::Cint, logToStdOut::Cint,
                                                  logToStdErr::Cint,
                                                  logFileName::Cstring)::cublasStatus_t
end

@checked function cublasSetLoggerCallback(userCallback)
    @gcsafe_ccall libcublas.cublasSetLoggerCallback(userCallback::cublasLogCallback)::cublasStatus_t
end

@checked function cublasGetLoggerCallback(userCallback)
    @gcsafe_ccall libcublas.cublasGetLoggerCallback(userCallback::Ref{cublasLogCallback})::cublasStatus_t
end

@checked function cublasSetVector(n, elemSize, x, incx, devicePtr, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetVector(n::Cint, elemSize::Cint, x::Ptr{Cvoid},
                                            incx::Cint, devicePtr::CuPtr{Cvoid},
                                            incy::Cint)::cublasStatus_t
end

@checked function cublasSetVector_64(n, elemSize, x, incx, devicePtr, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetVector_64(n::Int64, elemSize::Int64, x::Ptr{Cvoid},
                                               incx::Int64, devicePtr::CuPtr{Cvoid},
                                               incy::Int64)::cublasStatus_t
end

@checked function cublasGetVector(n, elemSize, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetVector(n::Cint, elemSize::Cint, x::CuPtr{Cvoid},
                                            incx::Cint, y::Ptr{Cvoid},
                                            incy::Cint)::cublasStatus_t
end

@checked function cublasGetVector_64(n, elemSize, x, incx, y, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetVector_64(n::Int64, elemSize::Int64, x::CuPtr{Cvoid},
                                               incx::Int64, y::Ptr{Cvoid},
                                               incy::Int64)::cublasStatus_t
end

@checked function cublasSetMatrix(rows, cols, elemSize, A, lda, B, ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetMatrix(rows::Cint, cols::Cint, elemSize::Cint,
                                            A::Ptr{Cvoid}, lda::Cint, B::CuPtr{Cvoid},
                                            ldb::Cint)::cublasStatus_t
end

@checked function cublasSetMatrix_64(rows, cols, elemSize, A, lda, B, ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetMatrix_64(rows::Int64, cols::Int64, elemSize::Int64,
                                               A::Ptr{Cvoid}, lda::Int64, B::CuPtr{Cvoid},
                                               ldb::Int64)::cublasStatus_t
end

@checked function cublasGetMatrix(rows, cols, elemSize, A, lda, B, ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetMatrix(rows::Cint, cols::Cint, elemSize::Cint,
                                            A::CuPtr{Cvoid}, lda::Cint, B::Ptr{Cvoid},
                                            ldb::Cint)::cublasStatus_t
end

@checked function cublasGetMatrix_64(rows, cols, elemSize, A, lda, B, ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetMatrix_64(rows::Int64, cols::Int64, elemSize::Int64,
                                               A::CuPtr{Cvoid}, lda::Int64, B::Ptr{Cvoid},
                                               ldb::Int64)::cublasStatus_t
end

@checked function cublasSetVectorAsync(n, elemSize, hostPtr, incx, devicePtr, incy, stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetVectorAsync(n::Cint, elemSize::Cint,
                                                 hostPtr::Ptr{Cvoid}, incx::Cint,
                                                 devicePtr::CuPtr{Cvoid}, incy::Cint,
                                                 stream::cudaStream_t)::cublasStatus_t
end

@checked function cublasSetVectorAsync_64(n, elemSize, hostPtr, incx, devicePtr, incy,
                                          stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetVectorAsync_64(n::Int64, elemSize::Int64,
                                                    hostPtr::Ptr{Cvoid}, incx::Int64,
                                                    devicePtr::CuPtr{Cvoid}, incy::Int64,
                                                    stream::cudaStream_t)::cublasStatus_t
end

@checked function cublasGetVectorAsync(n, elemSize, devicePtr, incx, hostPtr, incy, stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetVectorAsync(n::Cint, elemSize::Cint,
                                                 devicePtr::CuPtr{Cvoid}, incx::Cint,
                                                 hostPtr::Ptr{Cvoid}, incy::Cint,
                                                 stream::cudaStream_t)::cublasStatus_t
end

@checked function cublasGetVectorAsync_64(n, elemSize, devicePtr, incx, hostPtr, incy,
                                          stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetVectorAsync_64(n::Int64, elemSize::Int64,
                                                    devicePtr::CuPtr{Cvoid}, incx::Int64,
                                                    hostPtr::Ptr{Cvoid}, incy::Int64,
                                                    stream::cudaStream_t)::cublasStatus_t
end

@checked function cublasSetMatrixAsync(rows, cols, elemSize, A, lda, B, ldb, stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetMatrixAsync(rows::Cint, cols::Cint, elemSize::Cint,
                                                 A::Ptr{Cvoid}, lda::Cint, B::CuPtr{Cvoid},
                                                 ldb::Cint,
                                                 stream::cudaStream_t)::cublasStatus_t
end

@checked function cublasSetMatrixAsync_64(rows, cols, elemSize, A, lda, B, ldb, stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSetMatrixAsync_64(rows::Int64, cols::Int64,
                                                    elemSize::Int64, A::Ptr{Cvoid},
                                                    lda::Int64, B::CuPtr{Cvoid}, ldb::Int64,
                                                    stream::cudaStream_t)::cublasStatus_t
end

@checked function cublasGetMatrixAsync(rows, cols, elemSize, A, lda, B, ldb, stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetMatrixAsync(rows::Cint, cols::Cint, elemSize::Cint,
                                                 A::CuPtr{Cvoid}, lda::Cint, B::Ptr{Cvoid},
                                                 ldb::Cint,
                                                 stream::cudaStream_t)::cublasStatus_t
end

@checked function cublasGetMatrixAsync_64(rows, cols, elemSize, A, lda, B, ldb, stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGetMatrixAsync_64(rows::Int64, cols::Int64,
                                                    elemSize::Int64, A::CuPtr{Cvoid},
                                                    lda::Int64, B::Ptr{Cvoid}, ldb::Int64,
                                                    stream::cudaStream_t)::cublasStatus_t
end

function cublasXerbla(srName, info)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXerbla(srName::Cstring, info::Cint)::Cvoid
end

@checked function cublasNrm2Ex(handle, n, x, xType, incx, result, resultType, executionType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasNrm2Ex(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                         xType::cudaDataType, incx::Cint,
                                         result::PtrOrCuPtr{Cvoid},
                                         resultType::cudaDataType,
                                         executionType::cudaDataType)::cublasStatus_t
end

@checked function cublasNrm2Ex_64(handle, n, x, xType, incx, result, resultType,
                                  executionType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasNrm2Ex_64(handle::cublasHandle_t, n::Int64,
                                            x::CuPtr{Cvoid}, xType::cudaDataType,
                                            incx::Int64, result::PtrOrCuPtr{Cvoid},
                                            resultType::cudaDataType,
                                            executionType::cudaDataType)::cublasStatus_t
end

@checked function cublasDotEx(handle, n, x, xType, incx, y, yType, incy, result, resultType,
                              executionType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDotEx(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                        xType::cudaDataType, incx::Cint, y::CuPtr{Cvoid},
                                        yType::cudaDataType, incy::Cint,
                                        result::PtrOrCuPtr{Cvoid}, resultType::cudaDataType,
                                        executionType::cudaDataType)::cublasStatus_t
end

@checked function cublasDotEx_64(handle, n, x, xType, incx, y, yType, incy, result,
                                 resultType, executionType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDotEx_64(handle::cublasHandle_t, n::Int64,
                                           x::CuPtr{Cvoid}, xType::cudaDataType,
                                           incx::Int64, y::CuPtr{Cvoid},
                                           yType::cudaDataType, incy::Int64,
                                           result::PtrOrCuPtr{Cvoid},
                                           resultType::cudaDataType,
                                           executionType::cudaDataType)::cublasStatus_t
end

@checked function cublasDotcEx(handle, n, x, xType, incx, y, yType, incy, result,
                               resultType, executionType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDotcEx(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                         xType::cudaDataType, incx::Cint, y::CuPtr{Cvoid},
                                         yType::cudaDataType, incy::Cint,
                                         result::PtrOrCuPtr{Cvoid},
                                         resultType::cudaDataType,
                                         executionType::cudaDataType)::cublasStatus_t
end

@checked function cublasDotcEx_64(handle, n, x, xType, incx, y, yType, incy, result,
                                  resultType, executionType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDotcEx_64(handle::cublasHandle_t, n::Int64,
                                            x::CuPtr{Cvoid}, xType::cudaDataType,
                                            incx::Int64, y::CuPtr{Cvoid},
                                            yType::cudaDataType, incy::Int64,
                                            result::PtrOrCuPtr{Cvoid},
                                            resultType::cudaDataType,
                                            executionType::cudaDataType)::cublasStatus_t
end

@checked function cublasScalEx(handle, n, alpha, alphaType, x, xType, incx, executionType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasScalEx(handle::cublasHandle_t, n::Cint,
                                         alpha::PtrOrCuPtr{Cvoid}, alphaType::cudaDataType,
                                         x::CuPtr{Cvoid}, xType::cudaDataType, incx::Cint,
                                         executionType::cudaDataType)::cublasStatus_t
end

@checked function cublasScalEx_64(handle, n, alpha, alphaType, x, xType, incx,
                                  executionType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasScalEx_64(handle::cublasHandle_t, n::Int64,
                                            alpha::PtrOrCuPtr{Cvoid},
                                            alphaType::cudaDataType, x::CuPtr{Cvoid},
                                            xType::cudaDataType, incx::Int64,
                                            executionType::cudaDataType)::cublasStatus_t
end

@checked function cublasAxpyEx(handle, n, alpha, alphaType, x, xType, incx, y, yType, incy,
                               executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasAxpyEx(handle::cublasHandle_t, n::Cint,
                                         alpha::PtrOrCuPtr{Cvoid}, alphaType::cudaDataType,
                                         x::CuPtr{Cvoid}, xType::cudaDataType, incx::Cint,
                                         y::CuPtr{Cvoid}, yType::cudaDataType, incy::Cint,
                                         executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasAxpyEx_64(handle, n, alpha, alphaType, x, xType, incx, y, yType,
                                  incy, executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasAxpyEx_64(handle::cublasHandle_t, n::Int64,
                                            alpha::PtrOrCuPtr{Cvoid},
                                            alphaType::cudaDataType, x::CuPtr{Cvoid},
                                            xType::cudaDataType, incx::Int64,
                                            y::CuPtr{Cvoid}, yType::cudaDataType,
                                            incy::Int64,
                                            executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasCopyEx(handle, n, x, xType, incx, y, yType, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCopyEx(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                         xType::cudaDataType, incx::Cint, y::CuPtr{Cvoid},
                                         yType::cudaDataType, incy::Cint)::cublasStatus_t
end

@checked function cublasCopyEx_64(handle, n, x, xType, incx, y, yType, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCopyEx_64(handle::cublasHandle_t, n::Int64,
                                            x::CuPtr{Cvoid}, xType::cudaDataType,
                                            incx::Int64, y::CuPtr{Cvoid},
                                            yType::cudaDataType,
                                            incy::Int64)::cublasStatus_t
end

@checked function cublasSwapEx(handle, n, x, xType, incx, y, yType, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSwapEx(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                         xType::cudaDataType, incx::Cint, y::CuPtr{Cvoid},
                                         yType::cudaDataType, incy::Cint)::cublasStatus_t
end

@checked function cublasSwapEx_64(handle, n, x, xType, incx, y, yType, incy)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSwapEx_64(handle::cublasHandle_t, n::Int64,
                                            x::CuPtr{Cvoid}, xType::cudaDataType,
                                            incx::Int64, y::CuPtr{Cvoid},
                                            yType::cudaDataType,
                                            incy::Int64)::cublasStatus_t
end

@checked function cublasIamaxEx(handle, n, x, xType, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIamaxEx(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                          xType::cudaDataType, incx::Cint,
                                          result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasIamaxEx_64(handle, n, x, xType, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIamaxEx_64(handle::cublasHandle_t, n::Int64,
                                             x::CuPtr{Cvoid}, xType::cudaDataType,
                                             incx::Int64,
                                             result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasIaminEx(handle, n, x, xType, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIaminEx(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                          xType::cudaDataType, incx::Cint,
                                          result::RefOrCuRef{Cint})::cublasStatus_t
end

@checked function cublasIaminEx_64(handle, n, x, xType, incx, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasIaminEx_64(handle::cublasHandle_t, n::Int64,
                                             x::CuPtr{Cvoid}, xType::cudaDataType,
                                             incx::Int64,
                                             result::RefOrCuRef{Int64})::cublasStatus_t
end

@checked function cublasAsumEx(handle, n, x, xType, incx, result, resultType, executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasAsumEx(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                         xType::cudaDataType, incx::Cint,
                                         result::PtrOrCuPtr{Cvoid},
                                         resultType::cudaDataType,
                                         executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasAsumEx_64(handle, n, x, xType, incx, result, resultType,
                                  executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasAsumEx_64(handle::cublasHandle_t, n::Int64,
                                            x::CuPtr{Cvoid}, xType::cudaDataType,
                                            incx::Int64, result::PtrOrCuPtr{Cvoid},
                                            resultType::cudaDataType,
                                            executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasRotEx(handle, n, x, xType, incx, y, yType, incy, c, s, csType,
                              executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasRotEx(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                        xType::cudaDataType, incx::Cint, y::CuPtr{Cvoid},
                                        yType::cudaDataType, incy::Cint,
                                        c::PtrOrCuPtr{Cvoid}, s::PtrOrCuPtr{Cvoid},
                                        csType::cudaDataType,
                                        executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasRotEx_64(handle, n, x, xType, incx, y, yType, incy, c, s, csType,
                                 executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasRotEx_64(handle::cublasHandle_t, n::Int64,
                                           x::CuPtr{Cvoid}, xType::cudaDataType,
                                           incx::Int64, y::CuPtr{Cvoid},
                                           yType::cudaDataType, incy::Int64,
                                           c::PtrOrCuPtr{Cvoid}, s::PtrOrCuPtr{Cvoid},
                                           csType::cudaDataType,
                                           executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasRotgEx(handle, a, b, abType, c, s, csType, executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasRotgEx(handle::cublasHandle_t, a::Ptr{Cvoid},
                                         b::Ptr{Cvoid}, abType::cudaDataType,
                                         c::PtrOrCuPtr{Cvoid}, s::PtrOrCuPtr{Cvoid},
                                         csType::cudaDataType,
                                         executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasRotmEx(handle, n, x, xType, incx, y, yType, incy, param, paramType,
                               executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasRotmEx(handle::cublasHandle_t, n::Cint, x::CuPtr{Cvoid},
                                         xType::cudaDataType, incx::Cint, y::CuPtr{Cvoid},
                                         yType::cudaDataType, incy::Cint,
                                         param::PtrOrCuPtr{Cvoid}, paramType::cudaDataType,
                                         executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasRotmEx_64(handle, n, x, xType, incx, y, yType, incy, param,
                                  paramType, executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasRotmEx_64(handle::cublasHandle_t, n::Int64,
                                            x::CuPtr{Cvoid}, xType::cudaDataType,
                                            incx::Int64, y::CuPtr{Cvoid},
                                            yType::cudaDataType, incy::Int64,
                                            param::PtrOrCuPtr{Cvoid},
                                            paramType::cudaDataType,
                                            executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasRotmgEx(handle, d1, d1Type, d2, d2Type, x1, x1Type, y1, y1Type,
                                param, paramType, executiontype)
    initialize_context()
    @gcsafe_ccall libcublas.cublasRotmgEx(handle::cublasHandle_t, d1::PtrOrCuPtr{Cvoid},
                                          d1Type::cudaDataType, d2::PtrOrCuPtr{Cvoid},
                                          d2Type::cudaDataType, x1::PtrOrCuPtr{Cvoid},
                                          x1Type::cudaDataType, y1::PtrOrCuPtr{Cvoid},
                                          y1Type::cudaDataType, param::PtrOrCuPtr{Cvoid},
                                          paramType::cudaDataType,
                                          executiontype::cudaDataType)::cublasStatus_t
end

@checked function cublasSgemvBatched(handle, trans, m, n, alpha, Aarray, lda, xarray, incx,
                                     beta, yarray, incy, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemvBatched(handle::cublasHandle_t,
                                               trans::cublasOperation_t, m::Cint, n::Cint,
                                               alpha::RefOrCuRef{Cfloat},
                                               Aarray::CuPtr{Ptr{Cfloat}}, lda::Cint,
                                               xarray::CuPtr{Ptr{Cfloat}}, incx::Cint,
                                               beta::RefOrCuRef{Cfloat},
                                               yarray::CuPtr{Ptr{Cfloat}}, incy::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasSgemvBatched_64(handle, trans, m, n, alpha, Aarray, lda, xarray,
                                        incx, beta, yarray, incy, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemvBatched_64(handle::cublasHandle_t,
                                                  trans::cublasOperation_t, m::Int64,
                                                  n::Int64, alpha::RefOrCuRef{Cfloat},
                                                  Aarray::CuPtr{Ptr{Cfloat}}, lda::Int64,
                                                  xarray::CuPtr{Ptr{Cfloat}}, incx::Int64,
                                                  beta::RefOrCuRef{Cfloat},
                                                  yarray::CuPtr{Ptr{Cfloat}}, incy::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasDgemvBatched(handle, trans, m, n, alpha, Aarray, lda, xarray, incx,
                                     beta, yarray, incy, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemvBatched(handle::cublasHandle_t,
                                               trans::cublasOperation_t, m::Cint, n::Cint,
                                               alpha::RefOrCuRef{Cdouble},
                                               Aarray::CuPtr{Ptr{Cdouble}}, lda::Cint,
                                               xarray::CuPtr{Ptr{Cdouble}}, incx::Cint,
                                               beta::RefOrCuRef{Cdouble},
                                               yarray::CuPtr{Ptr{Cdouble}}, incy::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasDgemvBatched_64(handle, trans, m, n, alpha, Aarray, lda, xarray,
                                        incx, beta, yarray, incy, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemvBatched_64(handle::cublasHandle_t,
                                                  trans::cublasOperation_t, m::Int64,
                                                  n::Int64, alpha::RefOrCuRef{Cdouble},
                                                  Aarray::CuPtr{Ptr{Cdouble}}, lda::Int64,
                                                  xarray::CuPtr{Ptr{Cdouble}}, incx::Int64,
                                                  beta::RefOrCuRef{Cdouble},
                                                  yarray::CuPtr{Ptr{Cdouble}}, incy::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasCgemvBatched(handle, trans, m, n, alpha, Aarray, lda, xarray, incx,
                                     beta, yarray, incy, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemvBatched(handle::cublasHandle_t,
                                               trans::cublasOperation_t, m::Cint, n::Cint,
                                               alpha::RefOrCuRef{cuComplex},
                                               Aarray::CuPtr{Ptr{cuComplex}}, lda::Cint,
                                               xarray::CuPtr{Ptr{cuComplex}}, incx::Cint,
                                               beta::RefOrCuRef{cuComplex},
                                               yarray::CuPtr{Ptr{cuComplex}}, incy::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasCgemvBatched_64(handle, trans, m, n, alpha, Aarray, lda, xarray,
                                        incx, beta, yarray, incy, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemvBatched_64(handle::cublasHandle_t,
                                                  trans::cublasOperation_t, m::Int64,
                                                  n::Int64, alpha::RefOrCuRef{cuComplex},
                                                  Aarray::CuPtr{Ptr{cuComplex}}, lda::Int64,
                                                  xarray::CuPtr{Ptr{cuComplex}},
                                                  incx::Int64, beta::RefOrCuRef{cuComplex},
                                                  yarray::CuPtr{Ptr{cuComplex}},
                                                  incy::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasZgemvBatched(handle, trans, m, n, alpha, Aarray, lda, xarray, incx,
                                     beta, yarray, incy, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemvBatched(handle::cublasHandle_t,
                                               trans::cublasOperation_t, m::Cint, n::Cint,
                                               alpha::RefOrCuRef{cuDoubleComplex},
                                               Aarray::CuPtr{Ptr{cuDoubleComplex}},
                                               lda::Cint,
                                               xarray::CuPtr{Ptr{cuDoubleComplex}},
                                               incx::Cint,
                                               beta::RefOrCuRef{cuDoubleComplex},
                                               yarray::CuPtr{Ptr{cuDoubleComplex}},
                                               incy::Cint, batchCount::Cint)::cublasStatus_t
end

@checked function cublasZgemvBatched_64(handle, trans, m, n, alpha, Aarray, lda, xarray,
                                        incx, beta, yarray, incy, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemvBatched_64(handle::cublasHandle_t,
                                                  trans::cublasOperation_t, m::Int64,
                                                  n::Int64,
                                                  alpha::RefOrCuRef{cuDoubleComplex},
                                                  Aarray::CuPtr{Ptr{cuDoubleComplex}},
                                                  lda::Int64,
                                                  xarray::CuPtr{Ptr{cuDoubleComplex}},
                                                  incx::Int64,
                                                  beta::RefOrCuRef{cuDoubleComplex},
                                                  yarray::CuPtr{Ptr{cuDoubleComplex}},
                                                  incy::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasSgemvStridedBatched(handle, trans, m, n, alpha, A, lda, strideA, x,
                                            incx, stridex, beta, y, incy, stridey,
                                            batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemvStridedBatched(handle::cublasHandle_t,
                                                      trans::cublasOperation_t, m::Cint,
                                                      n::Cint, alpha::RefOrCuRef{Cfloat},
                                                      A::CuPtr{Cfloat}, lda::Cint,
                                                      strideA::Clonglong, x::CuPtr{Cfloat},
                                                      incx::Cint, stridex::Clonglong,
                                                      beta::RefOrCuRef{Cfloat},
                                                      y::CuPtr{Cfloat}, incy::Cint,
                                                      stridey::Clonglong,
                                                      batchCount::Cint)::cublasStatus_t
end

@checked function cublasSgemvStridedBatched_64(handle, trans, m, n, alpha, A, lda, strideA,
                                               x, incx, stridex, beta, y, incy, stridey,
                                               batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemvStridedBatched_64(handle::cublasHandle_t,
                                                         trans::cublasOperation_t, m::Int64,
                                                         n::Int64,
                                                         alpha::RefOrCuRef{Cfloat},
                                                         A::CuPtr{Cfloat}, lda::Int64,
                                                         strideA::Clonglong,
                                                         x::CuPtr{Cfloat}, incx::Int64,
                                                         stridex::Clonglong,
                                                         beta::RefOrCuRef{Cfloat},
                                                         y::CuPtr{Cfloat}, incy::Int64,
                                                         stridey::Clonglong,
                                                         batchCount::Int64)::cublasStatus_t
end

@checked function cublasDgemvStridedBatched(handle, trans, m, n, alpha, A, lda, strideA, x,
                                            incx, stridex, beta, y, incy, stridey,
                                            batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemvStridedBatched(handle::cublasHandle_t,
                                                      trans::cublasOperation_t, m::Cint,
                                                      n::Cint, alpha::RefOrCuRef{Cdouble},
                                                      A::CuPtr{Cdouble}, lda::Cint,
                                                      strideA::Clonglong, x::CuPtr{Cdouble},
                                                      incx::Cint, stridex::Clonglong,
                                                      beta::RefOrCuRef{Cdouble},
                                                      y::CuPtr{Cdouble}, incy::Cint,
                                                      stridey::Clonglong,
                                                      batchCount::Cint)::cublasStatus_t
end

@checked function cublasDgemvStridedBatched_64(handle, trans, m, n, alpha, A, lda, strideA,
                                               x, incx, stridex, beta, y, incy, stridey,
                                               batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemvStridedBatched_64(handle::cublasHandle_t,
                                                         trans::cublasOperation_t, m::Int64,
                                                         n::Int64,
                                                         alpha::RefOrCuRef{Cdouble},
                                                         A::CuPtr{Cdouble}, lda::Int64,
                                                         strideA::Clonglong,
                                                         x::CuPtr{Cdouble}, incx::Int64,
                                                         stridex::Clonglong,
                                                         beta::RefOrCuRef{Cdouble},
                                                         y::CuPtr{Cdouble}, incy::Int64,
                                                         stridey::Clonglong,
                                                         batchCount::Int64)::cublasStatus_t
end

@checked function cublasCgemvStridedBatched(handle, trans, m, n, alpha, A, lda, strideA, x,
                                            incx, stridex, beta, y, incy, stridey,
                                            batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemvStridedBatched(handle::cublasHandle_t,
                                                      trans::cublasOperation_t, m::Cint,
                                                      n::Cint, alpha::RefOrCuRef{cuComplex},
                                                      A::CuPtr{cuComplex}, lda::Cint,
                                                      strideA::Clonglong,
                                                      x::CuPtr{cuComplex}, incx::Cint,
                                                      stridex::Clonglong,
                                                      beta::RefOrCuRef{cuComplex},
                                                      y::CuPtr{cuComplex}, incy::Cint,
                                                      stridey::Clonglong,
                                                      batchCount::Cint)::cublasStatus_t
end

@checked function cublasCgemvStridedBatched_64(handle, trans, m, n, alpha, A, lda, strideA,
                                               x, incx, stridex, beta, y, incy, stridey,
                                               batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemvStridedBatched_64(handle::cublasHandle_t,
                                                         trans::cublasOperation_t, m::Int64,
                                                         n::Int64,
                                                         alpha::RefOrCuRef{cuComplex},
                                                         A::CuPtr{cuComplex}, lda::Int64,
                                                         strideA::Clonglong,
                                                         x::CuPtr{cuComplex}, incx::Int64,
                                                         stridex::Clonglong,
                                                         beta::RefOrCuRef{cuComplex},
                                                         y::CuPtr{cuComplex}, incy::Int64,
                                                         stridey::Clonglong,
                                                         batchCount::Int64)::cublasStatus_t
end

@checked function cublasZgemvStridedBatched(handle, trans, m, n, alpha, A, lda, strideA, x,
                                            incx, stridex, beta, y, incy, stridey,
                                            batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemvStridedBatched(handle::cublasHandle_t,
                                                      trans::cublasOperation_t, m::Cint,
                                                      n::Cint,
                                                      alpha::RefOrCuRef{cuDoubleComplex},
                                                      A::CuPtr{cuDoubleComplex}, lda::Cint,
                                                      strideA::Clonglong,
                                                      x::CuPtr{cuDoubleComplex}, incx::Cint,
                                                      stridex::Clonglong,
                                                      beta::RefOrCuRef{cuDoubleComplex},
                                                      y::CuPtr{cuDoubleComplex}, incy::Cint,
                                                      stridey::Clonglong,
                                                      batchCount::Cint)::cublasStatus_t
end

@checked function cublasZgemvStridedBatched_64(handle, trans, m, n, alpha, A, lda, strideA,
                                               x, incx, stridex, beta, y, incy, stridey,
                                               batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemvStridedBatched_64(handle::cublasHandle_t,
                                                         trans::cublasOperation_t, m::Int64,
                                                         n::Int64,
                                                         alpha::RefOrCuRef{cuDoubleComplex},
                                                         A::CuPtr{cuDoubleComplex},
                                                         lda::Int64, strideA::Clonglong,
                                                         x::CuPtr{cuDoubleComplex},
                                                         incx::Int64, stridex::Clonglong,
                                                         beta::RefOrCuRef{cuDoubleComplex},
                                                         y::CuPtr{cuDoubleComplex},
                                                         incy::Int64, stridey::Clonglong,
                                                         batchCount::Int64)::cublasStatus_t
end

@checked function cublasCgemm3m(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm3m(handle::cublasHandle_t, transa::cublasOperation_t,
                                          transb::cublasOperation_t, m::Cint, n::Cint,
                                          k::Cint, alpha::RefOrCuRef{cuComplex},
                                          A::CuPtr{cuComplex}, lda::Cint,
                                          B::CuPtr{cuComplex}, ldb::Cint,
                                          beta::RefOrCuRef{cuComplex}, C::CuPtr{cuComplex},
                                          ldc::Cint)::cublasStatus_t
end

@checked function cublasCgemm3m_64(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                   beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm3m_64(handle::cublasHandle_t,
                                             transa::cublasOperation_t,
                                             transb::cublasOperation_t, m::Int64, n::Int64,
                                             k::Int64, alpha::RefOrCuRef{cuComplex},
                                             A::CuPtr{cuComplex}, lda::Int64,
                                             B::CuPtr{cuComplex}, ldb::Int64,
                                             beta::RefOrCuRef{cuComplex},
                                             C::CuPtr{cuComplex},
                                             ldc::Int64)::cublasStatus_t
end

@checked function cublasCgemm3mEx(handle, transa, transb, m, n, k, alpha, A, Atype, lda, B,
                                  Btype, ldb, beta, C, Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm3mEx(handle::cublasHandle_t,
                                            transa::cublasOperation_t,
                                            transb::cublasOperation_t, m::Cint, n::Cint,
                                            k::Cint, alpha::RefOrCuRef{cuComplex},
                                            A::CuPtr{Cvoid}, Atype::cudaDataType, lda::Cint,
                                            B::CuPtr{Cvoid}, Btype::cudaDataType, ldb::Cint,
                                            beta::RefOrCuRef{cuComplex}, C::CuPtr{Cvoid},
                                            Ctype::cudaDataType, ldc::Cint)::cublasStatus_t
end

@checked function cublasCgemm3mEx_64(handle, transa, transb, m, n, k, alpha, A, Atype, lda,
                                     B, Btype, ldb, beta, C, Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm3mEx_64(handle::cublasHandle_t,
                                               transa::cublasOperation_t,
                                               transb::cublasOperation_t, m::Int64,
                                               n::Int64, k::Int64,
                                               alpha::RefOrCuRef{cuComplex},
                                               A::CuPtr{Cvoid}, Atype::cudaDataType,
                                               lda::Int64, B::CuPtr{Cvoid},
                                               Btype::cudaDataType, ldb::Int64,
                                               beta::RefOrCuRef{cuComplex}, C::CuPtr{Cvoid},
                                               Ctype::cudaDataType,
                                               ldc::Int64)::cublasStatus_t
end

@checked function cublasZgemm3m(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemm3m(handle::cublasHandle_t, transa::cublasOperation_t,
                                          transb::cublasOperation_t, m::Cint, n::Cint,
                                          k::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                          A::CuPtr{cuDoubleComplex}, lda::Cint,
                                          B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                          beta::RefOrCuRef{cuDoubleComplex},
                                          C::CuPtr{cuDoubleComplex},
                                          ldc::Cint)::cublasStatus_t
end

@checked function cublasZgemm3m_64(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                   beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemm3m_64(handle::cublasHandle_t,
                                             transa::cublasOperation_t,
                                             transb::cublasOperation_t, m::Int64, n::Int64,
                                             k::Int64, alpha::RefOrCuRef{cuDoubleComplex},
                                             A::CuPtr{cuDoubleComplex}, lda::Int64,
                                             B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                             beta::RefOrCuRef{cuDoubleComplex},
                                             C::CuPtr{cuDoubleComplex},
                                             ldc::Int64)::cublasStatus_t
end

@checked function cublasSgemmEx(handle, transa, transb, m, n, k, alpha, A, Atype, lda, B,
                                Btype, ldb, beta, C, Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemmEx(handle::cublasHandle_t, transa::cublasOperation_t,
                                          transb::cublasOperation_t, m::Cint, n::Cint,
                                          k::Cint, alpha::RefOrCuRef{Cfloat},
                                          A::CuPtr{Cvoid}, Atype::cudaDataType, lda::Cint,
                                          B::CuPtr{Cvoid}, Btype::cudaDataType, ldb::Cint,
                                          beta::RefOrCuRef{Cfloat}, C::CuPtr{Cvoid},
                                          Ctype::cudaDataType, ldc::Cint)::cublasStatus_t
end

@checked function cublasSgemmEx_64(handle, transa, transb, m, n, k, alpha, A, Atype, lda, B,
                                   Btype, ldb, beta, C, Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemmEx_64(handle::cublasHandle_t,
                                             transa::cublasOperation_t,
                                             transb::cublasOperation_t, m::Int64, n::Int64,
                                             k::Int64, alpha::RefOrCuRef{Cfloat},
                                             A::CuPtr{Cvoid}, Atype::cudaDataType,
                                             lda::Int64, B::CuPtr{Cvoid},
                                             Btype::cudaDataType, ldb::Int64,
                                             beta::RefOrCuRef{Cfloat}, C::CuPtr{Cvoid},
                                             Ctype::cudaDataType,
                                             ldc::Int64)::cublasStatus_t
end

@checked function cublasGemmEx(handle, transa, transb, m, n, k, alpha, A, Atype, lda, B,
                               Btype, ldb, beta, C, Ctype, ldc, computeType, algo)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGemmEx(handle::cublasHandle_t, transa::cublasOperation_t,
                                         transb::cublasOperation_t, m::Cint, n::Cint,
                                         k::Cint, alpha::PtrOrCuPtr{Cvoid}, A::CuPtr{Cvoid},
                                         Atype::cudaDataType, lda::Cint, B::CuPtr{Cvoid},
                                         Btype::cudaDataType, ldb::Cint,
                                         beta::PtrOrCuPtr{Cvoid}, C::CuPtr{Cvoid},
                                         Ctype::cudaDataType, ldc::Cint,
                                         computeType::cublasComputeType_t,
                                         algo::cublasGemmAlgo_t)::cublasStatus_t
end

@checked function cublasGemmEx_64(handle, transa, transb, m, n, k, alpha, A, Atype, lda, B,
                                  Btype, ldb, beta, C, Ctype, ldc, computeType, algo)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGemmEx_64(handle::cublasHandle_t,
                                            transa::cublasOperation_t,
                                            transb::cublasOperation_t, m::Int64, n::Int64,
                                            k::Int64, alpha::PtrOrCuPtr{Cvoid},
                                            A::CuPtr{Cvoid}, Atype::cudaDataType,
                                            lda::Int64, B::CuPtr{Cvoid},
                                            Btype::cudaDataType, ldb::Int64,
                                            beta::PtrOrCuPtr{Cvoid}, C::CuPtr{Cvoid},
                                            Ctype::cudaDataType, ldc::Int64,
                                            computeType::cublasComputeType_t,
                                            algo::cublasGemmAlgo_t)::cublasStatus_t
end

@checked function cublasCgemmEx(handle, transa, transb, m, n, k, alpha, A, Atype, lda, B,
                                Btype, ldb, beta, C, Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemmEx(handle::cublasHandle_t, transa::cublasOperation_t,
                                          transb::cublasOperation_t, m::Cint, n::Cint,
                                          k::Cint, alpha::RefOrCuRef{cuComplex},
                                          A::CuPtr{Cvoid}, Atype::cudaDataType, lda::Cint,
                                          B::CuPtr{Cvoid}, Btype::cudaDataType, ldb::Cint,
                                          beta::RefOrCuRef{cuComplex}, C::CuPtr{Cvoid},
                                          Ctype::cudaDataType, ldc::Cint)::cublasStatus_t
end

@checked function cublasCgemmEx_64(handle, transa, transb, m, n, k, alpha, A, Atype, lda, B,
                                   Btype, ldb, beta, C, Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemmEx_64(handle::cublasHandle_t,
                                             transa::cublasOperation_t,
                                             transb::cublasOperation_t, m::Int64, n::Int64,
                                             k::Int64, alpha::RefOrCuRef{cuComplex},
                                             A::CuPtr{Cvoid}, Atype::cudaDataType,
                                             lda::Int64, B::CuPtr{Cvoid},
                                             Btype::cudaDataType, ldb::Int64,
                                             beta::RefOrCuRef{cuComplex}, C::CuPtr{Cvoid},
                                             Ctype::cudaDataType,
                                             ldc::Int64)::cublasStatus_t
end

@checked function cublasCsyrkEx(handle, uplo, trans, n, k, alpha, A, Atype, lda, beta, C,
                                Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyrkEx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          trans::cublasOperation_t, n::Cint, k::Cint,
                                          alpha::RefOrCuRef{cuComplex}, A::CuPtr{Cvoid},
                                          Atype::cudaDataType, lda::Cint,
                                          beta::RefOrCuRef{cuComplex}, C::CuPtr{Cvoid},
                                          Ctype::cudaDataType, ldc::Cint)::cublasStatus_t
end

@checked function cublasCsyrkEx_64(handle, uplo, trans, n, k, alpha, A, Atype, lda, beta, C,
                                   Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyrkEx_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             trans::cublasOperation_t, n::Int64, k::Int64,
                                             alpha::RefOrCuRef{cuComplex}, A::CuPtr{Cvoid},
                                             Atype::cudaDataType, lda::Int64,
                                             beta::RefOrCuRef{cuComplex}, C::CuPtr{Cvoid},
                                             Ctype::cudaDataType,
                                             ldc::Int64)::cublasStatus_t
end

@checked function cublasCsyrk3mEx(handle, uplo, trans, n, k, alpha, A, Atype, lda, beta, C,
                                  Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyrk3mEx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Cint, k::Cint,
                                            alpha::RefOrCuRef{cuComplex}, A::CuPtr{Cvoid},
                                            Atype::cudaDataType, lda::Cint,
                                            beta::RefOrCuRef{cuComplex}, C::CuPtr{Cvoid},
                                            Ctype::cudaDataType, ldc::Cint)::cublasStatus_t
end

@checked function cublasCsyrk3mEx_64(handle, uplo, trans, n, k, alpha, A, Atype, lda, beta,
                                     C, Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyrk3mEx_64(handle::cublasHandle_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t, n::Int64, k::Int64,
                                               alpha::RefOrCuRef{cuComplex},
                                               A::CuPtr{Cvoid}, Atype::cudaDataType,
                                               lda::Int64, beta::RefOrCuRef{cuComplex},
                                               C::CuPtr{Cvoid}, Ctype::cudaDataType,
                                               ldc::Int64)::cublasStatus_t
end

@checked function cublasCherkEx(handle, uplo, trans, n, k, alpha, A, Atype, lda, beta, C,
                                Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCherkEx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                          trans::cublasOperation_t, n::Cint, k::Cint,
                                          alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cvoid},
                                          Atype::cudaDataType, lda::Cint,
                                          beta::RefOrCuRef{Cfloat}, C::CuPtr{Cvoid},
                                          Ctype::cudaDataType, ldc::Cint)::cublasStatus_t
end

@checked function cublasCherkEx_64(handle, uplo, trans, n, k, alpha, A, Atype, lda, beta, C,
                                   Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCherkEx_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                             trans::cublasOperation_t, n::Int64, k::Int64,
                                             alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cvoid},
                                             Atype::cudaDataType, lda::Int64,
                                             beta::RefOrCuRef{Cfloat}, C::CuPtr{Cvoid},
                                             Ctype::cudaDataType,
                                             ldc::Int64)::cublasStatus_t
end

@checked function cublasCherk3mEx(handle, uplo, trans, n, k, alpha, A, Atype, lda, beta, C,
                                  Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCherk3mEx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Cint, k::Cint,
                                            alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cvoid},
                                            Atype::cudaDataType, lda::Cint,
                                            beta::RefOrCuRef{Cfloat}, C::CuPtr{Cvoid},
                                            Ctype::cudaDataType, ldc::Cint)::cublasStatus_t
end

@checked function cublasCherk3mEx_64(handle, uplo, trans, n, k, alpha, A, Atype, lda, beta,
                                     C, Ctype, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCherk3mEx_64(handle::cublasHandle_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t, n::Int64, k::Int64,
                                               alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cvoid},
                                               Atype::cudaDataType, lda::Int64,
                                               beta::RefOrCuRef{Cfloat}, C::CuPtr{Cvoid},
                                               Ctype::cudaDataType,
                                               ldc::Int64)::cublasStatus_t
end

@checked function cublasSsyrkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                               ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyrkx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         trans::cublasOperation_t, n::Cint, k::Cint,
                                         alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                         lda::Cint, B::CuPtr{Cfloat}, ldb::Cint,
                                         beta::RefOrCuRef{Cfloat}, C::CuPtr{Cfloat},
                                         ldc::Cint)::cublasStatus_t
end

@checked function cublasSsyrkx_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSsyrkx_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Int64, k::Int64,
                                            alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                            lda::Int64, B::CuPtr{Cfloat}, ldb::Int64,
                                            beta::RefOrCuRef{Cfloat}, C::CuPtr{Cfloat},
                                            ldc::Int64)::cublasStatus_t
end

@checked function cublasDsyrkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                               ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyrkx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         trans::cublasOperation_t, n::Cint, k::Cint,
                                         alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                         lda::Cint, B::CuPtr{Cdouble}, ldb::Cint,
                                         beta::RefOrCuRef{Cdouble}, C::CuPtr{Cdouble},
                                         ldc::Cint)::cublasStatus_t
end

@checked function cublasDsyrkx_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDsyrkx_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Int64, k::Int64,
                                            alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                            lda::Int64, B::CuPtr{Cdouble}, ldb::Int64,
                                            beta::RefOrCuRef{Cdouble}, C::CuPtr{Cdouble},
                                            ldc::Int64)::cublasStatus_t
end

@checked function cublasCsyrkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                               ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyrkx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         trans::cublasOperation_t, n::Cint, k::Cint,
                                         alpha::RefOrCuRef{cuComplex}, A::CuPtr{cuComplex},
                                         lda::Cint, B::CuPtr{cuComplex}, ldb::Cint,
                                         beta::RefOrCuRef{cuComplex}, C::CuPtr{cuComplex},
                                         ldc::Cint)::cublasStatus_t
end

@checked function cublasCsyrkx_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCsyrkx_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Int64, k::Int64,
                                            alpha::RefOrCuRef{cuComplex},
                                            A::CuPtr{cuComplex}, lda::Int64,
                                            B::CuPtr{cuComplex}, ldb::Int64,
                                            beta::RefOrCuRef{cuComplex},
                                            C::CuPtr{cuComplex}, ldc::Int64)::cublasStatus_t
end

@checked function cublasZsyrkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                               ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyrkx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         trans::cublasOperation_t, n::Cint, k::Cint,
                                         alpha::RefOrCuRef{cuDoubleComplex},
                                         A::CuPtr{cuDoubleComplex}, lda::Cint,
                                         B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                         beta::RefOrCuRef{cuDoubleComplex},
                                         C::CuPtr{cuDoubleComplex},
                                         ldc::Cint)::cublasStatus_t
end

@checked function cublasZsyrkx_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZsyrkx_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Int64, k::Int64,
                                            alpha::RefOrCuRef{cuDoubleComplex},
                                            A::CuPtr{cuDoubleComplex}, lda::Int64,
                                            B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                            beta::RefOrCuRef{cuDoubleComplex},
                                            C::CuPtr{cuDoubleComplex},
                                            ldc::Int64)::cublasStatus_t
end

@checked function cublasCherkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                               ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCherkx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         trans::cublasOperation_t, n::Cint, k::Cint,
                                         alpha::RefOrCuRef{cuComplex}, A::CuPtr{cuComplex},
                                         lda::Cint, B::CuPtr{cuComplex}, ldb::Cint,
                                         beta::RefOrCuRef{Cfloat}, C::CuPtr{cuComplex},
                                         ldc::Cint)::cublasStatus_t
end

@checked function cublasCherkx_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCherkx_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Int64, k::Int64,
                                            alpha::RefOrCuRef{cuComplex},
                                            A::CuPtr{cuComplex}, lda::Int64,
                                            B::CuPtr{cuComplex}, ldb::Int64,
                                            beta::RefOrCuRef{Cfloat}, C::CuPtr{cuComplex},
                                            ldc::Int64)::cublasStatus_t
end

@checked function cublasZherkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                               ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZherkx(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         trans::cublasOperation_t, n::Cint, k::Cint,
                                         alpha::RefOrCuRef{cuDoubleComplex},
                                         A::CuPtr{cuDoubleComplex}, lda::Cint,
                                         B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                         beta::RefOrCuRef{Cdouble},
                                         C::CuPtr{cuDoubleComplex},
                                         ldc::Cint)::cublasStatus_t
end

@checked function cublasZherkx_64(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                  ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZherkx_64(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                            trans::cublasOperation_t, n::Int64, k::Int64,
                                            alpha::RefOrCuRef{cuDoubleComplex},
                                            A::CuPtr{cuDoubleComplex}, lda::Int64,
                                            B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                            beta::RefOrCuRef{Cdouble},
                                            C::CuPtr{cuDoubleComplex},
                                            ldc::Int64)::cublasStatus_t
end

@checked function cublasSgemmBatched(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                     Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemmBatched(handle::cublasHandle_t,
                                               transa::cublasOperation_t,
                                               transb::cublasOperation_t, m::Cint, n::Cint,
                                               k::Cint, alpha::RefOrCuRef{Cfloat},
                                               Aarray::CuPtr{Ptr{Cfloat}}, lda::Cint,
                                               Barray::CuPtr{Ptr{Cfloat}}, ldb::Cint,
                                               beta::RefOrCuRef{Cfloat},
                                               Carray::CuPtr{Ptr{Cfloat}}, ldc::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasSgemmBatched_64(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                        Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemmBatched_64(handle::cublasHandle_t,
                                                  transa::cublasOperation_t,
                                                  transb::cublasOperation_t, m::Int64,
                                                  n::Int64, k::Int64,
                                                  alpha::RefOrCuRef{Cfloat},
                                                  Aarray::CuPtr{Ptr{Cfloat}}, lda::Int64,
                                                  Barray::CuPtr{Ptr{Cfloat}}, ldb::Int64,
                                                  beta::RefOrCuRef{Cfloat},
                                                  Carray::CuPtr{Ptr{Cfloat}}, ldc::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasDgemmBatched(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                     Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemmBatched(handle::cublasHandle_t,
                                               transa::cublasOperation_t,
                                               transb::cublasOperation_t, m::Cint, n::Cint,
                                               k::Cint, alpha::RefOrCuRef{Cdouble},
                                               Aarray::CuPtr{Ptr{Cdouble}}, lda::Cint,
                                               Barray::CuPtr{Ptr{Cdouble}}, ldb::Cint,
                                               beta::RefOrCuRef{Cdouble},
                                               Carray::CuPtr{Ptr{Cdouble}}, ldc::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasDgemmBatched_64(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                        Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemmBatched_64(handle::cublasHandle_t,
                                                  transa::cublasOperation_t,
                                                  transb::cublasOperation_t, m::Int64,
                                                  n::Int64, k::Int64,
                                                  alpha::RefOrCuRef{Cdouble},
                                                  Aarray::CuPtr{Ptr{Cdouble}}, lda::Int64,
                                                  Barray::CuPtr{Ptr{Cdouble}}, ldb::Int64,
                                                  beta::RefOrCuRef{Cdouble},
                                                  Carray::CuPtr{Ptr{Cdouble}}, ldc::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasCgemmBatched(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                     Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemmBatched(handle::cublasHandle_t,
                                               transa::cublasOperation_t,
                                               transb::cublasOperation_t, m::Cint, n::Cint,
                                               k::Cint, alpha::RefOrCuRef{cuComplex},
                                               Aarray::CuPtr{Ptr{cuComplex}}, lda::Cint,
                                               Barray::CuPtr{Ptr{cuComplex}}, ldb::Cint,
                                               beta::RefOrCuRef{cuComplex},
                                               Carray::CuPtr{Ptr{cuComplex}}, ldc::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasCgemmBatched_64(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                        Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemmBatched_64(handle::cublasHandle_t,
                                                  transa::cublasOperation_t,
                                                  transb::cublasOperation_t, m::Int64,
                                                  n::Int64, k::Int64,
                                                  alpha::RefOrCuRef{cuComplex},
                                                  Aarray::CuPtr{Ptr{cuComplex}}, lda::Int64,
                                                  Barray::CuPtr{Ptr{cuComplex}}, ldb::Int64,
                                                  beta::RefOrCuRef{cuComplex},
                                                  Carray::CuPtr{Ptr{cuComplex}}, ldc::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasCgemm3mBatched(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                       Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm3mBatched(handle::cublasHandle_t,
                                                 transa::cublasOperation_t,
                                                 transb::cublasOperation_t, m::Cint,
                                                 n::Cint, k::Cint,
                                                 alpha::RefOrCuRef{cuComplex},
                                                 Aarray::CuPtr{Ptr{cuComplex}}, lda::Cint,
                                                 Barray::CuPtr{Ptr{cuComplex}}, ldb::Cint,
                                                 beta::RefOrCuRef{cuComplex},
                                                 Carray::CuPtr{Ptr{cuComplex}}, ldc::Cint,
                                                 batchCount::Cint)::cublasStatus_t
end

@checked function cublasCgemm3mBatched_64(handle, transa, transb, m, n, k, alpha, Aarray,
                                          lda, Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm3mBatched_64(handle::cublasHandle_t,
                                                    transa::cublasOperation_t,
                                                    transb::cublasOperation_t, m::Int64,
                                                    n::Int64, k::Int64,
                                                    alpha::RefOrCuRef{cuComplex},
                                                    Aarray::CuPtr{Ptr{cuComplex}},
                                                    lda::Int64,
                                                    Barray::CuPtr{Ptr{cuComplex}},
                                                    ldb::Int64, beta::RefOrCuRef{cuComplex},
                                                    Carray::CuPtr{Ptr{cuComplex}},
                                                    ldc::Int64,
                                                    batchCount::Int64)::cublasStatus_t
end

@checked function cublasZgemmBatched(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                     Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemmBatched(handle::cublasHandle_t,
                                               transa::cublasOperation_t,
                                               transb::cublasOperation_t, m::Cint, n::Cint,
                                               k::Cint, alpha::RefOrCuRef{cuDoubleComplex},
                                               Aarray::CuPtr{Ptr{cuDoubleComplex}},
                                               lda::Cint,
                                               Barray::CuPtr{Ptr{cuDoubleComplex}},
                                               ldb::Cint, beta::RefOrCuRef{cuDoubleComplex},
                                               Carray::CuPtr{Ptr{cuDoubleComplex}},
                                               ldc::Cint, batchCount::Cint)::cublasStatus_t
end

@checked function cublasZgemmBatched_64(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                        Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemmBatched_64(handle::cublasHandle_t,
                                                  transa::cublasOperation_t,
                                                  transb::cublasOperation_t, m::Int64,
                                                  n::Int64, k::Int64,
                                                  alpha::RefOrCuRef{cuDoubleComplex},
                                                  Aarray::CuPtr{Ptr{cuDoubleComplex}},
                                                  lda::Int64,
                                                  Barray::CuPtr{Ptr{cuDoubleComplex}},
                                                  ldb::Int64,
                                                  beta::RefOrCuRef{cuDoubleComplex},
                                                  Carray::CuPtr{Ptr{cuDoubleComplex}},
                                                  ldc::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasSgemmStridedBatched(handle, transa, transb, m, n, k, alpha, A, lda,
                                            strideA, B, ldb, strideB, beta, C, ldc, strideC,
                                            batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemmStridedBatched(handle::cublasHandle_t,
                                                      transa::cublasOperation_t,
                                                      transb::cublasOperation_t, m::Cint,
                                                      n::Cint, k::Cint,
                                                      alpha::RefOrCuRef{Cfloat},
                                                      A::CuPtr{Cfloat}, lda::Cint,
                                                      strideA::Clonglong, B::CuPtr{Cfloat},
                                                      ldb::Cint, strideB::Clonglong,
                                                      beta::RefOrCuRef{Cfloat},
                                                      C::CuPtr{Cfloat}, ldc::Cint,
                                                      strideC::Clonglong,
                                                      batchCount::Cint)::cublasStatus_t
end

@checked function cublasSgemmStridedBatched_64(handle, transa, transb, m, n, k, alpha, A,
                                               lda, strideA, B, ldb, strideB, beta, C, ldc,
                                               strideC, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemmStridedBatched_64(handle::cublasHandle_t,
                                                         transa::cublasOperation_t,
                                                         transb::cublasOperation_t,
                                                         m::Int64, n::Int64, k::Int64,
                                                         alpha::RefOrCuRef{Cfloat},
                                                         A::CuPtr{Cfloat}, lda::Int64,
                                                         strideA::Clonglong,
                                                         B::CuPtr{Cfloat}, ldb::Int64,
                                                         strideB::Clonglong,
                                                         beta::RefOrCuRef{Cfloat},
                                                         C::CuPtr{Cfloat}, ldc::Int64,
                                                         strideC::Clonglong,
                                                         batchCount::Int64)::cublasStatus_t
end

@checked function cublasDgemmStridedBatched(handle, transa, transb, m, n, k, alpha, A, lda,
                                            strideA, B, ldb, strideB, beta, C, ldc, strideC,
                                            batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemmStridedBatched(handle::cublasHandle_t,
                                                      transa::cublasOperation_t,
                                                      transb::cublasOperation_t, m::Cint,
                                                      n::Cint, k::Cint,
                                                      alpha::RefOrCuRef{Cdouble},
                                                      A::CuPtr{Cdouble}, lda::Cint,
                                                      strideA::Clonglong, B::CuPtr{Cdouble},
                                                      ldb::Cint, strideB::Clonglong,
                                                      beta::RefOrCuRef{Cdouble},
                                                      C::CuPtr{Cdouble}, ldc::Cint,
                                                      strideC::Clonglong,
                                                      batchCount::Cint)::cublasStatus_t
end

@checked function cublasDgemmStridedBatched_64(handle, transa, transb, m, n, k, alpha, A,
                                               lda, strideA, B, ldb, strideB, beta, C, ldc,
                                               strideC, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemmStridedBatched_64(handle::cublasHandle_t,
                                                         transa::cublasOperation_t,
                                                         transb::cublasOperation_t,
                                                         m::Int64, n::Int64, k::Int64,
                                                         alpha::RefOrCuRef{Cdouble},
                                                         A::CuPtr{Cdouble}, lda::Int64,
                                                         strideA::Clonglong,
                                                         B::CuPtr{Cdouble}, ldb::Int64,
                                                         strideB::Clonglong,
                                                         beta::RefOrCuRef{Cdouble},
                                                         C::CuPtr{Cdouble}, ldc::Int64,
                                                         strideC::Clonglong,
                                                         batchCount::Int64)::cublasStatus_t
end

@checked function cublasCgemmStridedBatched(handle, transa, transb, m, n, k, alpha, A, lda,
                                            strideA, B, ldb, strideB, beta, C, ldc, strideC,
                                            batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemmStridedBatched(handle::cublasHandle_t,
                                                      transa::cublasOperation_t,
                                                      transb::cublasOperation_t, m::Cint,
                                                      n::Cint, k::Cint,
                                                      alpha::RefOrCuRef{cuComplex},
                                                      A::CuPtr{cuComplex}, lda::Cint,
                                                      strideA::Clonglong,
                                                      B::CuPtr{cuComplex}, ldb::Cint,
                                                      strideB::Clonglong,
                                                      beta::RefOrCuRef{cuComplex},
                                                      C::CuPtr{cuComplex}, ldc::Cint,
                                                      strideC::Clonglong,
                                                      batchCount::Cint)::cublasStatus_t
end

@checked function cublasCgemmStridedBatched_64(handle, transa, transb, m, n, k, alpha, A,
                                               lda, strideA, B, ldb, strideB, beta, C, ldc,
                                               strideC, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemmStridedBatched_64(handle::cublasHandle_t,
                                                         transa::cublasOperation_t,
                                                         transb::cublasOperation_t,
                                                         m::Int64, n::Int64, k::Int64,
                                                         alpha::RefOrCuRef{cuComplex},
                                                         A::CuPtr{cuComplex}, lda::Int64,
                                                         strideA::Clonglong,
                                                         B::CuPtr{cuComplex}, ldb::Int64,
                                                         strideB::Clonglong,
                                                         beta::RefOrCuRef{cuComplex},
                                                         C::CuPtr{cuComplex}, ldc::Int64,
                                                         strideC::Clonglong,
                                                         batchCount::Int64)::cublasStatus_t
end

@checked function cublasCgemm3mStridedBatched(handle, transa, transb, m, n, k, alpha, A,
                                              lda, strideA, B, ldb, strideB, beta, C, ldc,
                                              strideC, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm3mStridedBatched(handle::cublasHandle_t,
                                                        transa::cublasOperation_t,
                                                        transb::cublasOperation_t, m::Cint,
                                                        n::Cint, k::Cint,
                                                        alpha::RefOrCuRef{cuComplex},
                                                        A::CuPtr{cuComplex}, lda::Cint,
                                                        strideA::Clonglong,
                                                        B::CuPtr{cuComplex}, ldb::Cint,
                                                        strideB::Clonglong,
                                                        beta::RefOrCuRef{cuComplex},
                                                        C::CuPtr{cuComplex}, ldc::Cint,
                                                        strideC::Clonglong,
                                                        batchCount::Cint)::cublasStatus_t
end

@checked function cublasCgemm3mStridedBatched_64(handle, transa, transb, m, n, k, alpha, A,
                                                 lda, strideA, B, ldb, strideB, beta, C,
                                                 ldc, strideC, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgemm3mStridedBatched_64(handle::cublasHandle_t,
                                                           transa::cublasOperation_t,
                                                           transb::cublasOperation_t,
                                                           m::Int64, n::Int64, k::Int64,
                                                           alpha::RefOrCuRef{cuComplex},
                                                           A::CuPtr{cuComplex}, lda::Int64,
                                                           strideA::Clonglong,
                                                           B::CuPtr{cuComplex}, ldb::Int64,
                                                           strideB::Clonglong,
                                                           beta::RefOrCuRef{cuComplex},
                                                           C::CuPtr{cuComplex}, ldc::Int64,
                                                           strideC::Clonglong,
                                                           batchCount::Int64)::cublasStatus_t
end

@checked function cublasZgemmStridedBatched(handle, transa, transb, m, n, k, alpha, A, lda,
                                            strideA, B, ldb, strideB, beta, C, ldc, strideC,
                                            batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemmStridedBatched(handle::cublasHandle_t,
                                                      transa::cublasOperation_t,
                                                      transb::cublasOperation_t, m::Cint,
                                                      n::Cint, k::Cint,
                                                      alpha::RefOrCuRef{cuDoubleComplex},
                                                      A::CuPtr{cuDoubleComplex}, lda::Cint,
                                                      strideA::Clonglong,
                                                      B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                                      strideB::Clonglong,
                                                      beta::RefOrCuRef{cuDoubleComplex},
                                                      C::CuPtr{cuDoubleComplex}, ldc::Cint,
                                                      strideC::Clonglong,
                                                      batchCount::Cint)::cublasStatus_t
end

@checked function cublasZgemmStridedBatched_64(handle, transa, transb, m, n, k, alpha, A,
                                               lda, strideA, B, ldb, strideB, beta, C, ldc,
                                               strideC, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgemmStridedBatched_64(handle::cublasHandle_t,
                                                         transa::cublasOperation_t,
                                                         transb::cublasOperation_t,
                                                         m::Int64, n::Int64, k::Int64,
                                                         alpha::RefOrCuRef{cuDoubleComplex},
                                                         A::CuPtr{cuDoubleComplex},
                                                         lda::Int64, strideA::Clonglong,
                                                         B::CuPtr{cuDoubleComplex},
                                                         ldb::Int64, strideB::Clonglong,
                                                         beta::RefOrCuRef{cuDoubleComplex},
                                                         C::CuPtr{cuDoubleComplex},
                                                         ldc::Int64, strideC::Clonglong,
                                                         batchCount::Int64)::cublasStatus_t
end

@checked function cublasGemmBatchedEx(handle, transa, transb, m, n, k, alpha, Aarray, Atype,
                                      lda, Barray, Btype, ldb, beta, Carray, Ctype, ldc,
                                      batchCount, computeType, algo)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGemmBatchedEx(handle::cublasHandle_t,
                                                transa::cublasOperation_t,
                                                transb::cublasOperation_t, m::Cint, n::Cint,
                                                k::Cint, alpha::PtrOrCuPtr{Cvoid},
                                                Aarray::CuPtr{Ptr{Cvoid}},
                                                Atype::cudaDataType, lda::Cint,
                                                Barray::CuPtr{Ptr{Cvoid}},
                                                Btype::cudaDataType, ldb::Cint,
                                                beta::PtrOrCuPtr{Cvoid},
                                                Carray::CuPtr{Ptr{Cvoid}},
                                                Ctype::cudaDataType, ldc::Cint,
                                                batchCount::Cint,
                                                computeType::cublasComputeType_t,
                                                algo::cublasGemmAlgo_t)::cublasStatus_t
end

@checked function cublasGemmBatchedEx_64(handle, transa, transb, m, n, k, alpha, Aarray,
                                         Atype, lda, Barray, Btype, ldb, beta, Carray,
                                         Ctype, ldc, batchCount, computeType, algo)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGemmBatchedEx_64(handle::cublasHandle_t,
                                                   transa::cublasOperation_t,
                                                   transb::cublasOperation_t, m::Int64,
                                                   n::Int64, k::Int64,
                                                   alpha::PtrOrCuPtr{Cvoid},
                                                   Aarray::CuPtr{Ptr{Cvoid}},
                                                   Atype::cudaDataType, lda::Int64,
                                                   Barray::CuPtr{Ptr{Cvoid}},
                                                   Btype::cudaDataType, ldb::Int64,
                                                   beta::PtrOrCuPtr{Cvoid},
                                                   Carray::CuPtr{Ptr{Cvoid}},
                                                   Ctype::cudaDataType, ldc::Int64,
                                                   batchCount::Int64,
                                                   computeType::cublasComputeType_t,
                                                   algo::cublasGemmAlgo_t)::cublasStatus_t
end

@checked function cublasGemmStridedBatchedEx(handle, transa, transb, m, n, k, alpha, A,
                                             Atype, lda, strideA, B, Btype, ldb, strideB,
                                             beta, C, Ctype, ldc, strideC, batchCount,
                                             computeType, algo)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGemmStridedBatchedEx(handle::cublasHandle_t,
                                                       transa::cublasOperation_t,
                                                       transb::cublasOperation_t, m::Cint,
                                                       n::Cint, k::Cint,
                                                       alpha::PtrOrCuPtr{Cvoid},
                                                       A::CuPtr{Cvoid}, Atype::cudaDataType,
                                                       lda::Cint, strideA::Clonglong,
                                                       B::CuPtr{Cvoid}, Btype::cudaDataType,
                                                       ldb::Cint, strideB::Clonglong,
                                                       beta::PtrOrCuPtr{Cvoid},
                                                       C::CuPtr{Cvoid}, Ctype::cudaDataType,
                                                       ldc::Cint, strideC::Clonglong,
                                                       batchCount::Cint,
                                                       computeType::cublasComputeType_t,
                                                       algo::cublasGemmAlgo_t)::cublasStatus_t
end

@checked function cublasGemmStridedBatchedEx_64(handle, transa, transb, m, n, k, alpha, A,
                                                Atype, lda, strideA, B, Btype, ldb, strideB,
                                                beta, C, Ctype, ldc, strideC, batchCount,
                                                computeType, algo)
    initialize_context()
    @gcsafe_ccall libcublas.cublasGemmStridedBatchedEx_64(handle::cublasHandle_t,
                                                          transa::cublasOperation_t,
                                                          transb::cublasOperation_t,
                                                          m::Int64, n::Int64, k::Int64,
                                                          alpha::PtrOrCuPtr{Cvoid},
                                                          A::CuPtr{Cvoid},
                                                          Atype::cudaDataType, lda::Int64,
                                                          strideA::Clonglong,
                                                          B::CuPtr{Cvoid},
                                                          Btype::cudaDataType, ldb::Int64,
                                                          strideB::Clonglong,
                                                          beta::PtrOrCuPtr{Cvoid},
                                                          C::CuPtr{Cvoid},
                                                          Ctype::cudaDataType, ldc::Int64,
                                                          strideC::Clonglong,
                                                          batchCount::Int64,
                                                          computeType::cublasComputeType_t,
                                                          algo::cublasGemmAlgo_t)::cublasStatus_t
end

@checked function cublasSgemmGroupedBatched(handle, transa_array, transb_array, m_array,
                                            n_array, k_array, alpha_array, Aarray,
                                            lda_array, Barray, ldb_array, beta_array,
                                            Carray, ldc_array, group_count, group_size)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemmGroupedBatched(handle::cublasHandle_t,
                                                      transa_array::Ptr{cublasOperation_t},
                                                      transb_array::Ptr{cublasOperation_t},
                                                      m_array::Ptr{Cint},
                                                      n_array::Ptr{Cint},
                                                      k_array::Ptr{Cint},
                                                      alpha_array::Ptr{Cfloat},
                                                      Aarray::CuPtr{Ptr{Cfloat}},
                                                      lda_array::Ptr{Cint},
                                                      Barray::CuPtr{Ptr{Cfloat}},
                                                      ldb_array::Ptr{Cint},
                                                      beta_array::Ptr{Cfloat},
                                                      Carray::CuPtr{Ptr{Cfloat}},
                                                      ldc_array::Ptr{Cint},
                                                      group_count::Cint,
                                                      group_size::Ptr{Cint})::cublasStatus_t
end

@checked function cublasSgemmGroupedBatched_64(handle, transa_array, transb_array, m_array,
                                               n_array, k_array, alpha_array, Aarray,
                                               lda_array, Barray, ldb_array, beta_array,
                                               Carray, ldc_array, group_count, group_size)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgemmGroupedBatched_64(handle::cublasHandle_t,
                                                         transa_array::Ptr{cublasOperation_t},
                                                         transb_array::Ptr{cublasOperation_t},
                                                         m_array::Ptr{Int64},
                                                         n_array::Ptr{Int64},
                                                         k_array::Ptr{Int64},
                                                         alpha_array::Ptr{Cfloat},
                                                         Aarray::CuPtr{Ptr{Cfloat}},
                                                         lda_array::Ptr{Int64},
                                                         Barray::CuPtr{Ptr{Cfloat}},
                                                         ldb_array::Ptr{Int64},
                                                         beta_array::Ptr{Cfloat},
                                                         Carray::CuPtr{Ptr{Cfloat}},
                                                         ldc_array::Ptr{Int64},
                                                         group_count::Int64,
                                                         group_size::Ptr{Int64})::cublasStatus_t
end

@checked function cublasDgemmGroupedBatched(handle, transa_array, transb_array, m_array,
                                            n_array, k_array, alpha_array, Aarray,
                                            lda_array, Barray, ldb_array, beta_array,
                                            Carray, ldc_array, group_count, group_size)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemmGroupedBatched(handle::cublasHandle_t,
                                                      transa_array::Ptr{cublasOperation_t},
                                                      transb_array::Ptr{cublasOperation_t},
                                                      m_array::Ptr{Cint},
                                                      n_array::Ptr{Cint},
                                                      k_array::Ptr{Cint},
                                                      alpha_array::Ptr{Cdouble},
                                                      Aarray::CuPtr{Ptr{Cdouble}},
                                                      lda_array::Ptr{Cint},
                                                      Barray::CuPtr{Ptr{Cdouble}},
                                                      ldb_array::Ptr{Cint},
                                                      beta_array::Ptr{Cdouble},
                                                      Carray::CuPtr{Ptr{Cdouble}},
                                                      ldc_array::Ptr{Cint},
                                                      group_count::Cint,
                                                      group_size::Ptr{Cint})::cublasStatus_t
end

@checked function cublasDgemmGroupedBatched_64(handle, transa_array, transb_array, m_array,
                                               n_array, k_array, alpha_array, Aarray,
                                               lda_array, Barray, ldb_array, beta_array,
                                               Carray, ldc_array, group_count, group_size)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgemmGroupedBatched_64(handle::cublasHandle_t,
                                                         transa_array::Ptr{cublasOperation_t},
                                                         transb_array::Ptr{cublasOperation_t},
                                                         m_array::Ptr{Int64},
                                                         n_array::Ptr{Int64},
                                                         k_array::Ptr{Int64},
                                                         alpha_array::Ptr{Cdouble},
                                                         Aarray::CuPtr{Ptr{Cdouble}},
                                                         lda_array::Ptr{Int64},
                                                         Barray::CuPtr{Ptr{Cdouble}},
                                                         ldb_array::Ptr{Int64},
                                                         beta_array::Ptr{Cdouble},
                                                         Carray::CuPtr{Ptr{Cdouble}},
                                                         ldc_array::Ptr{Int64},
                                                         group_count::Int64,
                                                         group_size::Ptr{Int64})::cublasStatus_t
end

@checked function cublasSgeam(handle, transa, transb, m, n, alpha, A, lda, beta, B, ldb, C,
                              ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgeam(handle::cublasHandle_t, transa::cublasOperation_t,
                                        transb::cublasOperation_t, m::Cint, n::Cint,
                                        alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                        lda::Cint, beta::RefOrCuRef{Cfloat},
                                        B::CuPtr{Cfloat}, ldb::Cint, C::CuPtr{Cfloat},
                                        ldc::Cint)::cublasStatus_t
end

@checked function cublasSgeam_64(handle, transa, transb, m, n, alpha, A, lda, beta, B, ldb,
                                 C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgeam_64(handle::cublasHandle_t,
                                           transa::cublasOperation_t,
                                           transb::cublasOperation_t, m::Int64, n::Int64,
                                           alpha::RefOrCuRef{Cfloat}, A::CuPtr{Cfloat},
                                           lda::Int64, beta::RefOrCuRef{Cfloat},
                                           B::CuPtr{Cfloat}, ldb::Int64, C::CuPtr{Cfloat},
                                           ldc::Int64)::cublasStatus_t
end

@checked function cublasDgeam(handle, transa, transb, m, n, alpha, A, lda, beta, B, ldb, C,
                              ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgeam(handle::cublasHandle_t, transa::cublasOperation_t,
                                        transb::cublasOperation_t, m::Cint, n::Cint,
                                        alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                        lda::Cint, beta::RefOrCuRef{Cdouble},
                                        B::CuPtr{Cdouble}, ldb::Cint, C::CuPtr{Cdouble},
                                        ldc::Cint)::cublasStatus_t
end

@checked function cublasDgeam_64(handle, transa, transb, m, n, alpha, A, lda, beta, B, ldb,
                                 C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgeam_64(handle::cublasHandle_t,
                                           transa::cublasOperation_t,
                                           transb::cublasOperation_t, m::Int64, n::Int64,
                                           alpha::RefOrCuRef{Cdouble}, A::CuPtr{Cdouble},
                                           lda::Int64, beta::RefOrCuRef{Cdouble},
                                           B::CuPtr{Cdouble}, ldb::Int64, C::CuPtr{Cdouble},
                                           ldc::Int64)::cublasStatus_t
end

@checked function cublasCgeam(handle, transa, transb, m, n, alpha, A, lda, beta, B, ldb, C,
                              ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgeam(handle::cublasHandle_t, transa::cublasOperation_t,
                                        transb::cublasOperation_t, m::Cint, n::Cint,
                                        alpha::RefOrCuRef{cuComplex}, A::CuPtr{cuComplex},
                                        lda::Cint, beta::RefOrCuRef{cuComplex},
                                        B::CuPtr{cuComplex}, ldb::Cint, C::CuPtr{cuComplex},
                                        ldc::Cint)::cublasStatus_t
end

@checked function cublasCgeam_64(handle, transa, transb, m, n, alpha, A, lda, beta, B, ldb,
                                 C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgeam_64(handle::cublasHandle_t,
                                           transa::cublasOperation_t,
                                           transb::cublasOperation_t, m::Int64, n::Int64,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::CuPtr{cuComplex}, lda::Int64,
                                           beta::RefOrCuRef{cuComplex}, B::CuPtr{cuComplex},
                                           ldb::Int64, C::CuPtr{cuComplex},
                                           ldc::Int64)::cublasStatus_t
end

@checked function cublasZgeam(handle, transa, transb, m, n, alpha, A, lda, beta, B, ldb, C,
                              ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgeam(handle::cublasHandle_t, transa::cublasOperation_t,
                                        transb::cublasOperation_t, m::Cint, n::Cint,
                                        alpha::RefOrCuRef{cuDoubleComplex},
                                        A::CuPtr{cuDoubleComplex}, lda::Cint,
                                        beta::RefOrCuRef{cuDoubleComplex},
                                        B::CuPtr{cuDoubleComplex}, ldb::Cint,
                                        C::CuPtr{cuDoubleComplex},
                                        ldc::Cint)::cublasStatus_t
end

@checked function cublasZgeam_64(handle, transa, transb, m, n, alpha, A, lda, beta, B, ldb,
                                 C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgeam_64(handle::cublasHandle_t,
                                           transa::cublasOperation_t,
                                           transb::cublasOperation_t, m::Int64, n::Int64,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::CuPtr{cuDoubleComplex}, lda::Int64,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           B::CuPtr{cuDoubleComplex}, ldb::Int64,
                                           C::CuPtr{cuDoubleComplex},
                                           ldc::Int64)::cublasStatus_t
end

@checked function cublasStrsmBatched(handle, side, uplo, trans, diag, m, n, alpha, A, lda,
                                     B, ldb, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrsmBatched(handle::cublasHandle_t,
                                               side::cublasSideMode_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t,
                                               diag::cublasDiagType_t, m::Cint, n::Cint,
                                               alpha::RefOrCuRef{Cfloat},
                                               A::CuPtr{Ptr{Cfloat}}, lda::Cint,
                                               B::CuPtr{Ptr{Cfloat}}, ldb::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasStrsmBatched_64(handle, side, uplo, trans, diag, m, n, alpha, A,
                                        lda, B, ldb, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrsmBatched_64(handle::cublasHandle_t,
                                                  side::cublasSideMode_t,
                                                  uplo::cublasFillMode_t,
                                                  trans::cublasOperation_t,
                                                  diag::cublasDiagType_t, m::Int64,
                                                  n::Int64, alpha::RefOrCuRef{Cfloat},
                                                  A::CuPtr{Ptr{Cfloat}}, lda::Int64,
                                                  B::CuPtr{Ptr{Cfloat}}, ldb::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasDtrsmBatched(handle, side, uplo, trans, diag, m, n, alpha, A, lda,
                                     B, ldb, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrsmBatched(handle::cublasHandle_t,
                                               side::cublasSideMode_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t,
                                               diag::cublasDiagType_t, m::Cint, n::Cint,
                                               alpha::RefOrCuRef{Cdouble},
                                               A::CuPtr{Ptr{Cdouble}}, lda::Cint,
                                               B::CuPtr{Ptr{Cdouble}}, ldb::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasDtrsmBatched_64(handle, side, uplo, trans, diag, m, n, alpha, A,
                                        lda, B, ldb, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrsmBatched_64(handle::cublasHandle_t,
                                                  side::cublasSideMode_t,
                                                  uplo::cublasFillMode_t,
                                                  trans::cublasOperation_t,
                                                  diag::cublasDiagType_t, m::Int64,
                                                  n::Int64, alpha::RefOrCuRef{Cdouble},
                                                  A::CuPtr{Ptr{Cdouble}}, lda::Int64,
                                                  B::CuPtr{Ptr{Cdouble}}, ldb::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasCtrsmBatched(handle, side, uplo, trans, diag, m, n, alpha, A, lda,
                                     B, ldb, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrsmBatched(handle::cublasHandle_t,
                                               side::cublasSideMode_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t,
                                               diag::cublasDiagType_t, m::Cint, n::Cint,
                                               alpha::RefOrCuRef{cuComplex},
                                               A::CuPtr{Ptr{cuComplex}}, lda::Cint,
                                               B::CuPtr{Ptr{cuComplex}}, ldb::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasCtrsmBatched_64(handle, side, uplo, trans, diag, m, n, alpha, A,
                                        lda, B, ldb, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrsmBatched_64(handle::cublasHandle_t,
                                                  side::cublasSideMode_t,
                                                  uplo::cublasFillMode_t,
                                                  trans::cublasOperation_t,
                                                  diag::cublasDiagType_t, m::Int64,
                                                  n::Int64, alpha::RefOrCuRef{cuComplex},
                                                  A::CuPtr{Ptr{cuComplex}}, lda::Int64,
                                                  B::CuPtr{Ptr{cuComplex}}, ldb::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasZtrsmBatched(handle, side, uplo, trans, diag, m, n, alpha, A, lda,
                                     B, ldb, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrsmBatched(handle::cublasHandle_t,
                                               side::cublasSideMode_t,
                                               uplo::cublasFillMode_t,
                                               trans::cublasOperation_t,
                                               diag::cublasDiagType_t, m::Cint, n::Cint,
                                               alpha::RefOrCuRef{cuDoubleComplex},
                                               A::CuPtr{Ptr{cuDoubleComplex}}, lda::Cint,
                                               B::CuPtr{Ptr{cuDoubleComplex}}, ldb::Cint,
                                               batchCount::Cint)::cublasStatus_t
end

@checked function cublasZtrsmBatched_64(handle, side, uplo, trans, diag, m, n, alpha, A,
                                        lda, B, ldb, batchCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrsmBatched_64(handle::cublasHandle_t,
                                                  side::cublasSideMode_t,
                                                  uplo::cublasFillMode_t,
                                                  trans::cublasOperation_t,
                                                  diag::cublasDiagType_t, m::Int64,
                                                  n::Int64,
                                                  alpha::RefOrCuRef{cuDoubleComplex},
                                                  A::CuPtr{Ptr{cuDoubleComplex}},
                                                  lda::Int64,
                                                  B::CuPtr{Ptr{cuDoubleComplex}},
                                                  ldb::Int64,
                                                  batchCount::Int64)::cublasStatus_t
end

@checked function cublasSdgmm(handle, mode, m, n, A, lda, x, incx, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSdgmm(handle::cublasHandle_t, mode::cublasSideMode_t,
                                        m::Cint, n::Cint, A::CuPtr{Cfloat}, lda::Cint,
                                        x::CuPtr{Cfloat}, incx::Cint, C::CuPtr{Cfloat},
                                        ldc::Cint)::cublasStatus_t
end

@checked function cublasSdgmm_64(handle, mode, m, n, A, lda, x, incx, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSdgmm_64(handle::cublasHandle_t, mode::cublasSideMode_t,
                                           m::Int64, n::Int64, A::CuPtr{Cfloat}, lda::Int64,
                                           x::CuPtr{Cfloat}, incx::Int64, C::CuPtr{Cfloat},
                                           ldc::Int64)::cublasStatus_t
end

@checked function cublasDdgmm(handle, mode, m, n, A, lda, x, incx, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDdgmm(handle::cublasHandle_t, mode::cublasSideMode_t,
                                        m::Cint, n::Cint, A::CuPtr{Cdouble}, lda::Cint,
                                        x::CuPtr{Cdouble}, incx::Cint, C::CuPtr{Cdouble},
                                        ldc::Cint)::cublasStatus_t
end

@checked function cublasDdgmm_64(handle, mode, m, n, A, lda, x, incx, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDdgmm_64(handle::cublasHandle_t, mode::cublasSideMode_t,
                                           m::Int64, n::Int64, A::CuPtr{Cdouble},
                                           lda::Int64, x::CuPtr{Cdouble}, incx::Int64,
                                           C::CuPtr{Cdouble}, ldc::Int64)::cublasStatus_t
end

@checked function cublasCdgmm(handle, mode, m, n, A, lda, x, incx, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCdgmm(handle::cublasHandle_t, mode::cublasSideMode_t,
                                        m::Cint, n::Cint, A::CuPtr{cuComplex}, lda::Cint,
                                        x::CuPtr{cuComplex}, incx::Cint,
                                        C::CuPtr{cuComplex}, ldc::Cint)::cublasStatus_t
end

@checked function cublasCdgmm_64(handle, mode, m, n, A, lda, x, incx, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCdgmm_64(handle::cublasHandle_t, mode::cublasSideMode_t,
                                           m::Int64, n::Int64, A::CuPtr{cuComplex},
                                           lda::Int64, x::CuPtr{cuComplex}, incx::Int64,
                                           C::CuPtr{cuComplex}, ldc::Int64)::cublasStatus_t
end

@checked function cublasZdgmm(handle, mode, m, n, A, lda, x, incx, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdgmm(handle::cublasHandle_t, mode::cublasSideMode_t,
                                        m::Cint, n::Cint, A::CuPtr{cuDoubleComplex},
                                        lda::Cint, x::CuPtr{cuDoubleComplex}, incx::Cint,
                                        C::CuPtr{cuDoubleComplex},
                                        ldc::Cint)::cublasStatus_t
end

@checked function cublasZdgmm_64(handle, mode, m, n, A, lda, x, incx, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZdgmm_64(handle::cublasHandle_t, mode::cublasSideMode_t,
                                           m::Int64, n::Int64, A::CuPtr{cuDoubleComplex},
                                           lda::Int64, x::CuPtr{cuDoubleComplex},
                                           incx::Int64, C::CuPtr{cuDoubleComplex},
                                           ldc::Int64)::cublasStatus_t
end

@checked function cublasSmatinvBatched(handle, n, A, lda, Ainv, lda_inv, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSmatinvBatched(handle::cublasHandle_t, n::Cint,
                                                 A::CuPtr{Ptr{Cfloat}}, lda::Cint,
                                                 Ainv::CuPtr{Ptr{Cfloat}}, lda_inv::Cint,
                                                 info::CuPtr{Cint},
                                                 batchSize::Cint)::cublasStatus_t
end

@checked function cublasDmatinvBatched(handle, n, A, lda, Ainv, lda_inv, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDmatinvBatched(handle::cublasHandle_t, n::Cint,
                                                 A::CuPtr{Ptr{Cdouble}}, lda::Cint,
                                                 Ainv::CuPtr{Ptr{Cdouble}}, lda_inv::Cint,
                                                 info::CuPtr{Cint},
                                                 batchSize::Cint)::cublasStatus_t
end

@checked function cublasCmatinvBatched(handle, n, A, lda, Ainv, lda_inv, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCmatinvBatched(handle::cublasHandle_t, n::Cint,
                                                 A::CuPtr{Ptr{cuComplex}}, lda::Cint,
                                                 Ainv::CuPtr{Ptr{cuComplex}}, lda_inv::Cint,
                                                 info::CuPtr{Cint},
                                                 batchSize::Cint)::cublasStatus_t
end

@checked function cublasZmatinvBatched(handle, n, A, lda, Ainv, lda_inv, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZmatinvBatched(handle::cublasHandle_t, n::Cint,
                                                 A::CuPtr{Ptr{cuDoubleComplex}}, lda::Cint,
                                                 Ainv::CuPtr{Ptr{cuDoubleComplex}},
                                                 lda_inv::Cint, info::CuPtr{Cint},
                                                 batchSize::Cint)::cublasStatus_t
end

@checked function cublasSgeqrfBatched(handle, m, n, Aarray, lda, TauArray, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgeqrfBatched(handle::cublasHandle_t, m::Cint, n::Cint,
                                                Aarray::CuPtr{Ptr{Cfloat}}, lda::Cint,
                                                TauArray::CuPtr{Ptr{Cfloat}},
                                                info::Ptr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasDgeqrfBatched(handle, m, n, Aarray, lda, TauArray, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgeqrfBatched(handle::cublasHandle_t, m::Cint, n::Cint,
                                                Aarray::CuPtr{Ptr{Cdouble}}, lda::Cint,
                                                TauArray::CuPtr{Ptr{Cdouble}},
                                                info::Ptr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasCgeqrfBatched(handle, m, n, Aarray, lda, TauArray, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgeqrfBatched(handle::cublasHandle_t, m::Cint, n::Cint,
                                                Aarray::CuPtr{Ptr{cuComplex}}, lda::Cint,
                                                TauArray::CuPtr{Ptr{cuComplex}},
                                                info::Ptr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasZgeqrfBatched(handle, m, n, Aarray, lda, TauArray, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgeqrfBatched(handle::cublasHandle_t, m::Cint, n::Cint,
                                                Aarray::CuPtr{Ptr{cuDoubleComplex}},
                                                lda::Cint,
                                                TauArray::CuPtr{Ptr{cuDoubleComplex}},
                                                info::Ptr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasSgelsBatched(handle, trans, m, n, nrhs, Aarray, lda, Carray, ldc,
                                     info, devInfoArray, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgelsBatched(handle::cublasHandle_t,
                                               trans::cublasOperation_t, m::Cint, n::Cint,
                                               nrhs::Cint, Aarray::CuPtr{Ptr{Cfloat}},
                                               lda::Cint, Carray::CuPtr{Ptr{Cfloat}},
                                               ldc::Cint, info::Ptr{Cint},
                                               devInfoArray::CuPtr{Cint},
                                               batchSize::Cint)::cublasStatus_t
end

@checked function cublasDgelsBatched(handle, trans, m, n, nrhs, Aarray, lda, Carray, ldc,
                                     info, devInfoArray, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgelsBatched(handle::cublasHandle_t,
                                               trans::cublasOperation_t, m::Cint, n::Cint,
                                               nrhs::Cint, Aarray::CuPtr{Ptr{Cdouble}},
                                               lda::Cint, Carray::CuPtr{Ptr{Cdouble}},
                                               ldc::Cint, info::Ptr{Cint},
                                               devInfoArray::CuPtr{Cint},
                                               batchSize::Cint)::cublasStatus_t
end

@checked function cublasCgelsBatched(handle, trans, m, n, nrhs, Aarray, lda, Carray, ldc,
                                     info, devInfoArray, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgelsBatched(handle::cublasHandle_t,
                                               trans::cublasOperation_t, m::Cint, n::Cint,
                                               nrhs::Cint, Aarray::CuPtr{Ptr{cuComplex}},
                                               lda::Cint, Carray::CuPtr{Ptr{cuComplex}},
                                               ldc::Cint, info::Ptr{Cint},
                                               devInfoArray::CuPtr{Cint},
                                               batchSize::Cint)::cublasStatus_t
end

@checked function cublasZgelsBatched(handle, trans, m, n, nrhs, Aarray, lda, Carray, ldc,
                                     info, devInfoArray, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgelsBatched(handle::cublasHandle_t,
                                               trans::cublasOperation_t, m::Cint, n::Cint,
                                               nrhs::Cint,
                                               Aarray::CuPtr{Ptr{cuDoubleComplex}},
                                               lda::Cint,
                                               Carray::CuPtr{Ptr{cuDoubleComplex}},
                                               ldc::Cint, info::Ptr{Cint},
                                               devInfoArray::CuPtr{Cint},
                                               batchSize::Cint)::cublasStatus_t
end

@checked function cublasStpttr(handle, uplo, n, AP, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStpttr(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         n::Cint, AP::CuPtr{Cfloat}, A::CuPtr{Cfloat},
                                         lda::Cint)::cublasStatus_t
end

@checked function cublasDtpttr(handle, uplo, n, AP, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtpttr(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         n::Cint, AP::CuPtr{Cdouble}, A::CuPtr{Cdouble},
                                         lda::Cint)::cublasStatus_t
end

@checked function cublasCtpttr(handle, uplo, n, AP, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtpttr(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         n::Cint, AP::CuPtr{cuComplex}, A::CuPtr{cuComplex},
                                         lda::Cint)::cublasStatus_t
end

@checked function cublasZtpttr(handle, uplo, n, AP, A, lda)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtpttr(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         n::Cint, AP::CuPtr{cuDoubleComplex},
                                         A::CuPtr{cuDoubleComplex},
                                         lda::Cint)::cublasStatus_t
end

@checked function cublasStrttp(handle, uplo, n, A, lda, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasStrttp(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         n::Cint, A::CuPtr{Cfloat}, lda::Cint,
                                         AP::CuPtr{Cfloat})::cublasStatus_t
end

@checked function cublasDtrttp(handle, uplo, n, A, lda, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDtrttp(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         n::Cint, A::CuPtr{Cdouble}, lda::Cint,
                                         AP::CuPtr{Cdouble})::cublasStatus_t
end

@checked function cublasCtrttp(handle, uplo, n, A, lda, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCtrttp(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         n::Cint, A::CuPtr{cuComplex}, lda::Cint,
                                         AP::CuPtr{cuComplex})::cublasStatus_t
end

@checked function cublasZtrttp(handle, uplo, n, A, lda, AP)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZtrttp(handle::cublasHandle_t, uplo::cublasFillMode_t,
                                         n::Cint, A::CuPtr{cuDoubleComplex}, lda::Cint,
                                         AP::CuPtr{cuDoubleComplex})::cublasStatus_t
end

@checked function cublasSgetrfBatched(handle, n, A, lda, P, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgetrfBatched(handle::cublasHandle_t, n::Cint,
                                                A::CuPtr{Ptr{Cfloat}}, lda::Cint,
                                                P::CuPtr{Cint}, info::CuPtr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasDgetrfBatched(handle, n, A, lda, P, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgetrfBatched(handle::cublasHandle_t, n::Cint,
                                                A::CuPtr{Ptr{Cdouble}}, lda::Cint,
                                                P::CuPtr{Cint}, info::CuPtr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasCgetrfBatched(handle, n, A, lda, P, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgetrfBatched(handle::cublasHandle_t, n::Cint,
                                                A::CuPtr{Ptr{cuComplex}}, lda::Cint,
                                                P::CuPtr{Cint}, info::CuPtr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasZgetrfBatched(handle, n, A, lda, P, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgetrfBatched(handle::cublasHandle_t, n::Cint,
                                                A::CuPtr{Ptr{cuDoubleComplex}}, lda::Cint,
                                                P::CuPtr{Cint}, info::CuPtr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasSgetriBatched(handle, n, A, lda, P, C, ldc, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgetriBatched(handle::cublasHandle_t, n::Cint,
                                                A::CuPtr{Ptr{Cfloat}}, lda::Cint,
                                                P::CuPtr{Cint}, C::CuPtr{Ptr{Cfloat}},
                                                ldc::Cint, info::CuPtr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasDgetriBatched(handle, n, A, lda, P, C, ldc, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgetriBatched(handle::cublasHandle_t, n::Cint,
                                                A::CuPtr{Ptr{Cdouble}}, lda::Cint,
                                                P::CuPtr{Cint}, C::CuPtr{Ptr{Cdouble}},
                                                ldc::Cint, info::CuPtr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasCgetriBatched(handle, n, A, lda, P, C, ldc, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgetriBatched(handle::cublasHandle_t, n::Cint,
                                                A::CuPtr{Ptr{cuComplex}}, lda::Cint,
                                                P::CuPtr{Cint}, C::CuPtr{Ptr{cuComplex}},
                                                ldc::Cint, info::CuPtr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasZgetriBatched(handle, n, A, lda, P, C, ldc, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgetriBatched(handle::cublasHandle_t, n::Cint,
                                                A::CuPtr{Ptr{cuDoubleComplex}}, lda::Cint,
                                                P::CuPtr{Cint},
                                                C::CuPtr{Ptr{cuDoubleComplex}}, ldc::Cint,
                                                info::CuPtr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasSgetrsBatched(handle, trans, n, nrhs, Aarray, lda, devIpiv, Barray,
                                      ldb, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasSgetrsBatched(handle::cublasHandle_t,
                                                trans::cublasOperation_t, n::Cint,
                                                nrhs::Cint, Aarray::CuPtr{Ptr{Cfloat}},
                                                lda::Cint, devIpiv::CuPtr{Cint},
                                                Barray::CuPtr{Ptr{Cfloat}}, ldb::Cint,
                                                info::Ptr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasDgetrsBatched(handle, trans, n, nrhs, Aarray, lda, devIpiv, Barray,
                                      ldb, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasDgetrsBatched(handle::cublasHandle_t,
                                                trans::cublasOperation_t, n::Cint,
                                                nrhs::Cint, Aarray::CuPtr{Ptr{Cdouble}},
                                                lda::Cint, devIpiv::CuPtr{Cint},
                                                Barray::CuPtr{Ptr{Cdouble}}, ldb::Cint,
                                                info::Ptr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasCgetrsBatched(handle, trans, n, nrhs, Aarray, lda, devIpiv, Barray,
                                      ldb, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasCgetrsBatched(handle::cublasHandle_t,
                                                trans::cublasOperation_t, n::Cint,
                                                nrhs::Cint, Aarray::CuPtr{Ptr{cuComplex}},
                                                lda::Cint, devIpiv::CuPtr{Cint},
                                                Barray::CuPtr{Ptr{cuComplex}}, ldb::Cint,
                                                info::Ptr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasZgetrsBatched(handle, trans, n, nrhs, Aarray, lda, devIpiv, Barray,
                                      ldb, info, batchSize)
    initialize_context()
    @gcsafe_ccall libcublas.cublasZgetrsBatched(handle::cublasHandle_t,
                                                trans::cublasOperation_t, n::Cint,
                                                nrhs::Cint,
                                                Aarray::CuPtr{Ptr{cuDoubleComplex}},
                                                lda::Cint, devIpiv::CuPtr{Cint},
                                                Barray::CuPtr{Ptr{cuDoubleComplex}},
                                                ldb::Cint, info::Ptr{Cint},
                                                batchSize::Cint)::cublasStatus_t
end

@checked function cublasUint8gemmBias(handle, transa, transb, transc, m, n, k, A, A_bias,
                                      lda, B, B_bias, ldb, C, C_bias, ldc, C_mult, C_shift)
    initialize_context()
    @gcsafe_ccall libcublas.cublasUint8gemmBias(handle::cublasHandle_t,
                                                transa::cublasOperation_t,
                                                transb::cublasOperation_t,
                                                transc::cublasOperation_t, m::Cint, n::Cint,
                                                k::Cint, A::CuPtr{Cuchar}, A_bias::Cint,
                                                lda::Cint, B::CuPtr{Cuchar}, B_bias::Cint,
                                                ldb::Cint, C::CuPtr{Cuchar}, C_bias::Cint,
                                                ldc::Cint, C_mult::Cint,
                                                C_shift::Cint)::cublasStatus_t
end

mutable struct cublasXtContext end

const cublasXtHandle_t = Ptr{cublasXtContext}

@checked function cublasXtCreate(handle)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCreate(handle::Ptr{cublasXtHandle_t})::cublasStatus_t
end

@checked function cublasXtDestroy(handle)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDestroy(handle::cublasXtHandle_t)::cublasStatus_t
end

@checked function cublasXtGetNumBoards(nbDevices, deviceId, nbBoards)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtGetNumBoards(nbDevices::Cint, deviceId::Ptr{Cint},
                                                 nbBoards::Ptr{Cint})::cublasStatus_t
end

@checked function cublasXtMaxBoards(nbGpuBoards)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtMaxBoards(nbGpuBoards::Ptr{Cint})::cublasStatus_t
end

@checked function cublasXtDeviceSelect(handle, nbDevices, deviceId)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDeviceSelect(handle::cublasXtHandle_t, nbDevices::Cint,
                                                 deviceId::Ptr{Cint})::cublasStatus_t
end

@checked function cublasXtSetBlockDim(handle, blockDim)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSetBlockDim(handle::cublasXtHandle_t,
                                                blockDim::Cint)::cublasStatus_t
end

@checked function cublasXtGetBlockDim(handle, blockDim)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtGetBlockDim(handle::cublasXtHandle_t,
                                                blockDim::Ptr{Cint})::cublasStatus_t
end

@cenum cublasXtPinnedMemMode_t::UInt32 begin
    CUBLASXT_PINNING_DISABLED = 0
    CUBLASXT_PINNING_ENABLED = 1
end

@checked function cublasXtGetPinningMemMode(handle, mode)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtGetPinningMemMode(handle::cublasXtHandle_t,
                                                      mode::Ptr{cublasXtPinnedMemMode_t})::cublasStatus_t
end

@checked function cublasXtSetPinningMemMode(handle, mode)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSetPinningMemMode(handle::cublasXtHandle_t,
                                                      mode::cublasXtPinnedMemMode_t)::cublasStatus_t
end

@cenum cublasXtOpType_t::UInt32 begin
    CUBLASXT_FLOAT = 0
    CUBLASXT_DOUBLE = 1
    CUBLASXT_COMPLEX = 2
    CUBLASXT_DOUBLECOMPLEX = 3
end

@cenum cublasXtBlasOp_t::UInt32 begin
    CUBLASXT_GEMM = 0
    CUBLASXT_SYRK = 1
    CUBLASXT_HERK = 2
    CUBLASXT_SYMM = 3
    CUBLASXT_HEMM = 4
    CUBLASXT_TRSM = 5
    CUBLASXT_SYR2K = 6
    CUBLASXT_HER2K = 7
    CUBLASXT_SPMM = 8
    CUBLASXT_SYRKX = 9
    CUBLASXT_HERKX = 10
    CUBLASXT_TRMM = 11
    CUBLASXT_ROUTINE_MAX = 12
end

@checked function cublasXtSetCpuRoutine(handle, blasOp, type, blasFunctor)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSetCpuRoutine(handle::cublasXtHandle_t,
                                                  blasOp::cublasXtBlasOp_t,
                                                  type::cublasXtOpType_t,
                                                  blasFunctor::Ptr{Cvoid})::cublasStatus_t
end

@checked function cublasXtSetCpuRatio(handle, blasOp, type, ratio)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSetCpuRatio(handle::cublasXtHandle_t,
                                                blasOp::cublasXtBlasOp_t,
                                                type::cublasXtOpType_t,
                                                ratio::Cfloat)::cublasStatus_t
end

@checked function cublasXtSgemm(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSgemm(handle::cublasXtHandle_t,
                                          transa::cublasOperation_t,
                                          transb::cublasOperation_t, m::Csize_t, n::Csize_t,
                                          k::Csize_t, alpha::RefOrCuRef{Cfloat},
                                          A::PtrOrCuPtr{Cfloat}, lda::Csize_t,
                                          B::PtrOrCuPtr{Cfloat}, ldb::Csize_t,
                                          beta::RefOrCuRef{Cfloat}, C::PtrOrCuPtr{Cfloat},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtDgemm(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDgemm(handle::cublasXtHandle_t,
                                          transa::cublasOperation_t,
                                          transb::cublasOperation_t, m::Csize_t, n::Csize_t,
                                          k::Csize_t, alpha::RefOrCuRef{Cdouble},
                                          A::PtrOrCuPtr{Cdouble}, lda::Csize_t,
                                          B::PtrOrCuPtr{Cdouble}, ldb::Csize_t,
                                          beta::RefOrCuRef{Cdouble}, C::PtrOrCuPtr{Cdouble},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCgemm(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCgemm(handle::cublasXtHandle_t,
                                          transa::cublasOperation_t,
                                          transb::cublasOperation_t, m::Csize_t, n::Csize_t,
                                          k::Csize_t, alpha::RefOrCuRef{cuComplex},
                                          A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuComplex}, ldb::Csize_t,
                                          beta::RefOrCuRef{cuComplex},
                                          C::PtrOrCuPtr{cuComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZgemm(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb,
                                beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZgemm(handle::cublasXtHandle_t,
                                          transa::cublasOperation_t,
                                          transb::cublasOperation_t, m::Csize_t, n::Csize_t,
                                          k::Csize_t, alpha::RefOrCuRef{cuDoubleComplex},
                                          A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuDoubleComplex}, ldb::Csize_t,
                                          beta::RefOrCuRef{cuDoubleComplex},
                                          C::PtrOrCuPtr{cuDoubleComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtSsyrk(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSsyrk(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                          trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                          alpha::RefOrCuRef{Cfloat}, A::PtrOrCuPtr{Cfloat},
                                          lda::Csize_t, beta::RefOrCuRef{Cfloat},
                                          C::PtrOrCuPtr{Cfloat},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtDsyrk(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDsyrk(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                          trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                          alpha::RefOrCuRef{Cdouble},
                                          A::PtrOrCuPtr{Cdouble}, lda::Csize_t,
                                          beta::RefOrCuRef{Cdouble}, C::PtrOrCuPtr{Cdouble},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCsyrk(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCsyrk(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                          trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                          alpha::RefOrCuRef{cuComplex},
                                          A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                          beta::RefOrCuRef{cuComplex},
                                          C::PtrOrCuPtr{cuComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZsyrk(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZsyrk(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                          trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                          alpha::RefOrCuRef{cuDoubleComplex},
                                          A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                          beta::RefOrCuRef{cuDoubleComplex},
                                          C::PtrOrCuPtr{cuDoubleComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCherk(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCherk(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                          trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                          alpha::RefOrCuRef{Cfloat},
                                          A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                          beta::RefOrCuRef{Cfloat},
                                          C::PtrOrCuPtr{cuComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZherk(handle, uplo, trans, n, k, alpha, A, lda, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZherk(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                          trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                          alpha::RefOrCuRef{Cdouble},
                                          A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                          beta::RefOrCuRef{Cdouble},
                                          C::PtrOrCuPtr{cuDoubleComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtSsyr2k(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSsyr2k(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{Cfloat}, A::PtrOrCuPtr{Cfloat},
                                           lda::Csize_t, B::PtrOrCuPtr{Cfloat},
                                           ldb::Csize_t, beta::RefOrCuRef{Cfloat},
                                           C::PtrOrCuPtr{Cfloat},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtDsyr2k(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDsyr2k(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{Cdouble},
                                           A::PtrOrCuPtr{Cdouble}, lda::Csize_t,
                                           B::PtrOrCuPtr{Cdouble}, ldb::Csize_t,
                                           beta::RefOrCuRef{Cdouble},
                                           C::PtrOrCuPtr{Cdouble},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCsyr2k(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCsyr2k(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                           B::PtrOrCuPtr{cuComplex}, ldb::Csize_t,
                                           beta::RefOrCuRef{cuComplex},
                                           C::PtrOrCuPtr{cuComplex},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZsyr2k(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZsyr2k(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                           B::PtrOrCuPtr{cuDoubleComplex}, ldb::Csize_t,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           C::PtrOrCuPtr{cuDoubleComplex},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCherkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCherkx(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                           B::PtrOrCuPtr{cuComplex}, ldb::Csize_t,
                                           beta::RefOrCuRef{Cfloat},
                                           C::PtrOrCuPtr{cuComplex},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZherkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZherkx(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                           B::PtrOrCuPtr{cuDoubleComplex}, ldb::Csize_t,
                                           beta::RefOrCuRef{Cdouble},
                                           C::PtrOrCuPtr{cuDoubleComplex},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtStrsm(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtStrsm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, trans::cublasOperation_t,
                                          diag::cublasDiagType_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{Cfloat}, A::PtrOrCuPtr{Cfloat},
                                          lda::Csize_t, B::PtrOrCuPtr{Cfloat},
                                          ldb::Csize_t)::cublasStatus_t
end

@checked function cublasXtDtrsm(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDtrsm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, trans::cublasOperation_t,
                                          diag::cublasDiagType_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{Cdouble},
                                          A::PtrOrCuPtr{Cdouble}, lda::Csize_t,
                                          B::PtrOrCuPtr{Cdouble},
                                          ldb::Csize_t)::cublasStatus_t
end

@checked function cublasXtCtrsm(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCtrsm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, trans::cublasOperation_t,
                                          diag::cublasDiagType_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{cuComplex},
                                          A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuComplex},
                                          ldb::Csize_t)::cublasStatus_t
end

@checked function cublasXtZtrsm(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                ldb)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZtrsm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, trans::cublasOperation_t,
                                          diag::cublasDiagType_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{cuDoubleComplex},
                                          A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuDoubleComplex},
                                          ldb::Csize_t)::cublasStatus_t
end

@checked function cublasXtSsymm(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSsymm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{Cfloat}, A::PtrOrCuPtr{Cfloat},
                                          lda::Csize_t, B::PtrOrCuPtr{Cfloat}, ldb::Csize_t,
                                          beta::RefOrCuRef{Cfloat}, C::PtrOrCuPtr{Cfloat},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtDsymm(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDsymm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{Cdouble},
                                          A::PtrOrCuPtr{Cdouble}, lda::Csize_t,
                                          B::PtrOrCuPtr{Cdouble}, ldb::Csize_t,
                                          beta::RefOrCuRef{Cdouble}, C::PtrOrCuPtr{Cdouble},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCsymm(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCsymm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{cuComplex},
                                          A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuComplex}, ldb::Csize_t,
                                          beta::RefOrCuRef{cuComplex},
                                          C::PtrOrCuPtr{cuComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZsymm(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZsymm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{cuDoubleComplex},
                                          A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuDoubleComplex}, ldb::Csize_t,
                                          beta::RefOrCuRef{cuDoubleComplex},
                                          C::PtrOrCuPtr{cuDoubleComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtChemm(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtChemm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{cuComplex},
                                          A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuComplex}, ldb::Csize_t,
                                          beta::RefOrCuRef{cuComplex},
                                          C::PtrOrCuPtr{cuComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZhemm(handle, side, uplo, m, n, alpha, A, lda, B, ldb, beta, C,
                                ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZhemm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{cuDoubleComplex},
                                          A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuDoubleComplex}, ldb::Csize_t,
                                          beta::RefOrCuRef{cuDoubleComplex},
                                          C::PtrOrCuPtr{cuDoubleComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtSsyrkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSsyrkx(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{Cfloat}, A::PtrOrCuPtr{Cfloat},
                                           lda::Csize_t, B::PtrOrCuPtr{Cfloat},
                                           ldb::Csize_t, beta::RefOrCuRef{Cfloat},
                                           C::PtrOrCuPtr{Cfloat},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtDsyrkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDsyrkx(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{Cdouble},
                                           A::PtrOrCuPtr{Cdouble}, lda::Csize_t,
                                           B::PtrOrCuPtr{Cdouble}, ldb::Csize_t,
                                           beta::RefOrCuRef{Cdouble},
                                           C::PtrOrCuPtr{Cdouble},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCsyrkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCsyrkx(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                           B::PtrOrCuPtr{cuComplex}, ldb::Csize_t,
                                           beta::RefOrCuRef{cuComplex},
                                           C::PtrOrCuPtr{cuComplex},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZsyrkx(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZsyrkx(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                           B::PtrOrCuPtr{cuDoubleComplex}, ldb::Csize_t,
                                           beta::RefOrCuRef{cuDoubleComplex},
                                           C::PtrOrCuPtr{cuDoubleComplex},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCher2k(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCher2k(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{cuComplex},
                                           A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                           B::PtrOrCuPtr{cuComplex}, ldb::Csize_t,
                                           beta::RefOrCuRef{Cfloat},
                                           C::PtrOrCuPtr{cuComplex},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZher2k(handle, uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C,
                                 ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZher2k(handle::cublasXtHandle_t, uplo::cublasFillMode_t,
                                           trans::cublasOperation_t, n::Csize_t, k::Csize_t,
                                           alpha::RefOrCuRef{cuDoubleComplex},
                                           A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                           B::PtrOrCuPtr{cuDoubleComplex}, ldb::Csize_t,
                                           beta::RefOrCuRef{Cdouble},
                                           C::PtrOrCuPtr{cuDoubleComplex},
                                           ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtSspmm(handle, side, uplo, m, n, alpha, AP, B, ldb, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtSspmm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::Ref{Cfloat}, AP::Ptr{Cfloat},
                                          B::PtrOrCuPtr{Cfloat}, ldb::Csize_t,
                                          beta::Ref{Cfloat}, C::PtrOrCuPtr{Cfloat},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtDspmm(handle, side, uplo, m, n, alpha, AP, B, ldb, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDspmm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::Ref{Cdouble}, AP::Ptr{Cdouble},
                                          B::PtrOrCuPtr{Cdouble}, ldb::Csize_t,
                                          beta::Ref{Cdouble}, C::PtrOrCuPtr{Cdouble},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCspmm(handle, side, uplo, m, n, alpha, AP, B, ldb, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCspmm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::Ref{cuComplex}, AP::Ptr{cuComplex},
                                          B::PtrOrCuPtr{cuComplex}, ldb::Csize_t,
                                          beta::Ref{cuComplex}, C::PtrOrCuPtr{cuComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZspmm(handle, side, uplo, m, n, alpha, AP, B, ldb, beta, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZspmm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, m::Csize_t, n::Csize_t,
                                          alpha::Ref{cuDoubleComplex},
                                          AP::Ptr{cuDoubleComplex},
                                          B::PtrOrCuPtr{cuDoubleComplex}, ldb::Csize_t,
                                          beta::Ref{cuDoubleComplex},
                                          C::PtrOrCuPtr{cuDoubleComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtStrmm(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtStrmm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, trans::cublasOperation_t,
                                          diag::cublasDiagType_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{Cfloat}, A::PtrOrCuPtr{Cfloat},
                                          lda::Csize_t, B::PtrOrCuPtr{Cfloat}, ldb::Csize_t,
                                          C::PtrOrCuPtr{Cfloat},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtDtrmm(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtDtrmm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, trans::cublasOperation_t,
                                          diag::cublasDiagType_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{Cdouble},
                                          A::PtrOrCuPtr{Cdouble}, lda::Csize_t,
                                          B::PtrOrCuPtr{Cdouble}, ldb::Csize_t,
                                          C::PtrOrCuPtr{Cdouble},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtCtrmm(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtCtrmm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, trans::cublasOperation_t,
                                          diag::cublasDiagType_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{cuComplex},
                                          A::PtrOrCuPtr{cuComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuComplex}, ldb::Csize_t,
                                          C::PtrOrCuPtr{cuComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

@checked function cublasXtZtrmm(handle, side, uplo, trans, diag, m, n, alpha, A, lda, B,
                                ldb, C, ldc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasXtZtrmm(handle::cublasXtHandle_t, side::cublasSideMode_t,
                                          uplo::cublasFillMode_t, trans::cublasOperation_t,
                                          diag::cublasDiagType_t, m::Csize_t, n::Csize_t,
                                          alpha::RefOrCuRef{cuDoubleComplex},
                                          A::PtrOrCuPtr{cuDoubleComplex}, lda::Csize_t,
                                          B::PtrOrCuPtr{cuDoubleComplex}, ldb::Csize_t,
                                          C::PtrOrCuPtr{cuDoubleComplex},
                                          ldc::Csize_t)::cublasStatus_t
end

mutable struct cublasLtContext end

const cublasLtHandle_t = Ptr{cublasLtContext}

@checked function cublasLtCreate(lightHandle)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtCreate(lightHandle::Ptr{cublasLtHandle_t})::cublasStatus_t
end

@checked function cublasLtDestroy(lightHandle)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtDestroy(lightHandle::cublasLtHandle_t)::cublasStatus_t
end

function cublasLtGetStatusName(status)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtGetStatusName(status::cublasStatus_t)::Cstring
end

function cublasLtGetStatusString(status)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtGetStatusString(status::cublasStatus_t)::Cstring
end

function cublasLtGetVersion()
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtGetVersion()::Csize_t
end

function cublasLtGetCudartVersion()
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtGetCudartVersion()::Csize_t
end

@checked function cublasLtGetProperty(type, value)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtGetProperty(type::libraryPropertyType,
                                                value::Ptr{Cint})::cublasStatus_t
end

@checked function cublasLtHeuristicsCacheGetCapacity(capacity)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtHeuristicsCacheGetCapacity(capacity::Ptr{Csize_t})::cublasStatus_t
end

@checked function cublasLtHeuristicsCacheSetCapacity(capacity)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtHeuristicsCacheSetCapacity(capacity::Csize_t)::cublasStatus_t
end

function cublasLtDisableCpuInstructionsSetMask(mask)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtDisableCpuInstructionsSetMask(mask::Cuint)::Cuint
end

struct cublasLtMatrixLayoutOpaque_t
    data::NTuple{8,UInt64}
end

const cublasLtMatrixLayout_t = Ptr{cublasLtMatrixLayoutOpaque_t}

struct cublasLtMatmulAlgo_t
    data::NTuple{8,UInt64}
end

struct cublasLtMatmulDescOpaque_t
    data::NTuple{32,UInt64}
end

const cublasLtMatmulDesc_t = Ptr{cublasLtMatmulDescOpaque_t}

struct cublasLtMatrixTransformDescOpaque_t
    data::NTuple{8,UInt64}
end

const cublasLtMatrixTransformDesc_t = Ptr{cublasLtMatrixTransformDescOpaque_t}

struct cublasLtMatmulPreferenceOpaque_t
    data::NTuple{8,UInt64}
end

const cublasLtMatmulPreference_t = Ptr{cublasLtMatmulPreferenceOpaque_t}

@cenum cublasLtMatmulTile_t::UInt32 begin
    CUBLASLT_MATMUL_TILE_UNDEFINED = 0
    CUBLASLT_MATMUL_TILE_8x8 = 1
    CUBLASLT_MATMUL_TILE_8x16 = 2
    CUBLASLT_MATMUL_TILE_16x8 = 3
    CUBLASLT_MATMUL_TILE_8x32 = 4
    CUBLASLT_MATMUL_TILE_16x16 = 5
    CUBLASLT_MATMUL_TILE_32x8 = 6
    CUBLASLT_MATMUL_TILE_8x64 = 7
    CUBLASLT_MATMUL_TILE_16x32 = 8
    CUBLASLT_MATMUL_TILE_32x16 = 9
    CUBLASLT_MATMUL_TILE_64x8 = 10
    CUBLASLT_MATMUL_TILE_32x32 = 11
    CUBLASLT_MATMUL_TILE_32x64 = 12
    CUBLASLT_MATMUL_TILE_64x32 = 13
    CUBLASLT_MATMUL_TILE_32x128 = 14
    CUBLASLT_MATMUL_TILE_64x64 = 15
    CUBLASLT_MATMUL_TILE_128x32 = 16
    CUBLASLT_MATMUL_TILE_64x128 = 17
    CUBLASLT_MATMUL_TILE_128x64 = 18
    CUBLASLT_MATMUL_TILE_64x256 = 19
    CUBLASLT_MATMUL_TILE_128x128 = 20
    CUBLASLT_MATMUL_TILE_256x64 = 21
    CUBLASLT_MATMUL_TILE_64x512 = 22
    CUBLASLT_MATMUL_TILE_128x256 = 23
    CUBLASLT_MATMUL_TILE_256x128 = 24
    CUBLASLT_MATMUL_TILE_512x64 = 25
    CUBLASLT_MATMUL_TILE_64x96 = 26
    CUBLASLT_MATMUL_TILE_96x64 = 27
    CUBLASLT_MATMUL_TILE_96x128 = 28
    CUBLASLT_MATMUL_TILE_128x160 = 29
    CUBLASLT_MATMUL_TILE_160x128 = 30
    CUBLASLT_MATMUL_TILE_192x128 = 31
    CUBLASLT_MATMUL_TILE_128x192 = 32
    CUBLASLT_MATMUL_TILE_128x96 = 33
    CUBLASLT_MATMUL_TILE_32x256 = 34
    CUBLASLT_MATMUL_TILE_256x32 = 35
    CUBLASLT_MATMUL_TILE_END = 36
end

@cenum cublasLtMatmulStages_t::UInt32 begin
    CUBLASLT_MATMUL_STAGES_UNDEFINED = 0
    CUBLASLT_MATMUL_STAGES_16x1 = 1
    CUBLASLT_MATMUL_STAGES_16x2 = 2
    CUBLASLT_MATMUL_STAGES_16x3 = 3
    CUBLASLT_MATMUL_STAGES_16x4 = 4
    CUBLASLT_MATMUL_STAGES_16x5 = 5
    CUBLASLT_MATMUL_STAGES_16x6 = 6
    CUBLASLT_MATMUL_STAGES_32x1 = 7
    CUBLASLT_MATMUL_STAGES_32x2 = 8
    CUBLASLT_MATMUL_STAGES_32x3 = 9
    CUBLASLT_MATMUL_STAGES_32x4 = 10
    CUBLASLT_MATMUL_STAGES_32x5 = 11
    CUBLASLT_MATMUL_STAGES_32x6 = 12
    CUBLASLT_MATMUL_STAGES_64x1 = 13
    CUBLASLT_MATMUL_STAGES_64x2 = 14
    CUBLASLT_MATMUL_STAGES_64x3 = 15
    CUBLASLT_MATMUL_STAGES_64x4 = 16
    CUBLASLT_MATMUL_STAGES_64x5 = 17
    CUBLASLT_MATMUL_STAGES_64x6 = 18
    CUBLASLT_MATMUL_STAGES_128x1 = 19
    CUBLASLT_MATMUL_STAGES_128x2 = 20
    CUBLASLT_MATMUL_STAGES_128x3 = 21
    CUBLASLT_MATMUL_STAGES_128x4 = 22
    CUBLASLT_MATMUL_STAGES_128x5 = 23
    CUBLASLT_MATMUL_STAGES_128x6 = 24
    CUBLASLT_MATMUL_STAGES_32x10 = 25
    CUBLASLT_MATMUL_STAGES_8x4 = 26
    CUBLASLT_MATMUL_STAGES_16x10 = 27
    CUBLASLT_MATMUL_STAGES_8x5 = 28
    CUBLASLT_MATMUL_STAGES_8x3 = 31
    CUBLASLT_MATMUL_STAGES_8xAUTO = 32
    CUBLASLT_MATMUL_STAGES_16xAUTO = 33
    CUBLASLT_MATMUL_STAGES_32xAUTO = 34
    CUBLASLT_MATMUL_STAGES_64xAUTO = 35
    CUBLASLT_MATMUL_STAGES_128xAUTO = 36
    CUBLASLT_MATMUL_STAGES_END = 37
end

@cenum cublasLtClusterShape_t::UInt32 begin
    CUBLASLT_CLUSTER_SHAPE_AUTO = 0
    CUBLASLT_CLUSTER_SHAPE_1x1x1 = 2
    CUBLASLT_CLUSTER_SHAPE_2x1x1 = 3
    CUBLASLT_CLUSTER_SHAPE_4x1x1 = 4
    CUBLASLT_CLUSTER_SHAPE_1x2x1 = 5
    CUBLASLT_CLUSTER_SHAPE_2x2x1 = 6
    CUBLASLT_CLUSTER_SHAPE_4x2x1 = 7
    CUBLASLT_CLUSTER_SHAPE_1x4x1 = 8
    CUBLASLT_CLUSTER_SHAPE_2x4x1 = 9
    CUBLASLT_CLUSTER_SHAPE_4x4x1 = 10
    CUBLASLT_CLUSTER_SHAPE_8x1x1 = 11
    CUBLASLT_CLUSTER_SHAPE_1x8x1 = 12
    CUBLASLT_CLUSTER_SHAPE_8x2x1 = 13
    CUBLASLT_CLUSTER_SHAPE_2x8x1 = 14
    CUBLASLT_CLUSTER_SHAPE_16x1x1 = 15
    CUBLASLT_CLUSTER_SHAPE_1x16x1 = 16
    CUBLASLT_CLUSTER_SHAPE_3x1x1 = 17
    CUBLASLT_CLUSTER_SHAPE_5x1x1 = 18
    CUBLASLT_CLUSTER_SHAPE_6x1x1 = 19
    CUBLASLT_CLUSTER_SHAPE_7x1x1 = 20
    CUBLASLT_CLUSTER_SHAPE_9x1x1 = 21
    CUBLASLT_CLUSTER_SHAPE_10x1x1 = 22
    CUBLASLT_CLUSTER_SHAPE_11x1x1 = 23
    CUBLASLT_CLUSTER_SHAPE_12x1x1 = 24
    CUBLASLT_CLUSTER_SHAPE_13x1x1 = 25
    CUBLASLT_CLUSTER_SHAPE_14x1x1 = 26
    CUBLASLT_CLUSTER_SHAPE_15x1x1 = 27
    CUBLASLT_CLUSTER_SHAPE_3x2x1 = 28
    CUBLASLT_CLUSTER_SHAPE_5x2x1 = 29
    CUBLASLT_CLUSTER_SHAPE_6x2x1 = 30
    CUBLASLT_CLUSTER_SHAPE_7x2x1 = 31
    CUBLASLT_CLUSTER_SHAPE_1x3x1 = 32
    CUBLASLT_CLUSTER_SHAPE_2x3x1 = 33
    CUBLASLT_CLUSTER_SHAPE_3x3x1 = 34
    CUBLASLT_CLUSTER_SHAPE_4x3x1 = 35
    CUBLASLT_CLUSTER_SHAPE_5x3x1 = 36
    CUBLASLT_CLUSTER_SHAPE_3x4x1 = 37
    CUBLASLT_CLUSTER_SHAPE_1x5x1 = 38
    CUBLASLT_CLUSTER_SHAPE_2x5x1 = 39
    CUBLASLT_CLUSTER_SHAPE_3x5x1 = 40
    CUBLASLT_CLUSTER_SHAPE_1x6x1 = 41
    CUBLASLT_CLUSTER_SHAPE_2x6x1 = 42
    CUBLASLT_CLUSTER_SHAPE_1x7x1 = 43
    CUBLASLT_CLUSTER_SHAPE_2x7x1 = 44
    CUBLASLT_CLUSTER_SHAPE_1x9x1 = 45
    CUBLASLT_CLUSTER_SHAPE_1x10x1 = 46
    CUBLASLT_CLUSTER_SHAPE_1x11x1 = 47
    CUBLASLT_CLUSTER_SHAPE_1x12x1 = 48
    CUBLASLT_CLUSTER_SHAPE_1x13x1 = 49
    CUBLASLT_CLUSTER_SHAPE_1x14x1 = 50
    CUBLASLT_CLUSTER_SHAPE_1x15x1 = 51
    CUBLASLT_CLUSTER_SHAPE_END = 52
end

@cenum cublasLtMatmulInnerShape_t::UInt32 begin
    CUBLASLT_MATMUL_INNER_SHAPE_UNDEFINED = 0
    CUBLASLT_MATMUL_INNER_SHAPE_MMA884 = 1
    CUBLASLT_MATMUL_INNER_SHAPE_MMA1684 = 2
    CUBLASLT_MATMUL_INNER_SHAPE_MMA1688 = 3
    CUBLASLT_MATMUL_INNER_SHAPE_MMA16816 = 4
    CUBLASLT_MATMUL_INNER_SHAPE_END = 5
end

@cenum cublasLtPointerMode_t::UInt32 begin
    CUBLASLT_POINTER_MODE_HOST = 0
    CUBLASLT_POINTER_MODE_DEVICE = 1
    CUBLASLT_POINTER_MODE_DEVICE_VECTOR = 2
    CUBLASLT_POINTER_MODE_ALPHA_DEVICE_VECTOR_BETA_ZERO = 3
    CUBLASLT_POINTER_MODE_ALPHA_DEVICE_VECTOR_BETA_HOST = 4
end

@cenum cublasLtPointerModeMask_t::UInt32 begin
    CUBLASLT_POINTER_MODE_MASK_HOST = 1
    CUBLASLT_POINTER_MODE_MASK_DEVICE = 2
    CUBLASLT_POINTER_MODE_MASK_DEVICE_VECTOR = 4
    CUBLASLT_POINTER_MODE_MASK_ALPHA_DEVICE_VECTOR_BETA_ZERO = 8
    CUBLASLT_POINTER_MODE_MASK_ALPHA_DEVICE_VECTOR_BETA_HOST = 16
end

const cublasLtNumericalImplFlags_t = UInt64

@checked function cublasLtMatmul(lightHandle, computeDesc, alpha, A, Adesc, B, Bdesc, beta,
                                 C, Cdesc, D, Ddesc, algo, workspace, workspaceSizeInBytes,
                                 stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmul(lightHandle::cublasLtHandle_t,
                                           computeDesc::cublasLtMatmulDesc_t,
                                           alpha::PtrOrCuPtr{Cvoid}, A::CuPtr{Cvoid},
                                           Adesc::cublasLtMatrixLayout_t, B::CuPtr{Cvoid},
                                           Bdesc::cublasLtMatrixLayout_t,
                                           beta::PtrOrCuPtr{Cvoid}, C::CuPtr{Cvoid},
                                           Cdesc::cublasLtMatrixLayout_t, D::CuPtr{Cvoid},
                                           Ddesc::cublasLtMatrixLayout_t,
                                           algo::Ptr{cublasLtMatmulAlgo_t},
                                           workspace::CuPtr{Cvoid},
                                           workspaceSizeInBytes::Csize_t,
                                           stream::cudaStream_t)::cublasStatus_t
end

@checked function cublasLtMatrixTransform(lightHandle, transformDesc, alpha, A, Adesc, beta,
                                          B, Bdesc, C, Cdesc, stream)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixTransform(lightHandle::cublasLtHandle_t,
                                                    transformDesc::cublasLtMatrixTransformDesc_t,
                                                    alpha::PtrOrCuPtr{Cvoid},
                                                    A::CuPtr{Cvoid},
                                                    Adesc::cublasLtMatrixLayout_t,
                                                    beta::PtrOrCuPtr{Cvoid},
                                                    B::CuPtr{Cvoid},
                                                    Bdesc::cublasLtMatrixLayout_t,
                                                    C::CuPtr{Cvoid},
                                                    Cdesc::cublasLtMatrixLayout_t,
                                                    stream::cudaStream_t)::cublasStatus_t
end

@cenum cublasLtOrder_t::UInt32 begin
    CUBLASLT_ORDER_COL = 0
    CUBLASLT_ORDER_ROW = 1
    CUBLASLT_ORDER_COL32 = 2
    CUBLASLT_ORDER_COL4_4R2_8C = 3
    CUBLASLT_ORDER_COL32_2R_4R4 = 4
end

@cenum cublasLtMatrixLayoutAttribute_t::UInt32 begin
    CUBLASLT_MATRIX_LAYOUT_TYPE = 0
    CUBLASLT_MATRIX_LAYOUT_ORDER = 1
    CUBLASLT_MATRIX_LAYOUT_ROWS = 2
    CUBLASLT_MATRIX_LAYOUT_COLS = 3
    CUBLASLT_MATRIX_LAYOUT_LD = 4
    CUBLASLT_MATRIX_LAYOUT_BATCH_COUNT = 5
    CUBLASLT_MATRIX_LAYOUT_STRIDED_BATCH_OFFSET = 6
    CUBLASLT_MATRIX_LAYOUT_PLANE_OFFSET = 7
end

@checked function cublasLtMatrixLayoutInit_internal(matLayout, size, type, rows, cols, ld)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixLayoutInit_internal(matLayout::cublasLtMatrixLayout_t,
                                                              size::Csize_t,
                                                              type::cudaDataType,
                                                              rows::UInt64, cols::UInt64,
                                                              ld::Int64)::cublasStatus_t
end

@checked function cublasLtMatrixLayoutInit(matLayout, type, rows, cols, ld)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixLayoutInit(matLayout::cublasLtMatrixLayout_t,
                                                     type::cudaDataType, rows::UInt64,
                                                     cols::UInt64,
                                                     ld::Int64)::cublasStatus_t
end

@checked function cublasLtMatrixLayoutCreate(matLayout, type, rows, cols, ld)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixLayoutCreate(matLayout::Ptr{cublasLtMatrixLayout_t},
                                                       type::cudaDataType, rows::UInt64,
                                                       cols::UInt64,
                                                       ld::Int64)::cublasStatus_t
end

@checked function cublasLtMatrixLayoutDestroy(matLayout)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixLayoutDestroy(matLayout::cublasLtMatrixLayout_t)::cublasStatus_t
end

@checked function cublasLtMatrixLayoutSetAttribute(matLayout, attr, buf, sizeInBytes)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixLayoutSetAttribute(matLayout::cublasLtMatrixLayout_t,
                                                             attr::cublasLtMatrixLayoutAttribute_t,
                                                             buf::Ptr{Cvoid},
                                                             sizeInBytes::Csize_t)::cublasStatus_t
end

@checked function cublasLtMatrixLayoutGetAttribute(matLayout, attr, buf, sizeInBytes,
                                                   sizeWritten)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixLayoutGetAttribute(matLayout::cublasLtMatrixLayout_t,
                                                             attr::cublasLtMatrixLayoutAttribute_t,
                                                             buf::Ptr{Cvoid},
                                                             sizeInBytes::Csize_t,
                                                             sizeWritten::Ptr{Csize_t})::cublasStatus_t
end

@cenum cublasLtMatmulDescAttributes_t::UInt32 begin
    CUBLASLT_MATMUL_DESC_COMPUTE_TYPE = 0
    CUBLASLT_MATMUL_DESC_SCALE_TYPE = 1
    CUBLASLT_MATMUL_DESC_POINTER_MODE = 2
    CUBLASLT_MATMUL_DESC_TRANSA = 3
    CUBLASLT_MATMUL_DESC_TRANSB = 4
    CUBLASLT_MATMUL_DESC_TRANSC = 5
    CUBLASLT_MATMUL_DESC_FILL_MODE = 6
    CUBLASLT_MATMUL_DESC_EPILOGUE = 7
    CUBLASLT_MATMUL_DESC_BIAS_POINTER = 8
    CUBLASLT_MATMUL_DESC_BIAS_BATCH_STRIDE = 10
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_POINTER = 11
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_LD = 12
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_BATCH_STRIDE = 13
    CUBLASLT_MATMUL_DESC_ALPHA_VECTOR_BATCH_STRIDE = 14
    CUBLASLT_MATMUL_DESC_SM_COUNT_TARGET = 15
    CUBLASLT_MATMUL_DESC_A_SCALE_POINTER = 17
    CUBLASLT_MATMUL_DESC_B_SCALE_POINTER = 18
    CUBLASLT_MATMUL_DESC_C_SCALE_POINTER = 19
    CUBLASLT_MATMUL_DESC_D_SCALE_POINTER = 20
    CUBLASLT_MATMUL_DESC_AMAX_D_POINTER = 21
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_DATA_TYPE = 22
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_SCALE_POINTER = 23
    CUBLASLT_MATMUL_DESC_EPILOGUE_AUX_AMAX_POINTER = 24
    CUBLASLT_MATMUL_DESC_FAST_ACCUM = 25
    CUBLASLT_MATMUL_DESC_BIAS_DATA_TYPE = 26
    CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_NUM_CHUNKS_D_ROWS = 27
    CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_NUM_CHUNKS_D_COLS = 28
    CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_IN_COUNTERS_POINTER = 29
    CUBLASLT_MATMUL_DESC_ATOMIC_SYNC_OUT_COUNTERS_POINTER = 30
end

@checked function cublasLtMatmulDescInit_internal(matmulDesc, size, computeType, scaleType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulDescInit_internal(matmulDesc::cublasLtMatmulDesc_t,
                                                            size::Csize_t,
                                                            computeType::cublasComputeType_t,
                                                            scaleType::cudaDataType_t)::cublasStatus_t
end

@checked function cublasLtMatmulDescInit(matmulDesc, computeType, scaleType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulDescInit(matmulDesc::cublasLtMatmulDesc_t,
                                                   computeType::cublasComputeType_t,
                                                   scaleType::cudaDataType_t)::cublasStatus_t
end

@checked function cublasLtMatmulDescCreate(matmulDesc, computeType, scaleType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulDescCreate(matmulDesc::Ptr{cublasLtMatmulDesc_t},
                                                     computeType::cublasComputeType_t,
                                                     scaleType::cudaDataType_t)::cublasStatus_t
end

@checked function cublasLtMatmulDescDestroy(matmulDesc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulDescDestroy(matmulDesc::cublasLtMatmulDesc_t)::cublasStatus_t
end

@checked function cublasLtMatmulDescSetAttribute(matmulDesc, attr, buf, sizeInBytes)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulDescSetAttribute(matmulDesc::cublasLtMatmulDesc_t,
                                                           attr::cublasLtMatmulDescAttributes_t,
                                                           buf::PtrOrCuPtr{Cvoid},
                                                           sizeInBytes::Csize_t)::cublasStatus_t
end

@checked function cublasLtMatmulDescGetAttribute(matmulDesc, attr, buf, sizeInBytes,
                                                 sizeWritten)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulDescGetAttribute(matmulDesc::cublasLtMatmulDesc_t,
                                                           attr::cublasLtMatmulDescAttributes_t,
                                                           buf::Ptr{Cvoid},
                                                           sizeInBytes::Csize_t,
                                                           sizeWritten::Ptr{Csize_t})::cublasStatus_t
end

@cenum cublasLtMatrixTransformDescAttributes_t::UInt32 begin
    CUBLASLT_MATRIX_TRANSFORM_DESC_SCALE_TYPE = 0
    CUBLASLT_MATRIX_TRANSFORM_DESC_POINTER_MODE = 1
    CUBLASLT_MATRIX_TRANSFORM_DESC_TRANSA = 2
    CUBLASLT_MATRIX_TRANSFORM_DESC_TRANSB = 3
end

@checked function cublasLtMatrixTransformDescInit_internal(transformDesc, size, scaleType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixTransformDescInit_internal(transformDesc::cublasLtMatrixTransformDesc_t,
                                                                     size::Csize_t,
                                                                     scaleType::cudaDataType)::cublasStatus_t
end

@checked function cublasLtMatrixTransformDescInit(transformDesc, scaleType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixTransformDescInit(transformDesc::cublasLtMatrixTransformDesc_t,
                                                            scaleType::cudaDataType)::cublasStatus_t
end

@checked function cublasLtMatrixTransformDescCreate(transformDesc, scaleType)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixTransformDescCreate(transformDesc::Ptr{cublasLtMatrixTransformDesc_t},
                                                              scaleType::cudaDataType)::cublasStatus_t
end

@checked function cublasLtMatrixTransformDescDestroy(transformDesc)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixTransformDescDestroy(transformDesc::cublasLtMatrixTransformDesc_t)::cublasStatus_t
end

@checked function cublasLtMatrixTransformDescSetAttribute(transformDesc, attr, buf,
                                                          sizeInBytes)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixTransformDescSetAttribute(transformDesc::cublasLtMatrixTransformDesc_t,
                                                                    attr::cublasLtMatrixTransformDescAttributes_t,
                                                                    buf::Ptr{Cvoid},
                                                                    sizeInBytes::Csize_t)::cublasStatus_t
end

@checked function cublasLtMatrixTransformDescGetAttribute(transformDesc, attr, buf,
                                                          sizeInBytes, sizeWritten)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatrixTransformDescGetAttribute(transformDesc::cublasLtMatrixTransformDesc_t,
                                                                    attr::cublasLtMatrixTransformDescAttributes_t,
                                                                    buf::Ptr{Cvoid},
                                                                    sizeInBytes::Csize_t,
                                                                    sizeWritten::Ptr{Csize_t})::cublasStatus_t
end

@cenum cublasLtReductionScheme_t::UInt32 begin
    CUBLASLT_REDUCTION_SCHEME_NONE = 0
    CUBLASLT_REDUCTION_SCHEME_INPLACE = 1
    CUBLASLT_REDUCTION_SCHEME_COMPUTE_TYPE = 2
    CUBLASLT_REDUCTION_SCHEME_OUTPUT_TYPE = 4
    CUBLASLT_REDUCTION_SCHEME_MASK = 7
end

@cenum cublasLtEpilogue_t::UInt32 begin
    CUBLASLT_EPILOGUE_DEFAULT = 1
    CUBLASLT_EPILOGUE_RELU = 2
    CUBLASLT_EPILOGUE_RELU_AUX = 130
    CUBLASLT_EPILOGUE_BIAS = 4
    CUBLASLT_EPILOGUE_RELU_BIAS = 6
    CUBLASLT_EPILOGUE_RELU_AUX_BIAS = 134
    CUBLASLT_EPILOGUE_DRELU = 136
    CUBLASLT_EPILOGUE_DRELU_BGRAD = 152
    CUBLASLT_EPILOGUE_GELU = 32
    CUBLASLT_EPILOGUE_GELU_AUX = 160
    CUBLASLT_EPILOGUE_GELU_BIAS = 36
    CUBLASLT_EPILOGUE_GELU_AUX_BIAS = 164
    CUBLASLT_EPILOGUE_DGELU = 192
    CUBLASLT_EPILOGUE_DGELU_BGRAD = 208
    CUBLASLT_EPILOGUE_BGRADA = 256
    CUBLASLT_EPILOGUE_BGRADB = 512
end

@cenum cublasLtMatmulSearch_t::UInt32 begin
    CUBLASLT_SEARCH_BEST_FIT = 0
    CUBLASLT_SEARCH_LIMITED_BY_ALGO_ID = 1
    CUBLASLT_SEARCH_RESERVED_02 = 2
    CUBLASLT_SEARCH_RESERVED_03 = 3
    CUBLASLT_SEARCH_RESERVED_04 = 4
    CUBLASLT_SEARCH_RESERVED_05 = 5
end

@cenum cublasLtMatmulPreferenceAttributes_t::UInt32 begin
    CUBLASLT_MATMUL_PREF_SEARCH_MODE = 0
    CUBLASLT_MATMUL_PREF_MAX_WORKSPACE_BYTES = 1
    CUBLASLT_MATMUL_PREF_REDUCTION_SCHEME_MASK = 3
    CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_A_BYTES = 5
    CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_B_BYTES = 6
    CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_C_BYTES = 7
    CUBLASLT_MATMUL_PREF_MIN_ALIGNMENT_D_BYTES = 8
    CUBLASLT_MATMUL_PREF_MAX_WAVES_COUNT = 9
    CUBLASLT_MATMUL_PREF_IMPL_MASK = 12
end

@checked function cublasLtMatmulPreferenceInit_internal(pref, size)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulPreferenceInit_internal(pref::cublasLtMatmulPreference_t,
                                                                  size::Csize_t)::cublasStatus_t
end

@checked function cublasLtMatmulPreferenceInit(pref)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulPreferenceInit(pref::cublasLtMatmulPreference_t)::cublasStatus_t
end

@checked function cublasLtMatmulPreferenceCreate(pref)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulPreferenceCreate(pref::Ptr{cublasLtMatmulPreference_t})::cublasStatus_t
end

@checked function cublasLtMatmulPreferenceDestroy(pref)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulPreferenceDestroy(pref::cublasLtMatmulPreference_t)::cublasStatus_t
end

@checked function cublasLtMatmulPreferenceSetAttribute(pref, attr, buf, sizeInBytes)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulPreferenceSetAttribute(pref::cublasLtMatmulPreference_t,
                                                                 attr::cublasLtMatmulPreferenceAttributes_t,
                                                                 buf::Ptr{Cvoid},
                                                                 sizeInBytes::Csize_t)::cublasStatus_t
end

@checked function cublasLtMatmulPreferenceGetAttribute(pref, attr, buf, sizeInBytes,
                                                       sizeWritten)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulPreferenceGetAttribute(pref::cublasLtMatmulPreference_t,
                                                                 attr::cublasLtMatmulPreferenceAttributes_t,
                                                                 buf::Ptr{Cvoid},
                                                                 sizeInBytes::Csize_t,
                                                                 sizeWritten::Ptr{Csize_t})::cublasStatus_t
end

struct cublasLtMatmulHeuristicResult_t
    algo::cublasLtMatmulAlgo_t
    workspaceSize::Csize_t
    state::cublasStatus_t
    wavesCount::Cfloat
    reserved::NTuple{4,Cint}
end

@checked function cublasLtMatmulAlgoGetHeuristic(lightHandle, operationDesc, Adesc, Bdesc,
                                                 Cdesc, Ddesc, preference,
                                                 requestedAlgoCount, heuristicResultsArray,
                                                 returnAlgoCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulAlgoGetHeuristic(lightHandle::cublasLtHandle_t,
                                                           operationDesc::cublasLtMatmulDesc_t,
                                                           Adesc::cublasLtMatrixLayout_t,
                                                           Bdesc::cublasLtMatrixLayout_t,
                                                           Cdesc::cublasLtMatrixLayout_t,
                                                           Ddesc::cublasLtMatrixLayout_t,
                                                           preference::cublasLtMatmulPreference_t,
                                                           requestedAlgoCount::Cint,
                                                           heuristicResultsArray::Ptr{cublasLtMatmulHeuristicResult_t},
                                                           returnAlgoCount::Ptr{Cint})::cublasStatus_t
end

@checked function cublasLtMatmulAlgoGetIds(lightHandle, computeType, scaleType, Atype,
                                           Btype, Ctype, Dtype, requestedAlgoCount,
                                           algoIdsArray, returnAlgoCount)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulAlgoGetIds(lightHandle::cublasLtHandle_t,
                                                     computeType::cublasComputeType_t,
                                                     scaleType::cudaDataType_t,
                                                     Atype::cudaDataType_t,
                                                     Btype::cudaDataType_t,
                                                     Ctype::cudaDataType_t,
                                                     Dtype::cudaDataType_t,
                                                     requestedAlgoCount::Cint,
                                                     algoIdsArray::Ptr{Cint},
                                                     returnAlgoCount::Ptr{Cint})::cublasStatus_t
end

@checked function cublasLtMatmulAlgoInit(lightHandle, computeType, scaleType, Atype, Btype,
                                         Ctype, Dtype, algoId, algo)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulAlgoInit(lightHandle::cublasLtHandle_t,
                                                   computeType::cublasComputeType_t,
                                                   scaleType::cudaDataType_t,
                                                   Atype::cudaDataType_t,
                                                   Btype::cudaDataType_t,
                                                   Ctype::cudaDataType_t,
                                                   Dtype::cudaDataType_t, algoId::Cint,
                                                   algo::Ptr{cublasLtMatmulAlgo_t})::cublasStatus_t
end

@checked function cublasLtMatmulAlgoCheck(lightHandle, operationDesc, Adesc, Bdesc, Cdesc,
                                          Ddesc, algo, result)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulAlgoCheck(lightHandle::cublasLtHandle_t,
                                                    operationDesc::cublasLtMatmulDesc_t,
                                                    Adesc::cublasLtMatrixLayout_t,
                                                    Bdesc::cublasLtMatrixLayout_t,
                                                    Cdesc::cublasLtMatrixLayout_t,
                                                    Ddesc::cublasLtMatrixLayout_t,
                                                    algo::Ptr{cublasLtMatmulAlgo_t},
                                                    result::Ptr{cublasLtMatmulHeuristicResult_t})::cublasStatus_t
end

@cenum cublasLtMatmulAlgoCapAttributes_t::UInt32 begin
    CUBLASLT_ALGO_CAP_SPLITK_SUPPORT = 0
    CUBLASLT_ALGO_CAP_REDUCTION_SCHEME_MASK = 1
    CUBLASLT_ALGO_CAP_CTA_SWIZZLING_SUPPORT = 2
    CUBLASLT_ALGO_CAP_STRIDED_BATCH_SUPPORT = 3
    CUBLASLT_ALGO_CAP_OUT_OF_PLACE_RESULT_SUPPORT = 4
    CUBLASLT_ALGO_CAP_UPLO_SUPPORT = 5
    CUBLASLT_ALGO_CAP_TILE_IDS = 6
    CUBLASLT_ALGO_CAP_CUSTOM_OPTION_MAX = 7
    CUBLASLT_ALGO_CAP_CUSTOM_MEMORY_ORDER = 10
    CUBLASLT_ALGO_CAP_POINTER_MODE_MASK = 11
    CUBLASLT_ALGO_CAP_EPILOGUE_MASK = 12
    CUBLASLT_ALGO_CAP_STAGES_IDS = 13
    CUBLASLT_ALGO_CAP_LD_NEGATIVE = 14
    CUBLASLT_ALGO_CAP_NUMERICAL_IMPL_FLAGS = 15
    CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_A_BYTES = 16
    CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_B_BYTES = 17
    CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_C_BYTES = 18
    CUBLASLT_ALGO_CAP_MIN_ALIGNMENT_D_BYTES = 19
    CUBLASLT_ALGO_CAP_ATOMIC_SYNC = 20
end

@checked function cublasLtMatmulAlgoCapGetAttribute(algo, attr, buf, sizeInBytes,
                                                    sizeWritten)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulAlgoCapGetAttribute(algo::Ptr{cublasLtMatmulAlgo_t},
                                                              attr::cublasLtMatmulAlgoCapAttributes_t,
                                                              buf::Ptr{Cvoid},
                                                              sizeInBytes::Csize_t,
                                                              sizeWritten::Ptr{Csize_t})::cublasStatus_t
end

@cenum cublasLtMatmulAlgoConfigAttributes_t::UInt32 begin
    CUBLASLT_ALGO_CONFIG_ID = 0
    CUBLASLT_ALGO_CONFIG_TILE_ID = 1
    CUBLASLT_ALGO_CONFIG_SPLITK_NUM = 2
    CUBLASLT_ALGO_CONFIG_REDUCTION_SCHEME = 3
    CUBLASLT_ALGO_CONFIG_CTA_SWIZZLING = 4
    CUBLASLT_ALGO_CONFIG_CUSTOM_OPTION = 5
    CUBLASLT_ALGO_CONFIG_STAGES_ID = 6
    CUBLASLT_ALGO_CONFIG_INNER_SHAPE_ID = 7
    CUBLASLT_ALGO_CONFIG_CLUSTER_SHAPE_ID = 8
end

@checked function cublasLtMatmulAlgoConfigSetAttribute(algo, attr, buf, sizeInBytes)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulAlgoConfigSetAttribute(algo::Ptr{cublasLtMatmulAlgo_t},
                                                                 attr::cublasLtMatmulAlgoConfigAttributes_t,
                                                                 buf::Ptr{Cvoid},
                                                                 sizeInBytes::Csize_t)::cublasStatus_t
end

@checked function cublasLtMatmulAlgoConfigGetAttribute(algo, attr, buf, sizeInBytes,
                                                       sizeWritten)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtMatmulAlgoConfigGetAttribute(algo::Ptr{cublasLtMatmulAlgo_t},
                                                                 attr::cublasLtMatmulAlgoConfigAttributes_t,
                                                                 buf::Ptr{Cvoid},
                                                                 sizeInBytes::Csize_t,
                                                                 sizeWritten::Ptr{Csize_t})::cublasStatus_t
end

# typedef void ( * cublasLtLoggerCallback_t ) ( int logLevel , const char * functionName , const char * message )
const cublasLtLoggerCallback_t = Ptr{Cvoid}

@checked function cublasLtLoggerSetCallback(callback)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtLoggerSetCallback(callback::cublasLtLoggerCallback_t)::cublasStatus_t
end

@checked function cublasLtLoggerSetFile(file)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtLoggerSetFile(file::Ptr{Libc.FILE})::cublasStatus_t
end

@checked function cublasLtLoggerOpenFile(logFile)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtLoggerOpenFile(logFile::Cstring)::cublasStatus_t
end

@checked function cublasLtLoggerSetLevel(level)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtLoggerSetLevel(level::Cint)::cublasStatus_t
end

@checked function cublasLtLoggerSetMask(mask)
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtLoggerSetMask(mask::Cint)::cublasStatus_t
end

# no prototype is found for this function at cublasLt.h:1841:29, please use with caution
@checked function cublasLtLoggerForceDisable()
    initialize_context()
    @gcsafe_ccall libcublas.cublasLtLoggerForceDisable()::cublasStatus_t
end

const CUBLASLT_NUMERICAL_IMPL_FLAGS_FMA = Culonglong(0x01) << 0

const CUBLASLT_NUMERICAL_IMPL_FLAGS_HMMA = Culonglong(0x02) << 0

const CUBLASLT_NUMERICAL_IMPL_FLAGS_IMMA = Culonglong(0x04) << 0

const CUBLASLT_NUMERICAL_IMPL_FLAGS_DMMA = Culonglong(0x08) << 0

const CUBLASLT_NUMERICAL_IMPL_FLAGS_TENSOR_OP_MASK = Culonglong(0xfe) << 0

const CUBLASLT_NUMERICAL_IMPL_FLAGS_OP_TYPE_MASK = Culonglong(0xff) << 0

const CUBLASLT_NUMERICAL_IMPL_FLAGS_ACCUMULATOR_16F = Culonglong(0x01) << 8

const CUBLASLT_NUMERICAL_IMPL_FLAGS_ACCUMULATOR_32F = Culonglong(0x02) << 8

const CUBLASLT_NUMERICAL_IMPL_FLAGS_ACCUMULATOR_64F = Culonglong(0x04) << 8

const CUBLASLT_NUMERICAL_IMPL_FLAGS_ACCUMULATOR_32I = Culonglong(0x08) << 8

const CUBLASLT_NUMERICAL_IMPL_FLAGS_ACCUMULATOR_TYPE_MASK = Culonglong(0xff) << 8

const CUBLASLT_NUMERICAL_IMPL_FLAGS_INPUT_16F = Culonglong(0x01) << 16

const CUBLASLT_NUMERICAL_IMPL_FLAGS_INPUT_16BF = Culonglong(0x02) << 16

const CUBLASLT_NUMERICAL_IMPL_FLAGS_INPUT_TF32 = Culonglong(0x04) << 16

const CUBLASLT_NUMERICAL_IMPL_FLAGS_INPUT_32F = Culonglong(0x08) << 16

const CUBLASLT_NUMERICAL_IMPL_FLAGS_INPUT_64F = Culonglong(0x10) << 16

const CUBLASLT_NUMERICAL_IMPL_FLAGS_INPUT_8I = Culonglong(0x20) << 16

const CUBLASLT_NUMERICAL_IMPL_FLAGS_INPUT_8F_E4M3 = Culonglong(0x40) << 16

const CUBLASLT_NUMERICAL_IMPL_FLAGS_INPUT_8F_E5M2 = Culonglong(0x80) << 16

const CUBLASLT_NUMERICAL_IMPL_FLAGS_OP_INPUT_TYPE_MASK = Culonglong(0xff) << 16

const CUBLASLT_NUMERICAL_IMPL_FLAGS_GAUSSIAN = Culonglong(0x01) << 32

# Float16 functionality is only enabled when using C++ (defining __cplusplus breaks things)

@checked function cublasHSHgemvBatched(handle, trans, m, n, alpha, Aarray, lda, xarray,
                                       incx, beta, yarray, incy, batchCount)
    initialize_context()
    @ccall libcublas.cublasHSHgemvBatched(handle::cublasHandle_t, trans::cublasOperation_t,
                                          m::Cint, n::Cint, alpha::RefOrCuRef{Cfloat},
                                          Aarray::CuPtr{Ptr{Float16}}, lda::Cint,
                                          xarray::CuPtr{Ptr{Float16}}, incx::Cint,
                                          beta::RefOrCuRef{Cfloat},
                                          yarray::CuPtr{Ptr{Float16}},
                                          incy::Cint, batchCount::Cint)::cublasStatus_t
end

@checked function cublasHSSgemvBatched(handle, trans, m, n, alpha, Aarray, lda, xarray,
                                       incx, beta, yarray, incy, batchCount)
    initialize_context()
    @ccall libcublas.cublasHSSgemvBatched(handle::cublasHandle_t, trans::cublasOperation_t,
                                          m::Cint, n::Cint, alpha::RefOrCuRef{Cfloat},
                                          Aarray::CuPtr{Ptr{Float16}}, lda::Cint,
                                          xarray::CuPtr{Ptr{Float16}}, incx::Cint,
                                          beta::RefOrCuRef{Cfloat},
                                          yarray::CuPtr{Ptr{Cfloat}},
                                          incy::Cint, batchCount::Cint)::cublasStatus_t
end

@checked function cublasTSTgemvBatched(handle, trans, m, n, alpha, Aarray, lda, xarray,
                                       incx, beta, yarray, incy, batchCount)
    initialize_context()
    @ccall libcublas.cublasTSTgemvBatched(handle::cublasHandle_t, trans::cublasOperation_t,
                                          m::Cint, n::Cint, alpha::Ptr{Cfloat},
                                          Aarray::Ptr{Ptr{BFloat16}}, lda::Cint,
                                          xarray::Ptr{Ptr{BFloat16}}, incx::Cint,
                                          beta::Ptr{Cfloat}, yarray::Ptr{Ptr{BFloat16}},
                                          incy::Cint, batchCount::Cint)::cublasStatus_t
end

@checked function cublasTSSgemvBatched(handle, trans, m, n, alpha, Aarray, lda, xarray,
                                       incx, beta, yarray, incy, batchCount)
    initialize_context()
    @ccall libcublas.cublasTSSgemvBatched(handle::cublasHandle_t, trans::cublasOperation_t,
                                          m::Cint, n::Cint, alpha::Ptr{Cfloat},
                                          Aarray::Ptr{Ptr{BFloat16}}, lda::Cint,
                                          xarray::Ptr{Ptr{BFloat16}}, incx::Cint,
                                          beta::Ptr{Cfloat}, yarray::Ptr{Ptr{Cfloat}},
                                          incy::Cint, batchCount::Cint)::cublasStatus_t
end

@checked function cublasHSHgemvStridedBatched(handle, trans, m, n, alpha, A, lda, strideA,
                                              x, incx, stridex, beta, y, incy, stridey,
                                              batchCount)
    initialize_context()
    @ccall libcublas.cublasHSHgemvStridedBatched(handle::cublasHandle_t,
                                                 trans::cublasOperation_t, m::Cint, n::Cint,
                                                 alpha::RefOrCuRef{Cfloat},
                                                 A::CuPtr{Float16},
                                                 lda::Cint, strideA::Clonglong,
                                                 x::CuPtr{Float16}, incx::Cint,
                                                 stridex::Clonglong,
                                                 beta::RefOrCuRef{Cfloat},
                                                 y::CuPtr{Float16}, incy::Cint,
                                                 stridey::Clonglong,
                                                 batchCount::Cint)::cublasStatus_t
end

@checked function cublasHSSgemvStridedBatched(handle, trans, m, n, alpha, A, lda, strideA,
                                              x, incx, stridex, beta, y, incy, stridey,
                                              batchCount)
    initialize_context()
    @ccall libcublas.cublasHSSgemvStridedBatched(handle::cublasHandle_t,
                                                 trans::cublasOperation_t, m::Cint, n::Cint,
                                                 alpha::RefOrCuRef{Cfloat},
                                                 A::CuPtr{Float16},
                                                 lda::Cint, strideA::Clonglong,
                                                 x::CuPtr{Float16}, incx::Cint,
                                                 stridex::Clonglong,
                                                 beta::RefOrCuRef{Cfloat},
                                                 y::CuPtr{Cfloat}, incy::Cint,
                                                 stridey::Clonglong,
                                                 batchCount::Cint)::cublasStatus_t
end

@checked function cublasTSTgemvStridedBatched(handle, trans, m, n, alpha, A, lda, strideA,
                                              x, incx, stridex, beta, y, incy, stridey,
                                              batchCount)
    initialize_context()
    @ccall libcublas.cublasTSTgemvStridedBatched(handle::cublasHandle_t,
                                                 trans::cublasOperation_t, m::Cint, n::Cint,
                                                 alpha::RefOrCuRef{Cfloat},
                                                 A::CuPtr{BFloat16},
                                                 lda::Cint, strideA::Clonglong,
                                                 x::CuPtr{BFloat16}, incx::Cint,
                                                 stridex::Clonglong,
                                                 beta::RefOrCuRef{Cfloat},
                                                 y::CuPtr{BFloat16}, incy::Cint,
                                                 stridey::Clonglong,
                                                 batchCount::Cint)::cublasStatus_t
end

@checked function cublasTSSgemvStridedBatched(handle, trans, m, n, alpha, A, lda, strideA,
                                              x, incx, stridex, beta, y, incy, stridey,
                                              batchCount)
    initialize_context()
    @ccall libcublas.cublasTSSgemvStridedBatched(handle::cublasHandle_t,
                                                 trans::cublasOperation_t, m::Cint, n::Cint,
                                                 alpha::RefOrCuRef{Cfloat},
                                                 A::CuPtr{BFloat16},
                                                 lda::Cint, strideA::Clonglong,
                                                 x::CuPtr{BFloat16}, incx::Cint,
                                                 stridex::Clonglong,
                                                 beta::RefOrCuRef{Cfloat},
                                                 y::CuPtr{Cfloat}, incy::Cint,
                                                 stridey::Clonglong,
                                                 batchCount::Cint)::cublasStatus_t
end

@checked function cublasHgemm(handle, transa, transb, m, n, k, alpha, A, lda, B, ldb, beta,
                              C, ldc)
    initialize_context()
    @ccall libcublas.cublasHgemm(handle::cublasHandle_t, transa::cublasOperation_t,
                                 transb::cublasOperation_t, m::Cint, n::Cint, k::Cint,
                                 alpha::Ptr{Float16}, A::Ptr{Float16}, lda::Cint,
                                 B::Ptr{Float16}, ldb::Cint, beta::Ptr{Float16},
                                 C::Ptr{Float16}, ldc::Cint)::cublasStatus_t
end

@checked function cublasHgemmBatched(handle, transa, transb, m, n, k, alpha, Aarray, lda,
                                     Barray, ldb, beta, Carray, ldc, batchCount)
    initialize_context()
    @ccall libcublas.cublasHgemmBatched(handle::cublasHandle_t, transa::cublasOperation_t,
                                        transb::cublasOperation_t, m::Cint, n::Cint,
                                        k::Cint, alpha::RefOrCuRef{Float16},
                                        Aarray::CuPtr{Ptr{Float16}}, lda::Cint,
                                        Barray::CuPtr{Ptr{Float16}}, ldb::Cint,
                                        beta::RefOrCuRef{Float16},
                                        Carray::CuPtr{Ptr{Float16}}, ldc::Cint,
                                        batchCount::Cint)::cublasStatus_t
end

@checked function cublasHgemmStridedBatched(handle, transa, transb, m, n, k, alpha, A, lda,
                                            strideA, B, ldb, strideB, beta, C, ldc, strideC,
                                            batchCount)
    initialize_context()
    @ccall libcublas.cublasHgemmStridedBatched(handle::cublasHandle_t,
                                               transa::cublasOperation_t,
                                               transb::cublasOperation_t, m::Cint, n::Cint,
                                               k::Cint, alpha::RefOrCuRef{Float16},
                                               A::CuPtr{Float16}, lda::Cint,
                                               strideA::Clonglong, B::CuPtr{Float16},
                                               ldb::Cint, strideB::Clonglong,
                                               beta::RefOrCuRef{Float16}, C::CuPtr{Float16},
                                               ldc::Cint, strideC::Clonglong,
                                               batchCount::Cint)::cublasStatus_t
end
